#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define MP make_pair
#define all(x) (x).begin(), (x).end()

const int N = 1e6 + 3e2;

void solve(int test) {
    int n;
    cin >> n;

    ll sum = 0;
    map<ll, int> a, b;
    for (int i = 1; i <= n; i++){
        int x;
        cin >> x;
        a[x]++;
        sum += x;
    }

    b[sum] = 1;

    if (n == 1){
        cout << "YES\n";
        return;
    }

    multiset<ll> ms;
    ms.insert(sum);

    for (int it = 1; it < n; it++){
        if (ms.empty()) break;

        ll val = *ms.rbegin();
        ms.erase(ms.find(val));

        b[val]--;

//        cout << val << ' ';

        ll x = val / 2, y = (val + 1) / 2;
        b[x]++;
        b[y]++;

        if (b[x] > a[x]) ms.insert(x);
        if (b[y] > a[y]) ms.insert(y);

    }

    map<ll, int> aa, bb;
    for (auto now : b){
        if (now.second) bb.insert(now);
    }

    for (auto now : a){
        if (now.second) aa.insert(now);
    }

    cout << (aa == bb ? "YES\n" : "NO\n");

    for (auto now : bb){
//        cout << now.first << ' ' << now.second << endl;
    }

}

int main() {
    ios_base::sync_with_stdio(false);

#ifdef dddxxz
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tests = 1;
    cin >> tests;

    for (int test = 1; test <= tests; test++) {
        solve(test);
    }

    return 0;
}
