#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long

int n;
int cnt_v = 0;
multiset<int> s;

bool dfs(int v) {
    if (v == 1 && s.find(v) == s.end()) return false;
    int l = v / 2, r = (v + 1) / 2;
    if (s.find(l) != s.end()) {
        s.erase(s.find(l));
    } else {
        if (!dfs(l)) return false;
    }
    if (s.find(r) != s.end()) {
        s.erase(s.find(r));
    } else {
        if (!dfs(r)) return false;
    }
    return true;
}

void solve() {
    cin >> n;
    vector<int> a(n);
    int summ = 0;
    cnt_v = 1;
    s.clear();
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        summ += a[i];
        s.insert(a[i]);
    }
    if (s.count(summ) || dfs(summ)) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) solve();
}
