#pragma GCC optimize("O3")
//#pragma GCC optimize("avx-2")
#pragma GCC optimize("unroll-loops")
#include<bits/stdc++.h>
using namespace std;
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;
#define fir first
#define mp make_pair
#define sec second
#define pb push_back
#define ma make_pair
#define sz size
#define en "\n"
#define ll long long
#define ld long double
const ll mod = 998244353;
vector<vector<pair<ll, pair<ll, ll> > > > g(300000);
vector<vector<pair<ll, ll> > > d(300000);
ll nw[300000], mn[300000];
void dfs(int v, int par)
{
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i].fir != par)
        {
            int a = g[v][i].sec.fir, b = g[v][i].sec.sec;
            for (int j = 0; j < d[a].sz(); j++)
                nw[d[a][j].fir] -= d[a][j].sec;
            for (int j = 0; j < d[b].sz(); j++)
                nw[d[b][j].fir] += d[b][j].sec;
            for (int j = 0; j < d[a].sz(); j++)
                mn[d[a][j].fir] = min(mn[d[a][j].fir], nw[d[a][j].fir]);
            for (int j = 0; j < d[b].sz(); j++)
                mn[d[b][j].fir] = min(mn[d[b][j].fir], nw[d[b][j].fir]);
            dfs(g[v][i].fir, v);
            for (int j = 0; j < d[a].sz(); j++)
                nw[d[a][j].fir] += d[a][j].sec;
            for (int j = 0; j < d[b].sz(); j++)
                nw[d[b][j].fir] -= d[b][j].sec;
        }
}
ll binpow(ll a, ll b)
{
    ll res = 1;
    while (b > 0)
    {
        if (b % 2 == 0)
        {
            b /= 2;
            a = (a*a) % mod;
        }
        b--;
        res = (res*a) % mod;
    }
    return res;
}
ll dv(ll a, ll b)
{
    return (a*binpow(b, mod-2)) % mod;
}
ll ans = 0, res;
//ll answ[300000];
void dfs1(int v, int par)
{
    ans = (ans+res) % mod;
//    answ[v] = res;
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i].fir != par)
        {
            res = (res*g[v][i].sec.sec) % mod;
            res = dv(res, g[v][i].sec.fir);
            dfs1(g[v][i].fir, v);
            res = (res*g[v][i].sec.fir) % mod;
            res = dv(res, g[v][i].sec.sec);
        }
    return;
}
void solve()
{
    ll n;
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        ll a, b, x, y, d;
        cin >> a >> b >> x >> y;
        a--;
        b--;
        g[a].pb(mp(b, mp(x, y)));
        g[b].pb(mp(a, mp(y, x)));
    }
    dfs(0, 0);
    res = 1;
    for (ll i = 1; i <= n; i++)
        res = res*binpow(i, -mn[i]);
    ans = 0;
    dfs1(0, 0);
    cout << ans << en;
    for (int i = 0; i <= n; i++)
    {
        nw[i] = 0;
        mn[i] = 0;
    }
    for (int i = 0; i < n; i++)
        g[i].clear();
}
bool used[300000];
int main()
{
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    for (int i = 2; i < 300000; i++)
        if (!used[i])
        {
            for (int j = i; j < 300000; j+=i)
            {
                used[j] = true;
                int u = j, p = 0;
                while (u % i == 0)
                {
                    p++;
                    u /= i;
                }
                d[j].pb(mp(i, p));
            }
        }
    int q;
    cin >> q;
    while (q--)
        solve();
}
