#include <iostream>
#include <set>

const int maxN = 2e5;

bool flag;
int t, n, a[maxN];
long long start;
std::multiset<long long> s1, s2;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> t;
	while (t--) {
		std::cin >> n;
		if (n == 1) {
			std::cin >> a[0];
			std::cout << "YES\n";
			continue;
		}
		s1.clear();
		s2.clear();
		start = 0;
		for (int i = 0; i < n; i++) {
			std::cin >> a[i];
			s2.insert(-a[i]);
			start += a[i];
		}
		flag = true;
		s1.insert(-start);
		while (!s1.empty() && !s2.empty()) {
			long long t1 = *s1.begin();
			s1.erase(s1.begin());
			long long t = *s2.begin();
			if (t1 > t) {
				flag = false;
				break;
			}
			t1 = -t1;
			t = -t;
			long long t2 = (t1 + 1) / 2, t3 = t1 / 2;
			if (t2 == t) {
				s2.erase(s2.begin());
				t2 = 0;
				t = *s2.begin();
				t = -t;
			}
			if (t3 == t) {
				s2.erase(s2.begin());
				t3 = 0;
			}
			if (t2 != 0) {
				if (t2 != 1)
					s1.insert(-t2);
				else {
					auto it = s2.find(-t2);
					if (it == s2.end()) {
						flag = false;
						break;
					}
					s2.erase(it);
				}
			}
			if (t3 != 0) {
				if (t3 != 1)
					s1.insert(-t3);
				else {
					auto it = s2.find(-t3);
					if (it == s2.end()) {
						flag = false;
						break;
					}
					s2.erase(it);
				}
			}
		}
		std::cout << (flag ? "YES\n" : "NO\n");
	}
	return 0;
}