#include <iostream>
#include <map>

const int maxN = 1e5;

int n, a[maxN], ans = 2;
std::map<long long, int> dict;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n;
	for (int i = 0; i < n; i++) {
		std::cin >> a[i];
		ans = std::max(ans, ++dict[a[i]]);
	}
	for (int d = 1; d <= maxN && maxN / d >= ans; d++) {
		dict.clear();
		for (int i = 0; i < n; i++)
			ans = std::max(ans, ++dict[a[i] - 1LL * i * d]);
		dict.clear();
		for (int i = 0; i < n; i++)
			ans = std::max(ans, ++dict[a[i] + 1LL * i * d]);
	}
	std::cout << n - ans;
	return 0;
}