#include <iostream>
#include <unordered_map>

#pragma GCC target("avx2")
#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")

const int maxN = 1e5;

int n, a[maxN], ans = 2;
std::unordered_map<long long, int> dict;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n;
	for (int i = 0; i < n; i++) {
		std::cin >> a[i];
		ans = std::max(ans, ++dict[a[i]]);
	}
	for (int d = 1; d <= maxN && maxN / d >= ans; d++) {
		dict.clear();
		for (int i = 0; i < n; i++)
			ans = std::max(ans, ++dict[a[i] - 1LL * i * d]);
		dict.clear();
		for (int i = 0; i < n; i++)
			ans = std::max(ans, ++dict[a[i] + 1LL * i * d]);
	}
	std::cout << std::max(n - ans, 0);
	return 0;
}