#include <bits/stdc++.h>
// #include <iostream>
// #include <vector>
// #include <string>
// #include <utility>
// #include <algorithm>
// #include <iomanip>
// #include <set>
// #include <map>
// #include <unordered_set>
// #include <unordered_map>
// #include <cmath>

using namespace std;

#define int long long
#define ft first
#define sd second
#define all(a) a.begin(), a.end()
#define siz(a) (int)(a.size())

typedef long long ll;
typedef long double ld;

const int INF = (int)(1e9) + 5, MOD = 998244353, MN = (int)(2e5) + 5;
int n, a[MN], b[MN], vis[MN];
vector<tuple<int, int, int>> gr[MN];

int gsd(int x, int y)
{
    if (y == 0)
    {
        return x;
    }
    return gsd(y, x % y);
}

int lca(int x, int y)
{
    return x * y / gsd(x, y);
}

void dfs(int u)
{
    vis[u] = 1;
    for (tuple<int, int, int> e : gr[u])
    {
        int v = get<0>(e), x = get<1>(e), y = get<2>(e);
        if (!vis[v])
        {
            a[v] = a[u] * y;
            b[v] = b[u] * x;
            int g = gsd(a[v], b[v]);
            a[v] /= g;
            b[v] /= g;
            dfs(v);
        }
    }
}

void solve()
{
    cin >> n;
    fill(a, a + n, 1);
    fill(b, b + n, 1);
    fill(vis, vis + n, 0);
    for (int z = 0; z < n - 1; z++)
    {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        i--; j--;
        int g = gsd(x, y);
        x /= g;
        y /= g;
        gr[i].push_back({j, x, y});
        gr[j].push_back({i, y, x});
    }
    // cout << "here" << endl;
    a[0] = 1;
    b[0] = 1;
    dfs(0);
    // cout << "here" << endl;
    int k = 1;
    for (int i = 0; i < n; i++)
    {
        k = lca(k, b[i]);
    }
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        ans = (ans + k / b[i] * a[i] % MOD) % MOD;
    }
    cout << ans;
}

void clear()
{
    for (int i = 0; i < n; i++)
    {
        gr[i].clear();
    }
    cout << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    cin >> test;
    while (test--)
    {
        solve();
        clear();
    }
    return 0;
}