#include <bits/stdc++.h>
// #include <iostream>
// #include <vector>
// #include <string>
// #include <utility>
// #include <algorithm>
// #include <iomanip>
// #include <set>
// #include <map>
// #include <unordered_set>
// #include <unordered_map>
// #include <cmath>

using namespace std;

#define int long long
#define ft first
#define sd second
#define all(a) a.begin(), a.end()
#define siz(a) (int)(a.size())

typedef long long ll;
typedef long double ld;

const int INF = (int)(1e9) + 5, MOD = 998244353, MN = (int)(2e5) + 5, MP = 17985 + 5;
int n, vis[MN], now = 1, tab[MN], cnt[MP], ans = 0, k = 0;
vector<tuple<int, int, int>> gr[MN];
vector<int> pm;

int power(int num, int pw)
{
    if (pw == 0)
    {
        return 1;
    }
    if (pw % 2 == 1)
    {
        return num * power(num, pw - 1) % MOD;
    }
    int res = power(num, pw / 2);
    return res * res % MOD;
}

void dfs(int u)
{
    vis[u] = 1;
    for (tuple<int, int, int> e : gr[u])
    {
        int v = get<0>(e), x = get<1>(e), y = get<2>(e);
        if (vis[v])
        {
            continue;
        }
        vector<pair<int, int>> dx, dy;
        for (int d = 2; d * d <= x; d++)
        {
            if (x % d == 0)
            {
                int c = 0;
                while (x % d == 0)
                {
                    c++;
                    x /= d;
                }
                dx.push_back({d, c});
            }
        }
        if (x > 1)
        {
            dx.push_back({x, 1});
        }
        for (int d = 2; d * d <= y; d++)
        {
            if (y % d == 0)
            {
                int c = 0;
                while (y % d == 0)
                {
                    c++;
                    y /= d;
                }
                dy.push_back({d, c});
            }
        }
        if (y > 1)
        {
            dy.push_back({y, 1});
        }
        for (pair<int, int> elem : dy)
        {
            cnt[tab[elem.ft]] += elem.sd;
        }
        for (pair<int, int> elem : dx)
        {
            cnt[tab[elem.ft]] = max(0LL, cnt[tab[elem.ft]] - elem.sd);
        }
        dfs(v);
        for (pair<int, int> elem : dy)
        {
            cnt[tab[elem.ft]] -= elem.sd;
        }
        for (pair<int, int> elem : dx)
        {
            cnt[tab[elem.ft]] += elem.sd;
        }
    }
}

void ans_dfs(int u)
{
    // cout << "u now = " << u << " " << now << "\n";
    vis[u] = 1;
    ans = (ans + now) % MOD;
    for (tuple<int, int, int> e : gr[u])
    {
        int v = get<0>(e), x = get<1>(e), y = get<2>(e);
        if (vis[v])
        {
            continue;
        }
        // cout << "v = " << v << "\n";
        vector<pair<int, int>> dx, dy;
        for (int d = 2; d * d <= x; d++)
        {
            if (x % d == 0)
            {
                int c = 0;
                while (x % d == 0)
                {
                    c++;
                    x /= d;
                }
                dx.push_back({d, c});
            }
        }
        if (x > 1)
        {
            dx.push_back({x, 1});
        }
        for (int d = 2; d * d <= y; d++)
        {
            if (y % d == 0)
            {
                int c = 0;
                while (y % d == 0)
                {
                    c++;
                    y /= d;
                }
                dy.push_back({d, c});
            }
        }
        if (y > 1)
        {
            dy.push_back({y, 1});
        }
        // cout << "dy:\n";
        for (pair<int, int> elem : dy)
        {
            // cout << elem.ft << " " << elem.sd << "\n";
            now = now * power(elem.ft, elem.sd) % MOD;
        }
        // cout << "\n";
        // cout << "dx:\n";
        for (pair<int, int> elem : dx)
        {
            // cout << elem.ft << " " << elem.sd << "\n";
            now = now * power(power(elem.ft, elem.sd), MOD - 2) % MOD;
        }
        // cout << "\n";
        ans_dfs(v);
        for (pair<int, int> elem : dx)
        {
            now = now * power(elem.ft, elem.sd) % MOD;
        }
        for (pair<int, int> elem : dy)
        {
            now = now * power(power(elem.ft, elem.sd), MOD - 2) % MOD;
        }
    }
}

void solve()
{
    cin >> n;
    fill(vis, vis + n, 0);
    for (int z = 0; z < n - 1; z++)
    {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        i--; j--;
        gr[i].push_back({j, x, y});
        gr[j].push_back({i, y, x});
    }
    fill(cnt, cnt + MP, 0);
    dfs(0);
    now = 1;
    for (int i = 0; i < MP; i++)
    {
        now = now * power(pm[i], cnt[i]) % MOD;
    }
    fill(vis, vis + n, 0);
    ans = 0;
    ans_dfs(0);
    cout << ans;
}

void clear()
{
    for (int i = 0; i < n; i++)
    {
        gr[i].clear();
    }
    cout << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    fill(tab, tab + MN, -1);
    for (int i = 2; i < MN; i++)
    {
        if (tab[i] == -1)
        {
            pm.push_back(i);
            for (int x = 0; x * i < MN; x++)
            {
                tab[x * i] = k;
            }
            k++;
        }
    }
    // cout << k;
    int test = 1;
    cin >> test;
    while (test--)
    {
        solve();
        clear();
    }
    return 0;
}