#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"

using namespace std;


const int MOD = 998244353;
long long ans = 0;
const int N = 2e5 + 100;
int p[N];
vector <int> primes;


int po(long long a, int n) {
    long long ans = 1;
    while (n) {
        if (n & 1) {
            (ans *= a) %= MOD;
        }
        (a *= a) %= MOD;
        n /= 2;
    }
    return ans;
}


map <int, int> fac(int v) {
    map <int, int> ans;
    if (v == 1) {
        return ans;
    }
    int last = p[v], cnt = 0;
    while (v != 1) {
        if (last != p[v]) {
            ans[last] = cnt;
            last = p[v];
            cnt = 1;
        } else {
            cnt++;
        }
        v /= p[v];
    }
    ans[last] = cnt;
    return ans;
}


map <int, int>* dfs(const vector <vector <array <int, 3>>>& g, int v, int p) {
    auto* now = new map <int, int>;

    for (auto [i, x, y] : g[v]) {
        if (i == p) {
            continue;
        }
        map <int, int> up = fac(x), down = fac(y);

        auto w = dfs(g, i, v);
        for (auto [a, b] : up) {
            (*w)[a] += b;
        }
        for (auto [a, b] : down) {
            if (w -> count(a)) {
                (*w)[a] = max(0, (*w)[a] - b);
            }
        }

        if (len(*w) > len(*now)) {
            swap(w, now);
        }
        for (auto [a, b] : *w) {
            if (!(*now).count(a)) {
                (*now)[a] = b;
            } else {
                (*now)[a] = max((*now)[a], b);
            }
        }
    }
    return now;
}


void getans(const vector <vector <array <int, 3>>>& g, int v, int p, long long nowval) {
    (ans += nowval) %= MOD;
    for (auto [i, x, y] : g[v]) {
        if (i == p) {
            continue;
        }
        getans(g, i, v, (nowval * y % MOD) * po(x, MOD - 2) % MOD);
    }
}


void solve() {
    int n;
    cin >> n;

    vector <vector <array <int, 3>>> g(n);

    for (int _ = 0; _ < n - 1; _++) {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        i--, j--;
        int gc = __gcd(x, y);
        x /= gc, y /= gc;
        g[i].push_back({j, x, y});
        g[j].push_back({i, y, x});
    }

    auto st = *dfs(g, 0, 0);
    int now = 1;
    for (auto [a, b] : st) {
        (now *= po(a, b)) %= MOD;
    }
    getans(g, 0, 0, now);
    cout << ans << endl;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    for (int i = 2; i < N; i++) {
        if (p[i] == 0) {
            p[i] = i;
            primes.push_back(i);
        }
        for (int x : primes) {
            if (x > p[i] || 1LL * x * i >= N) {
                break;
            }
            p[x * i] = x;
        }
    }

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
