#include<bits/stdc++.h>

using namespace std;

#define int long long


const int MOD = 998244353;

int binpow(int x, int a) {
    if (a == 0) {
        return 1;
    }
    if (a % 2 == 1) {
        return (binpow(x, a - 1) * x) % MOD;
    }
    int y = binpow(x, a / 2);
    return (y * y) % MOD;
}


vector<vector<vector<int>>>g;

vector<int>cur, mx;



void add(int x) {
    //cout << "X: " << x << endl;
    for (int i = 2; i * i <= x; ++i) {
        while(x % i == 0) {
            x /= i;
            cur[i]++;
            mx[i] = max(mx[i], cur[i]);
        }
    }
    if (x > 1) {
        cur[x]++;
        mx[x] = max(mx[x], cur[x]);
    }

}

void del(int x) {
    for (int i = 2; i * i <= x; ++i) {
        while(x % i == 0) {
            x /= i;
            cur[i]--;
        }
    }
    if (x > 1) {
        cur[x]--;
    }

}

int res = 0;


void dfs(int v, int pr = -1, int a = 1, int b = 1) {
    res = (res + (a * binpow(b, MOD - 2)) % MOD) % MOD;
    res %= MOD;
    for (auto p : g[v]) {
        int u = p[0];
        int x = p[2];
        int y = p[1];
        if (u != pr) {
            add(y);
            del(x);
            dfs(u, v, (a * x) % MOD, (b * y) % MOD);
            add(x);
            del(y);
        }
    }
}




signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        int n;
        cin >> n;
        res = 0;
        g.assign(n, vector<vector<int>>(0, vector<int>(1, 0)));
        cur.assign(n + 1, 0);
        mx.assign(n + 1, 0);
        for (int i = 0; i < n - 1; ++i) {
            int v, u, a, b;
            cin >> v >> u >> a >> b;
            g[v - 1].push_back({u - 1, a % MOD, b % MOD});
            g[u - 1].push_back({v - 1, b % MOD, a % MOD});
        }
        dfs(0);
        int x = 1;
        for (int i = 2; i <= n; ++i) {
            x = (x * binpow(i, mx[i])) % MOD;
            //cout << mx[i] << " ";
        }
        //cout << endl;

        res = (res * x) % MOD;

        //cout << x << endl;
        cout << (res % MOD + MOD) % MOD << "\n";


    }


}
