#include <iostream>
#include <tuple>
#include <vector>
#include <algorithm>
#include <random>
#include <ctime>
#include <iomanip>
#include <unordered_map>
#include <set>


using namespace std;

typedef uint32_t uint;
typedef int64_t ll;
typedef uint64_t ull;
mt19937 rnd((uint)time(0));

#define all(x) x.begin(),x.end()

void solve() {
    int n;
    cin >> n;
    unordered_map<ull, uint> cnt;
    ull cs = 0;
    for (int i = 0; i < n; ++i) {
        ull x;
        cin >> x;
        cnt[x]++;
        cs += x;
    }
    multiset<ull> vals;
    vals.insert(cs);
    bool ok = true;
    uint cuts = 0;
    while (!vals.empty()) {
        ull nv = *--vals.end();
        vals.erase(--vals.end());
        if (cnt.count(nv) && cnt[nv]) --cnt[nv];
        else {
            if (++cuts == n) {
                ok = false;
                break;
            }
            vals.insert(nv / 2);
            vals.insert((nv + 1) / 2);
        }
    }
    if (ok && vals.empty()) cout << "YES\n";
    else cout << "NO\n";
}


int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) solve();
}
