#include <iostream>
#include <tuple>
#include <vector>
#include <algorithm>
#include <random>
#include <ctime>
#include <iomanip>
#include <unordered_map>
#include <set>
#include <cstring>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/hash_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define unordered_map gp_hash_table

typedef uint32_t uint;
typedef int64_t ll;
typedef uint64_t ull;
mt19937 rnd((uint)time(0));

#define all(x) x.begin(),x.end()

constexpr uint MOD = 998244353;


ull bpow(ull x, ull p) {
    ull res = 1;
    for (uint i = 0; i < 31; ++i) {
        if (p & (1 << i)) res = res * x % MOD;
        x = x * x % MOD;
    }
    return res;
}

constexpr int MAXN = 100000;
constexpr int MAXA = 100000;
constexpr int MINA = -MAXA;
constexpr int MAXD = 200000;
constexpr int T = 500;
constexpr int D = (MAXD + T - 1) / T;
int a[MAXN];
int b[MAXN];
constexpr int MVAL = MAXA + (MAXN - 1) * T;
constexpr uint CSIZE = 2 * (MAXA + (MAXN - 1) * T);
uint cnt[CSIZE];
int16_t lstate[CSIZE];
void mxu(uint &a, uint b){if (a < b) a = b;}
signed main() {
    for (int16_t &x : lstate) x = T + 1;
    memset(cnt, 0, sizeof(cnt));
    //D * T <= MAXD
    // D <= MAXD / T
    // T = sqrt(MAXD)
    // T is straightfw checks and D is clever division
    // remember that T is taken both signs and D is taken both sides
    // N*2T + N*2D (stupid check long + check the app diff for close ones)
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a[i];
    uint bans = 0;
    for (int d = -T; d <= T; ++d) {
        int16_t d16 = d;
//        memset(cnt, 0, sizeof(cnt));
        int cadd = 0;
        for (int i = 0; i < n; ++i, cadd += d) {
            int cval = a[i] + cadd + MVAL; //maybe not cut on this
            if (lstate[cval] != d16) lstate[cval] = d16, cnt[cval] = 0;
            ++cnt[cval];
            mxu(bans, cnt[cval]);
        }
    }
    unordered_map<int, uint> lcnt;
    for (int i = 0; i < n; ++i) {
        lcnt.clear();
        int lb = max(0, i - D);
        int rb = min(n, i + D + 1);
        for (int j = lb; j < i; ++j) {
            int dv = (a[j] - a[i]) / (j - i);
            if (a[j] - a[i] == dv * (j - i)) ++lcnt[dv];
        }
        for (int j = i + 1; j < rb; ++j) {
            int dv = (a[j] - a[i]) / (j - i);
            if (a[j] - a[i] == dv * (j - i)) ++lcnt[dv];
        }
        for (auto &[x, y] : lcnt) mxu(bans, y + 1);
    }
    cout << n - bans;
}










