#include <iostream>
#include <algorithm>
#include <cstdio>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <random>
#include <chrono>
#include <bitset>
#include <vector>
#include <immintrin.h>
#include <stack>
#include <deque>
#include <queue>

#pragma GCC optimize("-O3")
#pragma GCC target("tune=native")

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    
    int32_t n;
    std::cin >> n;

    int32_t* arr = new int32_t[n];
    std::mt19937 rng;
    for(int32_t i = 0; i < n; i++)
        std::cin >> arr[i];
        //arr[i] = i % 2 == 0 ? 1 : 100'000;

    //for(int32_t i = 0; i < n; i++)
    //    std::cout << (i + 1) * 1 + arr[i] << " ";

    int32_t ans = 0;
    for(int64_t d = -400; d <= 400; d++) {
        std::vector<int64_t> vals;
        for(int32_t i = 0; i < n; i++)
            vals.push_back((i + 1) * d + arr[i]);
        std::sort(vals.begin(), vals.end());

        int32_t cnt = 1;
        for(int32_t i = 1; i < n; i++)
            if(vals[i] == vals[i - 1])
                cnt++;
            else {
                ans = std::max(ans, cnt);
                cnt = 1;
            }
        ans = std::max(ans, cnt);
    }

    for(int32_t i = 0; i < n; i++)
        for(int32_t j = i + 1; j < std::min(n, i + 255); j++) {
            if(std::abs(arr[j] - arr[i]) % (j - i) == 0) {
                int64_t d = (arr[j] - arr[i]) / (j - i);
                if(std::abs(d) <= 400)
                    continue;

                int32_t ans_cur = 0;
                for(int32_t k = i; k < n; k++) {
                    int64_t cur = (k - i) * d + arr[i];
                    if(cur < 0 || cur > 100'000)
                        break;

                    if(arr[k] == cur)
                        ans_cur++;
                }
                ans = std::max(ans, ans_cur);
            }
        }
    std::cout << n - ans;
    return 0;
}





