#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <set>
#include <vector>
#include <queue>
#include <bitset>
#include <algorithm>
#include <ctime>

using namespace std;

#define endl '\n'

const int Base = 1e5 + 1;
const long long Mod = 998244353;

int n;
int a[Base];
int pref[Base];
int ptK[2 * Base];
int ans = 0;

void solve(int pos)
{
	vector<int> ch;
	for (int i = pos + 1; i + 1 < n; i++)
	{
		int P = pref[i] - pref[pos];
		int d = i - pos;
		if (P % d == 0)
		{
			ptK[Base + P / d]++;
			ch.push_back(Base + P / d);
		}
	}

	for (auto id : ch)
	{
		ans = max(ans, 1 + ptK[id]);
		ptK[id] = 0;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("Text.txt", "w", stdout);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	pref[0] = 0;
	for (int i = 0; i + 1 < n; i++)
	{
		pref[i + 1] = pref[i] + a[i + 1] - a[i];
	}

	for (int i = 0; i < n - ans; i++)
	{
		solve(i);
	}

	cout << n - ans << endl;
}