//#pragma GCC("-O3, no-stack-protector")
#pragma GCC("unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <cstring>
#include <vector>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define puf push_front
#define pob pop_back
#define pof pop_front


using namespace std;
//using namespace __gnu_pbds;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
//typedef tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

const int NMAX = 100010;
const int S = 320;


int n;

int solve(vector<int> a) {

    int res = 1;

    for (int d = 1; d < S; d++) {
        vector<int> cl[d];

        for (int i = 0; i < n; i++) {
            cl[a[i] % d].pub({a[i] / d - i});
        }


        for (int i = 0; i < d; i++) {
            unordered_map<int, int> acc;
            for (int j = 0; j < sz(cl[i]); j++) {
                acc[cl[i][j]]++;
            }
            for (auto it : acc) {
                res = max(res, it.y);
            }
        }
    }

    unordered_map<int, int> dp[n];
    int d;
    for (int i = 1; i < n; i++) {
        for (int j = i - 1; j >= 0 && i - j < S; j--) {
            d = a[i] - a[j];
            if (d % (i - j)) {
                continue;
            }
            d /= (i - j);
            if (dp[i].find(d) != dp[i].end()) {
                continue;
            }

            if (dp[j].find(d) == dp[j].end()) {
                dp[i][d] = 2;
            } else {
                dp[i][d] = dp[j][d] + 1;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (auto it : dp[i]) {
            res = max(res, it.y);
        }
    }


    return res;
}


void solve_solve_solve() {
    cin >> n;
    vector<int> a(n);

    int res = 1;
    unordered_map<int, int> acc;
    for (int i = 0; i < n; i++) {
        cin >> a[i];

        acc[a[i]]++;
    }
    for (auto it : acc) {
        res = max(res, it.y);
    }


    int x = solve(a);


    reverse(all(a));
    int y = solve(a);


    res = max(res, max(x, y));


    cout << n - res << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);


    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
