#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define eb emplace_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int randint(int L, int R) {
    return L + rnd() % (R - L + 1);
}

const int N = 1e5 + 5, K = 333;

int n, a[N];

void read() {
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];
}

void gen() {
    n = 100000;
    for (int i = 1; i <= n; ++i) a[i] = randint(1, 100000);
}

int cnt[N * K + N], col[N * K + N], vers = 0;

int solve_small() {
    int ans = n;
    for (int d = 0; d <= K; ++d) {
        ++vers;
        for (int i = 1; i <= n; ++i) {
            int x = N + i * d - a[i];
            if (col[x] != vers) {
                col[x] = vers;
                cnt[x] = 0;
            }
            cnt[x]++;
        }
        for (int i = 1; i <= n; ++i) {
            int x = N + i * d - a[i];
            ans = min(ans, n - cnt[x]);
        }
    }
    return ans;
}

unordered_map<int, int> dp[N];

int solve_large() {
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        dp[i].clear();
        for (int j = i - 1; j >= max(1, i - 2 * K); --j) {
            if ((a[i] - a[j]) % (i - j) == 0) {
                int d = (a[i] - a[j]) / (i - j);
                if (abs(d) > K) {
                    dp[i][d] = max(dp[i][d], dp[j][d] + 1);
                    ans = max(ans, dp[i][d] + 1);
                }
            }
        }
    }
    return n - ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//    gen();
    read();
    int ans = solve_large();
    ans = min(ans, solve_small());
    reverse(a + 1, a + n + 1);
    ans = min(ans, solve_small());
    cout << ans << "\n";
    return 0;
}