#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const long long INF = 1000000001;

using namespace std;

const int C = 998244353;

int pow1(int x, int y) {
    if (y == 0) {
        return 1;
    }
    if (y % 2 == 0) {
        return pow1(x*x % C, y/2);
    }
    return pow1(x, y-1)*x % C;
}

vector<p> factor(int n) {
    vector<p> ans;
    int sqrt1 = sqrt(n);
    for (int q = 2; q <= sqrt1; q++) {
        if (n % q == 0) {
            ans.push_back({q, 0});
        }
        while (n % q == 0) {
            ans.back().second++;
            n /= q;
        }
    }
    if (n != 1) {
        ans.push_back({n, 1});
    }
    return ans;
}

vector<vector<pair<int, p>>> d;
vector<map<int, int>> is;
vector<int> ind, sum1, num;

void DFS(int vertex, int parent) {
    if (d[vertex].size() == 1 && parent != -1) {
        ind[vertex] = vertex, sum1[vertex] = 1;
        return;
    }
    p max1 = {-1, -1};
    for (pair<int, p> q : d[vertex]) {
        if (q.first != parent) {
            DFS(q.first, vertex);
            max1 = max(max1, {(int)is[ind[q.first]].size(), q.first});
        }
    }
    ind[vertex] = ind[max1.second];
    for (pair<int, p> q : d[vertex]) {
        if (q.first != parent) {
            vector<p> x = factor(q.second.first), y = factor(q.second.second);
            for (p q1 : x) {
                is[ind[q.first]][q1.first] += q1.second;
                num[q.first] = num[q.first]*pow1(q1.first, q1.second) % C;
            }
            int mn = 1;
            for (p q1 : y) {
                if (is[ind[q.first]].find(q1.first) != is[ind[q.first]].end()) {
                    int w = is[ind[q.first]][q1.first];
                    if (w > q1.second) {
                        is[ind[q.first]][q1.first] -= q1.second;
                    } else {
                        mn = mn*pow1(q1.first, q1.second-w) % C;
                        is[ind[q.first]].erase(q1.first);
                    }
                    num[q.first] = num[q.first]*pow1(q1.first, min(w, q1.second)*(C-2)) % C;
                } else {
                    mn = mn*pow1(q1.first, q1.second) % C;
                }
            }
            sum1[q.first] = sum1[q.first]*mn % C;
        }
    }
    num[vertex] = num[max1.second];
    for (pair<int, p> q : d[vertex]) {
        if (q.first != parent && q.first != max1.second) {
            for (p q1 : is[ind[q.first]]) {
                if (q1.second > is[ind[vertex]][q1.first]) {
                    num[vertex] = num[vertex]*pow1(q1.first, q1.second-is[ind[vertex]][q1.first]) % C;
                    is[ind[vertex]][q1.first] = q1.second;
                }
            }
        }
    }
    for (pair<int, p> q : d[vertex]) {
        if (q.first != parent) {
            sum1[vertex] += num[vertex]*pow1(num[q.first], C-2) % C*sum1[q.first] % C;
        }
    }
    sum1[vertex] = (sum1[vertex]+num[vertex]) % C;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t1;
    cin >> t1;
    for (int q11 = 0; q11 < t1; q11++) {
        int n;
        cin >> n;
        d.assign(n, {}), is.assign(n, {}), ind.assign(n, -1), sum1.assign(n, 0), num.assign(n, 1);
        for (int q = 0; q < n-1; q++) {
            int x, y, x1, y1;
            cin >> x >> y >> x1 >> y1;
            x--, y--;
            d[x].push_back({y, {x1, y1}});
            d[y].push_back({x, {y1, x1}});
        }
        DFS(0, -1);
        cout << sum1[0] << endl;
    }
    return 0;
}
