#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pb push_back
#define sz(a) int32_t(a.size())
#define endl '\n'
//#define int long long

const int N = 2e5 + 100;
const int M = 26;
const int mod = 998244353;
const int inf = 1e9 + 7;

int a[N], dp[N], check[N];
int sq = 320;

int calc(int d, int n)
{
    map < ll, int > mp;
    int ans = n - 1;
    for(int i = 0; i < n; i++)
        mp[1ll * a[i] - 1ll * i * d]++;
    for(auto to: mp)
        ans = min(ans, n - to.S);
    return ans;
}

int solve1(int n)
{
    for(int i = 0; i <= sq; i++)
        check[i] = 1;
    for(int i = 0; i < n; i++)
    {
        for(int j = i - 1; j >= max(0, i - sq); j--)
        {
            int ra = a[i] - a[j], len = i - j;
            if (ra < 0 || ra % len) continue;
            check[ra / len]++;
        }
    }
    int ans = n - 1;
    for(int d = 0; d <= 1e5; d++)
    {
        if (!check[d]) continue;
        ans = min(ans, calc(d, n));
    }
    return ans;
}

void solve()
{
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    int ans = n - 1;
    ans = min(ans, solve1(n));
    for(int i = 0; i < n; i++)
        a[i] *= -1;
    ans = min(ans, solve1(n));
    cout << ans << endl;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}
