#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>

#define int long long
#define sz(x) (int)x.size()
#define pw(x) (1LL<<x)
#define sqr(x) ((x)*(x))
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pii pair<int,int>
#define fi first
#define se second
#define p_b push_back
#define m_p make_pair

using namespace std;

const int k = 316;
int n, a[100005], ans = 0, cnt[100000 * (k + 1) + 5];

void solve()
{
    for(int d = 0; d <= k; d++)
    {
        for(int i = 0; i < n; i++)
        {
            int cur = a[i] + d * (n - i);
            ans = max(ans, ++cnt[cur]);
        }
        for(int i = 0; i < n; i++)
            cnt[a[i] + d * (n - i)]--;
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = 1; j * k <= 100000 && i+j<n; j++)
        {
            if(a[i+j] < a[i] || (a[i+j] - a[i]) % j)
                continue;
            int d = (a[i+j] - a[i]) / j;
            ans = max(ans, (++cnt[d]) + 1);
        }
        for(int j = 1; j * k <= 100000 && i+j<n; j++)
        {
            if(a[i+j] < a[i] || (a[i+j] - a[i]) % j)
                continue;
            int d = (a[i+j] - a[i]) / j;
            cnt[d]--;
        }
    }
}

main()
{
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    solve();
    reverse(a, a + n);
    solve();
    cout << n - ans;
    return 0;
}
