#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <random>
#include <vector>
#include <queue>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,mmx,abm,popcnt,tune=native")

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef long double ld;

const ll cst = 3e5 + 5;
const ll inf = (ll)1e18 + 228;
const ll mod = 1e9 + 7;

void operator delete(void*);

ll arr[cst];
map<ll, ll> mp;

void f(ll x) {
	if (mp[x] > 0) {
		mp[x]--;
		return;
	}
	if (x == 1) return;
	f(x / 2);
	f((x + 1) / 2);
}

inline void solve() {
	ll n;
	cin >> n;
	ll sm = 0;
	mp.clear();
	for (ll i = 1; i <= n; i++) {
		cin >> arr[i];
		mp[arr[i]]++;
		sm += arr[i];
	}
	f(sm);
	sm = 0;
	for (auto& i : mp) sm += i.second;
	if (sm) cout << "NO";
	else cout << "YES";
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
	return 0;
}