#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 2e5 + 100, INF = 1e18, BASE = 131, MOD = 998244353;
const double EPS = 0.0001;

int bp(int a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        int b = bp(a, n / 2);
        return b * b % MOD;
    } else {
        return bp(a, n - 1) * a % MOD;
    }
}

int gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

int pl(int a, int b) {
    return (a + b) % MOD;
}

int mi(int a, int b) {
    return (a - b + MOD) % MOD;
}

int mul(int a, int b) {
    return a * b % MOD;
}

int del(int a, int b) {
    return a * bp(b, MOD - 2) % MOD;
}

int nok(int a, int b) {
    return del((a * b % MOD), gcd(a, b));
}

int t, n, ans[N], sum, al = 1, b[N];
vector<pair<int, pair<int, int>>> a[N];

void dfs(int v, int p) {
    for (int i = 0; i < a[v].size(); i++) {
        int to = a[v][i].first, x = a[v][i].second.first, y = a[v][i].second.second;
        if (to == p) continue;
        int cv = del(mul(ans[v], al), b[v]);
        int tv = nok(ans[to], del(mul(cv, y), x));
        int nv = del(mul(tv, x), y);
        int de = del(nv, cv);
        ans[to] = tv;
        al = mul(al, de);
        b[to] = al;
        dfs(to, v);
    }
}

void solve() {
    cin >> t;
    while (t--) {
        cin >> n;
        for (int i = 0; i < n; i++) {
            a[i].clear();
            ans[i] = 0;
            sum = 0;
        }
        for (int i = 0; i < n - 1; i++) {
            int f, s, x, y;
            cin >> f >> s >> x >> y;
            f--, s--;
            int gc = gcd(x, y);
            x /= gc;
            y /= gc;
            a[f].push_back({s, {x, y}});
            a[s].push_back({f, {y, x}});
        }
        fill(ans, ans + n, 1);
        fill(b, b + n, 1);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < a[i].size(); j++) {
                int x = a[i][j].second.first;
                ans[i] = nok(ans[i], x);
            }
        }
        dfs(0, 0);
        for (int i = 0; i < n; i++) {
            ans[i] = del(mul(ans[i], al), b[i]);
        }
        for (int i = 0; i < n; i++) {
            sum += ans[i];
//            cout << i + 1 << " " << ans[i] << endl;
            sum %= MOD;
        }
        cout << sum << '\n';
    }
}
