#pragma GCC optimize("Ofast")
#pragma GCC target("avx")
#include <iostream>
#include <type_traits>
#include<set>
#include <bits/stdc++.h>



using namespace std;
#define ll long long
#define ld long double
#define ull unsigned long long

ll mod=998244353;
struct edge
{
    ll to, x, y;
    edge():to(0), x(1), y(1){}
    edge(ll to, ll x, ll y):to(to), x(x), y(y){}
};
ll bp(ll a,ll n)
{
    if(n==0)
        return 1;
    if(n%2==1)
    {
        return a*bp(a, n-1)%mod;
    }
    ll b=bp(a, n/2);
    return b*mod;
}
ll inv(ll a) {
    return bp(a, mod - 2);
}
vector<int> pr;
void eratos() {
    int N = 1e5 + 5;
    vector<bool> ok(N + 5, 1);
    for (int i = 2; i <= N; ++i) {
        if (ok[i]) {
            pr.push_back(i);
            for (int j = 2; j * i <= N; ++j)
                ok[j * i] = 0;
        }
    }
}
vector<vector<edge>> g;
int pr_num[200000], pr_max[200000];
ll ans=0;
ll gcd(ll a, ll b)
{
    while(b)
        a%=b, swap(a, b);
    return a;
}
ll lcm(ll a, ll b)
{
    ll c=gcd(a, b);
    return a/c*b;
}
void dfs(int v, int pr=-1) {
    for (auto u: g[v]) {
        int to = u.to, x = u.x, y = u.y;
        int x1 = x, y1 = y;
        if(to==pr)
            continue;
        vector<pair<int, int>> delx, dely;
        for (int j = 2; j * j <= x1; ++j) {
            if (x1 % j == 0) {
                delx.push_back({j, 0});
                while (x1 % j == 0) {
                    x1 /= j;
                    pr_num[j]--;
                    delx.back().second++;
                }
            }
        }
        for (int j = 2; j * j <= y1; ++j) {
            if (y1 % j == 0) {
                dely.push_back({j, 0});
                while (y1 % j == 0) {
                    y1 /= j;
                    pr_num[j]++;
                    dely.back().second++;
                }
                if (pr_num[j] < 0)
                    pr_max[j] = min(pr_max[j], pr_num[j]);
            }
        }

        dfs(to, v);
        for (auto u1: delx) {
            pr_num[u1.first] += u1.second;
        }
        for (auto u1: dely) {
            pr_num[u1.first] -= u1.second;
        }
    }
}
void dfs2(int v, int pr, ll K, ll X=1, ll Y=1) {
    ans += ((K * Y) % mod * inv(X)) % mod;
    ans%=mod;
    for (auto u: g[v]) {
        ll to = u.to, x = u.x, y = u.y;
        if (to == pr)
            continue;
        ll X1 = (X * x) % mod;
        ll Y1 = (Y * y) % mod;
        dfs2(to, v, K, X1, Y1);
    }
}
int main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    eratos();
    int q=1;
    cin>>q;
    while(q--)
    {
        int n;
        cin>>n;
        g.clear();
        g.resize(n);
        for(int i=0;i<n-1;++i)
        {
            int a, b, x, y;
            cin>>a>>b>>x>>y;
            a--, b--;
            ll d=gcd(x, y);
            x/=d, y/=d;
            g[a].push_back(edge(b, x, y));
            g[b].push_back(edge(a, y, x));
        }
        dfs(0);
        ll K=1;
        for(auto u:pr) {
            if (pr_max[u] < 0)
                K = (K * bp(u, -pr_max[u])) % mod;
        }
        ans=0;
        dfs2(0, -1, K);
        cout<<ans<<'\n';
    }
    return 0;
}
