﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>
#include <random>
#include <cassert>

using namespace std;

#define int long long
#define double long double
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int N = 1ll << 3;

const int al = 'z' - 'a' + 1;

void solve() {
    string s;
    cin >> s;
    vi cnt(al, 0);
    int n = sz(s);
    for (int i = 0; i < n; ++i) {
        ++cnt[s[i] - 'a'];
    }
    for (int i = 0; i < n; ++i) {
        if (cnt[s[i] - 'a'] == 1) {
            for (int j = i; j < n; ++j) {
                cout << s[j];
            }
            cout << "\n";
            return;
        }
        --cnt[s[i] - 'a'];
    }
}

signed  main(){
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
