﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>
#include <random>
#include <cassert>

using namespace std;

#define int long long
#define double long double
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int N = 1ll << 3;

const int al = 'z' - 'a' + 1;

void solve() {
    int n;
    cin >> n;
    vi a(n);
    int s = 0;
    multiset<int> st1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        st1.insert(a[i]);
        s += a[i];
    }
    multiset<int> st;
    st.insert(s);
    while (!st.empty()) {
        int a = *st.begin();
        if (a < *st1.begin()) {
            cout << "NO\n";
            return;
        }
        st.erase(st.begin());
        if (st1.find(a) == st1.end()) {
            st.insert(a / 2);
            st.insert(a - (a / 2));
        }
        else {
            st1.erase(st1.find(a));
        }
    }
    cout << "YES\n";
}

signed  main(){
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
