﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>
#include <random>
#include <cassert>

using namespace std;

#define int long long
#define double long double
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int N = 2e5 + 228;

const int al = 'z' - 'a' + 1;

const int st = 1e8;

void solve() {
    int n;
    cin >> n;
    vi a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    map<int, int> mp;
    int allans = 0;
    for (int k = max(-100000ll, -st / n); k <= min(100000ll, st / n); ++k) {
        mp.clear();
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, ++mp[a[i] - i * k]);
        }
        allans = max(allans, ans);
    }
    cout << n - allans;
}

signed  main(){
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
