#include<bits/stdc++.h>



#define fi first
#define se second
#define sz(x) (int)(x).size()
#define pb push_back
typedef long long ll;
typedef long double ld;


using namespace std;
const int N = (int)2e5 + 10;
const int mod =  998244353;
vector < pair < int , int > > primes[N];
vector < array < int , 3 > > g[N];

int cnt[N];
int mx[N];

int t[N];

void md(int &x){
    if(x >= mod)
        x-=mod;
    if(x < 0)
        x += mod;
}
void add(int v , int pl){
    for(auto &z : primes[v]){
        cnt[z.fi] += pl*z.se;
        mx[z.fi]=max(mx[z.fi],cnt[z.fi]);
    }
}
int inv[N];
void dfs(int v,  int p, int F){
    t[v] = F;
    for(auto &u : g[v]){
        if(u[0] == p)
            continue;
        add(u[1] , -1);
        add(u[2] , +1);




        dfs(u[0] , v, (1ll * F * u[1])%mod * (inv[u[2]])%mod);

        add(u[2] , -1);
        add(u[1], +1);

    }
}
int binpow(int a , int b){
    if(b == 0)return 1;
    int ans = binpow(a ,b  >> 1);
    ans = (1ll * ans * ans) % mod;
    if(b & 1)
        ans = (1ll * ans * a) % mod;
    return ans;
}
void solve(){
    int n;
    cin >> n;
    for(int i = 0 ; i < n; ++i){
        g[i].clear();
    }
    vector<int>vals;
    for(int i = 0; i < n - 1; ++i){
        int u , v,  x , y;
        cin >> u >> v >> x >> y;
        --u, --v;
        g[u].pb({v , y , x});
        g[v].pb({u , x , y});
        vals.pb(x);
        vals.pb(y);
    }
    dfs(0 , -1, 1);



    /// clr
    int ans = 1;
    for(auto &u : vals){
        for(auto &x : primes[u]){
            if(mx[x.fi] != 0){
                ans = (1ll * ans * binpow(x.fi, mx[x.fi])) % mod;
            }
            cnt[x.fi]=mx[x.fi]=0;
        }
    }
    int tot = 0;
    for(int x = 0; x < n; ++x){
        tot += (1ll * ans * t[x]) % mod;
        md(tot);
    }
    cout << tot << '\n';
}
signed main(){
    ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);


    for(int i = 2; i < N; ++i){
        if(primes[i].empty()){
            for(int j = i; j < N; j += i){
                int x = j;
                int cnt=0;
                while(x % i == 0){
                    cnt++, x/=i;
                }
                primes[j].pb({i , cnt});
            }
        }
    }
    for(int i = 1; i < N; ++i){
        inv[i] = binpow(i , mod - 2);
    }
    int t;
    cin >> t;
    while(t--){
        solve();
    }

    return 0;
}
