#include "bits/stdc++.h"
using ll = long long;
#define int ll
using namespace std;
using pii = pair<int, int>;
using vint = vector<int>;
using vpii = vector<pii>;
using ar3 = array<int, 3>;
using ar4 = array<int, 4>;
using va3 = vector<ar3>;
using va4 = vector<ar4>;

#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
#define range(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
#define F first
#define S second

const int N = 2e5+5;
const int Inf = 1e9+7;
const ll inf = ll(1e18)+7;

const int Mod = 998244353;
int add(int x, int y) { int t = x + y; if (t >= Mod) t -= Mod; if (t < 0) t += Mod; return t; }
int mul(int x, int y) { return (x * y) % Mod; }
int pw(int x, int p) {
	if (p == 0) return 1;
	int t = pw(x, p / 2);
	t = mul(t, t);
	if (p & 1) t = mul(t, x);
	return t;
}
int dv(int x, int y) { return mul(x, pw(y, Mod - 2)); }
// int f[N];
// int get_c(int n, int k) { return dv(dv(f[n], f[k]), f[n - k]); }
// f[0] = 1; range(i, N - 1) { f[i + 1] = mul(i + 1, f[i]); }

int n;
bool sost[N];
vint pr;
vector<pair<int, pair<vint, vint>>> g[N];
map<int, int> mxpo, mnpo;

void dfs(int v, unordered_map<int, int> &cnt, int p=-1) {
	for (auto &toe: g[v]) {
		int to = toe.F;
		if (to == p) continue;
		// cerr << "goto: " << v << ' ' << to << ' ' << sz(toe.S.F) << ' ' << sz(toe.S.S) << '\n';
		for (int i1: toe.S.F) { --cnt[i1]; }
		for (int i2: toe.S.S) { ++cnt[i2]; }
		for (int i1: toe.S.F) { mnpo[i1] = min(mnpo[i1], cnt[i1]); }
		for (int i2: toe.S.S) { mxpo[i2] = max(mxpo[i2], cnt[i2]); }
		dfs(to, cnt, v);
		for (int i1: toe.S.F) { ++cnt[i1]; }
		for (int i2: toe.S.S) { --cnt[i2]; }
	}
}
int ans = 0;
void dc(int v, int c, int p=-1) {
	ans = add(ans, c);
	for (auto &toe: g[v]) {
		int to = toe.F;
		if (to == p) continue;
		int c2 = c;
		for (int i1: toe.S.F) { c2 = dv(c2, i1); }
		for (int i2: toe.S.S) { c2 = mul(c2, i2); }
		dc(to, c2, v);
	}
}

vint fact(int x) {
	vint l;
	for (int i = 2; i * i <= x; ++i) {
		while (x % i == 0) {
			x /= i;
			l.pb(i);
		}
	}
	if (x != 1) {
		l.pb(x);
	}
	return l;
}

void solve() {
	cin >> n;
	range(iii, n - 1) {
		int i, j, x, y;
		cin >> i >> j >> x >> y;
		--i; --j;
		vint f1 = fact(x);
		vint f2 = fact(y);
		g[i].pb({j, {f1, f2}});
		g[j].pb({i, {f2, f1}});
	}
	unordered_map<int, int> cnt;
	// for (int i: pr) mnpo[i] = mxpo[i] = 0;
	dfs(0, cnt);
	int sus = 1;
	for (int i: pr) {
		sus = mul(sus, pw(i, -mnpo[i]));
	}
	ans = 0;
	dc(0, sus);
	cout << ans << '\n';
	range(i, n) {
		g[i].clear();
	}
	// int ans = 0;
	// for (int i: pr) {
	// 	if (mxpo[i] - mnpo[i] != 0) {
	// 		cerr << i << '\n';
	// 	}
	// 	ans = add(ans, pw(i, mxpo[i] - mnpo[i]));
	// }
	// cerr << "---" << '\n';
	// cout << ans << '\n';
	mxpo.clear();
	mnpo.clear();
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	// cout << setprecision(10) << fixed;
	int tt = 1;
	for (int i = 2; i < N; ++i) {
		if (!sost[i]) {
			pr.pb(i);
		}
		for (int j = i * i; j < N; j += i) {
			sost[j] = 1;
		}
	}
	cin >> tt;
	while (tt--) {
		solve();
	}
}