#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <bitset>
#include <sstream>
#include <assert.h>
#include <random>
#include <iomanip>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);
#define show(a) do {cerr << #a << ": " << a << "\n";} while(0);

mt19937_64 rnd(1231);
const int MAXINT = 1e9 + 12;
const ll MAXLL = (ll)1e18 + 21;

namespace segtree {
	const int MAXN = 262144;
	struct v {
		int x;
	};

	int arr[MAXN];
	int t[2 * MAXN - 1];

	void recalc(int i) {

	}
	void push(int i) {

	}
	
	void build(int i = 0, int l = 0, int r = MAXN) {
		if (r - l == 1) {
			// init!
		}
		else {
			int m = (r + l) / 2;
			build(2 * i + 1, l, m);
			build(2 * i + 2, m, r);
			recalc(i);
		}
	}

	void massUpd(int L, int R, int X = 0, int i = 0, int l = 0, int r = MAXN) {
		push(i);
		if (max(l, L) >= min(r, R))
			return;
		if (L <= l && r <= R) {

			push(i);
			return;
		}
		int m = (r + l) / 2;
		massUpd(L, R, X, 2 * i + 1, l, m);
		massUpd(L, R, X, 2 * i + 2, m, r);
		recalc(i);
	}

	int get(int L, int R, int X = 0, int i = 0, int l = 0, int r = MAXN) {
		push(i);
		if (max(l, L) >= min(r, R)) {
			return 0; // neutral!
		}
		if (L <= l && r <= R) {
			return 1; // t[i]
		}
		int m = (r + l) / 2;
		int a1 = get(L, R, X, 2 * i + 1, l, m);
		int a2 = get(L, R, X, 2 * i + 2, m, r);
		return a1 + a2; // or smthg else
	}
}
namespace sparce {
	const int K = 30;
	const int MAXN = 1e5;

	int table[K][MAXN];
	int logs[MAXN];
	void init() {
		for (int i = 2; i < MAXN; i++) {
			logs[i] = logs[i / 2] + 1;
		}
	}
	void initSparce() {
		for (int j = 1; j < K; j++) {
			int p = (1<<(j - 1));
			for (int i = 0; i + p < MAXN; i++) {
				table[j][i] = max(table[j - 1][i], table[j - 1][i + p]);
			}
		}
	}

	int get(int l, int r) {
		int sz = r - l;
		int lg = logs[sz];
		return max(table[lg][l], table[lg][r - (1<<lg)]);
	}
}
namespace myHash {
	const int MAXN = 1e5;
	const ll M = 1e9 + 9;
	const ll P = 59;
	struct hasher {
		ll hashes[MAXN];
		ll pows[MAXN];
		hasher(string& s) {
			hashes[0] = s[0];
			for (int i = 1; i < s.length(); i++) {
				hashes[i] = (hashes[i - 1] * P + s[i]) % M;
			}
			pows[0] = 1;
			for (int i = 1; i < s.length(); i++) {
				pows[i] = (pows[i - 1] * P) % M;
			}
		}
		ll get(int l, int r) {
			if (l == 0)
				return hashes[r - 1];
			ll toRem = (hashes[l - 1] * pows[r - l]) % M;
			return (hashes[r - 1] + M - toRem) % M;
		}
	};
}

void solve() {
	int n;
	cin >> n;
	vector<int> arr(n);
	input(arr);
	sort(arr.begin(), arr.end());
	reverse(arr.begin(), arr.end());
	cout << arr[0] + arr[1] << "\n";
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}