#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

multiset<ll> cur;
ll sm;
bool can;

void rec(ll w) {
    if (w < *cur.begin()) return;
    if (cur.find(w) != cur.end()) {
        cur.erase(cur.find(w));
    } else {
        if (w == 1) return;
        rec(w / 2);
        if (!cur.empty()) {
            rec(w - w / 2);
        } else {
            can = false;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    sm = 0;
    cur.clear();
    can = true;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        cur.insert(x);
        sm += x;
    }
    rec(sm);
//    while (cur.size() != 1) {
//        int a = *cur.begin(), b = *(++cur.begin());
//        if (a + 1 >= b) {
//            cur.erase(cur.begin());
//            cur.erase(cur.begin());
//            cur.insert(a + b);
//        } else {
//            cout << "NO" << en;
//            return;
//        }
//    }
    cout << (cur.empty() ? "YES" : "NO") << en;
}

int32_t main() {
    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}