#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>
#define f first
#define s second
//#define x first
//#define y second
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define _ << ' ' <<
#define pb push_back
#define Time() clock() / (ld) CLOCKS_PER_SEC

#ifdef LOCAL
	#define cerr cout
#else
	#define cerr if(0) cout
#endif

using namespace std;

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;
// using oredred_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef pair<long double, long double> pld;

const int MAXN = 2e5 + 10, MOD = 998244353;

struct Edge{
	int to, x, y;

	Edge(int to = 0, int x = 0, int y = 0): to(to), x(x), y(y) {};
};

int mul(int x, int y) {
	return 1ll * x * y % MOD;
}

int pw(int x, int y) {
	if (y == 0) return 1;
	if (y & 1) return mul(x, pw(x, y - 1));
	return pw(mul(x, x), y / 2);
}

vector<pii> r[MAXN];

void prec() {
	int cnt;
	for (int i = 2; i < MAXN; i++) {
		int x = i;
		for (int c = 2; c * c <= x; c++) {
			cnt = 0;
			if (x % c != 0) continue;
			while (x % c == 0) {
				x /= c;
				cnt++;
			}
			r[i].push_back({c, cnt});
		}
		if (x != 1) r[i].push_back({x, 1});
	}
}

vector<Edge> g[MAXN];

int minC[MAXN];

int nowc[MAXN];
int vers[MAXN];

int nowt = 1;

set<int> upd;

void dfs(int v, int p) {
	int to, x, y;
	for(auto e : g[v]) {
		to = e.to, x = e.x, y = e.y;
		if (to == p) continue;
		for (auto [c, cnt] : r[x]) {
			nowc[c] += cnt;
		}
		for (auto [c, cnt] : r[y]) {
			nowc[c] -= cnt;
			if (vers[c] != nowt) {
				minC[c] = 0;
				vers[c] = nowt;
			}
			if (nowc[c] < minC[c]) {
				minC[c] = nowc[c];
				upd.insert(c);
			}
		}
		dfs(to, v);
		for (auto [c, cnt] : r[x]) {
			nowc[c] -= cnt;
		}
		for (auto [c, cnt] : r[y]) {
			nowc[c] += cnt;
		}
	}
}

int add(int x, int y) {
	return (x + y < MOD ? x + y : x + y - MOD);
}

int ans;

void dfsAns(int v, int p, int now) {
	// cerr << "dfsAns" _ v + 1 _ now << endl;
	ans = add(ans, now);
	int to, x, y, z;
	for (auto e : g[v]) {
		to = e.to, x = e.x, y = e.y;
		if (to == p) continue;
		z = now;
		for (auto [c, cnt] : r[x]) {
			z = mul(z, pw(c, cnt));
		}
		for (auto [c, cnt] : r[y]) {
			z = mul(z, pw(pw(c, cnt), MOD - 2));
		}
		dfsAns(to, v, z);
	}
}

void solve() {
	int n;
	cin >> n;
	int v, to, x, y;
	fill(g, g + n, vector<Edge> ());
	for (int i = 0; i < n - 1; i++) {
		cin >> v >> to >> x >> y;
		g[--v].push_back(Edge(--to, y, x));
		g[to].push_back(Edge(v, x, y));
	}
	// cerr << "input!" << endl;
	nowt++;
	set<int> ().swap(upd);
	dfs(0, -1);
	int now = 1;
	for (auto c : upd) {
		now = mul(now, pw(c, -minC[c]));
		// cerr << "maxCnt" _ c _ -minC[c] << endl;
	}
	ans = 0;
	dfsAns(0, -1, now);
	cout << ans << '\n';
}

signed main() {
	prec();
	cout << fixed << setprecision(10);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	cin >> tests;
	while (tests--) {
		solve();
	}
	return 0;
}