#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

int solve(int n, vector <int> a){
        vector <map <int, int>> cnt(1e5 + 1);
        for(int i = 0; i < n; i++){
            for(int j = 0; j <= 1e5 && i * j <= 1e5; j++){
                cnt[j][a[i] - j * i]++;
            }
        }
        int ma = 0;
        for(auto i : cnt){
            for(auto j : i)
               ma = max(ma, j.second);
        }
        return n - ma;
}

signed main(){
    int t = 1;
    while(t--){
        int n;
        cin >> n;
        vector <int> a(n);
        for(auto &i : a){
          cin >> i;
        } 
        vector <int> b = a;
        reverse(all(b));
        cout << min(solve(n, a), solve(n, b)) << '\n';
    }
}