#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

//tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update> Set;
//
//const int RANDOM = std::chrono::system_clock::now().time_since_epoch().count();
//struct chash {
//    int operator()(int x) {
//        return x ^ RANDOM;
//    }
//};
//
//gp_hash_table<int, int, chash> table;

typedef long long ll;

void solve() {
    int n;
    std::cin >> n;
    std::map<ll, int> initCnt;
    std::multiset<ll> vals;
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        ll val;
        std::cin >> val;
        initCnt[val]++;
        sum += val;
    }
    vals.insert(sum);
    while (!initCnt.empty() && vals.size() <= n) {
        ll now = *vals.rbegin();
        vals.erase(--vals.end());
        if (initCnt.rbegin()->first > now) {
            break;
        }
        if (initCnt.count(now)) {
            initCnt[now]--;
            if (initCnt[now] == 0) initCnt.erase(now);
            continue;
        }
        if (now == 1) break;
        if (initCnt.count(now / 2)) {
            initCnt[now / 2]--;
            if (initCnt[now / 2] == 0) initCnt.erase(now / 2);
        } else {
            vals.insert(now / 2);
        }

        if (initCnt.count((now + 1) / 2)) {
            initCnt[(now + 1) / 2]--;
            if (initCnt[(now + 1) / 2] == 0) initCnt.erase((now + 1) / 2);
        } else {
            vals.insert((now + 1) / 2);
        }
    }

    std::cout << (initCnt.empty() ? "YES\n" : "NO\n");
}

int main() {
    int t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
}
