#include<bits/stdc++.h>
#pragma GCC optimize("unroll-loops,O3,Ofast")
using namespace std;
#define ll long long
#define ld long double
#define mpa make_pair
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
const int inf = 1e9 + 228;
const ll infll = (ll)1e18 + 228;
const ll mod = 998244353;
mt19937 gen(time(0));
const int MAXN = 2e5 + 228;
vector<ll> primes;
ll minDiv[MAXN];
vector<tuple<ll, ll, ll>> g[MAXN];
vector<pair<ll, ll>> fact(ll x) {
    vector<pair<ll, ll>> res;
    while (x != 1) {
        ll curMinDiv = minDiv[x];
        ll cnt = 0;
        while (minDiv[x] == curMinDiv) {
            ++cnt;
            x /= minDiv[x];
        }
        res.pb(curMinDiv, cnt);
    }
    return res;
}
ll bp(ll a, ll b) {
    if (b == 0) {
        return 1;
    } else if (b % 2) {
        return a * bp(a, b - 1) % mod;
    } else {
        ll res = bp(a, b / 2);
        return (res * res) % mod;
    }
}
ll inv(ll x) {
    return bp(x, mod - 2);
}
ll proc(ll x, ll y) {
    if (y >= 0) return bp(x, y);
    else return inv(bp(x, -y));
}
ll ans = 0;
ll curSum = 1;
ll powers[MAXN], maxPower[MAXN];
void dfs(int v, int anc) {
    ans = (ans + curSum) % mod;
    for (auto [to, toMul, toDiv] : g[v]) {
        if (to == anc) continue;
        vector<pair<ll, ll>> factMul = fact(toMul);
        vector<pair<ll, ll>> factDiv = fact(toDiv);
        vector<int> primeWas;
        for (auto [x, y] : factMul) primeWas.pb(x);
        for (auto [x, y] : factDiv) primeWas.pb(x);
        sort(all(primeWas));
        primeWas.erase(unique(all(primeWas)), primeWas.end());
        vector<pair<ll, ll>> prevValues;
        for (auto x : primeWas) prevValues.pb(x, powers[x]);
        for (auto x : primeWas) curSum = curSum * inv(proc(x, powers[x])) % mod;
        for (auto [x, y] : factMul) powers[x] += y;
        for (auto [x, y] : factDiv) powers[x] -= y;
        for (auto x : primeWas) curSum = curSum * proc(x, powers[x]) % mod;
        for (auto x : primeWas) {
            if (powers[x] < 0) {
                maxPower[x] = max(maxPower[x], -powers[x]);
            }
        }
        dfs(to, v);
        for (auto x : primeWas) curSum = curSum * inv(proc(x, powers[x])) % mod;
        for (auto [x, y] : prevValues) powers[x] = y;
        for (auto x : primeWas) curSum = curSum * proc(x, powers[x]) % mod;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    minDiv[1] = 1;
    for (ll i = 2; i < MAXN; ++i) {
        if (!minDiv[i]) {
            primes.pb(i);
            for (ll j = 1; i * j < MAXN; ++j) {
                if (!minDiv[i * j]) {
                    minDiv[i * j] = i;
                }
            }
        }
    }
    int T__ = 1;
    cin >> T__;
    while (T__-->0) {
        int n;
        cin >> n;
        for (int i = 0; i < n; ++i) g[i].clear();
        for (int i = 0; i + 1 < n; ++i) {
            ll x, y, A, B;
            cin >> x >> y >> A >> B;
            g[x - 1].pb(y - 1, B, A);
            g[y - 1].pb(x - 1, A, B);
        }
        ans = 0;
        ll bigMul = 1;
        dfs(0, -1);
        for (auto x : primes) {
            if (maxPower[x] > 0) {
                bigMul = bigMul * proc(x, maxPower[x]) % mod;
            }
            maxPower[x] = powers[x] = 0;
        }
        cout << ans * bigMul % mod << '\n';
    }
}
