#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <stack>

using namespace std;

#define khan ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define ll long long
#define pii pair < int, int >
#define pb push_back

const int N = 2e5 + 5, mod = 1e9 + 7 , INF = 1e9 + 7;

const ll BIG = 1e18;

const int block = 316;

const int base = 1000000000;
const int base_digits = 9;

const int tox[] = {0, 0, 1, -1}, toy[] = {1, -1, 0, 0};

const double eps = (double)1e-9;

int n, a[N];

map < ll, int > cnt;

int cond1;

void clear(){
    cnt.clear();
    for(int i = 1; i <= n; i++){
        a[i] = 0;
    }
    n = 0;
}

int dfs(ll v){
    if(v <= 1){
        //cout << v << endl;
        if(!v)
            return 1;
        if(cnt[1] > 0){
            cnt[1]--;
            return 1;
        }
        else{
            cout << "NO\n";
            return 0;
        }
    }
    if(cnt[(v + 1) / 2] > 0){
        cnt[(v + 1) / 2]--;
    }
    else{
//        q.push((v + 1) / 2);
        int ans = dfs((v + 1) / 2);
        if(ans == 0)
            return 0;
    }
    if(cnt[v / 2] > 0){
        cnt[v / 2]--;
    }
    else{
        //q.push(v / 2);
        int ans = dfs(v / 2);
        if(!ans)
            return 0;
    }
    return 1;
}

void solve(){
    cin >> n;
//    n = 2e5;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
//        a[i] = 1e9;
        cnt[a[i]]++;
    }
    if(n == 1){
        cout << "YES\n";
        return;
    }
//    sort(a + 1, a + n + 1);
    ll x = 0;
    for(int i = 1; i <= n; i++){
        x += a[i];
    }
    //cnt[x]--;
    int ans = dfs(x);
    if(!ans)
        return;
    for(int i = 1; i <= n; i++){
        if(cnt[a[i]] > 0){
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

int main(){
    khan
    int q;
    cin >> q;
    while(q--){
        solve();
        clear();
    }
}
