//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& i : (x)) cerr << i << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::::::::::::::::::::

void solve() {
    string s;
    cin >> s;

    int n = s.size();
    vector<queue<int>> pos(26);
    for (int i = 0; i < n; ++i)
        pos[s[i] - 'a'].emplace(i);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        pos[s[i] - 'a'].pop();
        if (pos[s[i] - 'a'].empty()) {
            ans = i;
            break;
        }
    }
    for (int i = ans; i < n; ++i)
        cout << s[i];
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}

