#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

#define all(x) x.begin(), x.end()
#define nl '\n'
#define deb(x) cout << #x << " = " << x << ' ';
#define deb(x) cout << #x << " = " << x << nl;
#define rep(n) for (int i = 0; i < (n); i++)


typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ll> pll;
typedef double D;
typedef long double LD;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<vvpll> vvvpll;

template<class T> void print(T a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << nl;
}

template<class T> void print2(T a) {
	for (auto x : a) {
		print(x);
	}
	cout << nl;
}

void fastio() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void solve() {
	string s;
	int n;
	cin >> s;
	n = s.size();
	vi pos(150, n);
	for (int i = n - 1; i >= 0; i--) {
		if (pos[s[i]] == n) pos[s[i]] = i;
	}
	int res = 0;
	for (int i = 0; i < n; i++) {
		if (pos[s[i]] <= i) break;
		res++;
	}
	for (int i = res; i < n; i++) {
		cout << s[i];
	}
	cout << nl;
}

signed main() {
	fastio();
	int t;
	cin >> t;
	while (t) {
		solve();
		t--;
	}
}