#include <bits/stdc++.h>
using namespace std;
typedef long long lint;
#define endl '\n';
#define fixed() {ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);}
#define print(a) {for (auto xyz : a) cout << xyz << " "; cout << endl;}
#define pb push_back
#define multitest() lint txyz; cin >> txyz; for (txyz; txyz; txyz--)

// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_pbds;
// typedef tree<lint, null_type, less<lint>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;
struct edge{
	lint b, x, y;
};
lint n; 
vector<vector<edge>> graph;
vector<lint> mn(200000, 0);
vector<lint> up(200000, 0);
vector<lint> down(200000, 0);
vector<lint> pr(200000, -1);
void dfs(lint v, lint p){
	// cout << v << endl;
	// for (lint i = 0; i < 10; i++){
	// 	cout << up[i] << " ";
	// }
	// cout << endl;
	// for (lint i = 0; i < 10; i++){
	// 	cout << down[i] << " ";
	// }
	// cout << endl;
	for (auto h : graph[v]){
		if (h.b == p) continue;
		lint x = h.x;
		lint y = h.y;
		// cout << x << " " << y << endl;
		while (x > 1){
			up[pr[x]]++;
			x /= pr[x];
		}
		while (y > 1){
			down[pr[y]]++;
			lint d = pr[y];
			mn[d] = min(mn[d], up[d] - down[d]);
			y /= pr[y];
		}
		dfs(h.b, v);
		x = h.x;
		y = h.y;
		while (x > 1){
			up[pr[x]]--;
			x /= pr[x];
		}
		while (y > 1){
			down[pr[y]]--;
			y /= pr[y];
		}
	}
}
lint mod = 998244353;
lint binpow(lint x, lint p){
	if (p == 0) return 1;
	lint u = binpow(x, p / 2);
	u = (u * u) % mod;
	if (p % 2) return (u * x) % mod;
	return u;
}
lint sum = 0;
void getres(lint v, lint p, lint cur){
	// cout << v << " " << cur << endl;
	sum += cur;
	sum %= mod;
	for (auto h : graph[v]){
		if (h.b == p) continue;
		lint x = h.x;
		lint y = h.y;
		// cout << x << " " << y << endl;
		lint nxt;
		nxt = (cur * x) % mod;
		nxt = (nxt * binpow(y, mod - 2)) % mod;
		getres(h.b, v, nxt);
	}
}
int main(){
	fixed();
	for (lint i = 2; i < 200000; i++){
		if (pr[i] != -1) continue;
		pr[i] = i;
		for (lint j = 2 * i; j < 200000; j += i){
			if (pr[j] == -1) pr[j] = i;
		}
	}
	multitest(){
		sum = 0;
		cin >> n;
		mn.assign(n + 100, 0);
		up.assign(n + 100, 0);
		down.assign(n + 100, 0);
		graph.assign(n, vector<edge>());
		for (lint i = 0; i < n - 1; i++){
			lint a, b, x, y; cin >> a >> b >> x >> y; a--; b--;
			graph[a].pb({b, y, x});
			graph[b].pb({a, x, y});
		}
		dfs(0, 0);
		// for (lint i = 0; i < 10; i++) cout << i << " " << mn[i] << "; " << endl;
		lint x = 1;
		for (lint i = 2; i <= n; i++){
			if (mn[i] >= 0) continue;
			 // cout << binpow(i, mod - 2) * i % mod << endl;
			lint cur = binpow(i, -mn[i]);
			// if (i < 10) cout << cur << endl;
			x = (x * cur) % mod;
		}
		// cout << x << endl;
		getres(0, 0, x);
		cout << sum << endl;

	}
}
