#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define ld long double
#define pii pair<int, int>
#define fi first
#define se second
#define sz(a) (int)a.size()

const int N = 5e7;
int cnt[2 * N];

int getRes(vector<int> &a, int d, int l , int r) {
    vector<int> w;
    for (int i = l; i <= r; ++i) {
        if(a[i] - i * d + N < 0 || a[i] - i * d + N >= 2 * N)
            return 0;

        w.push_back(a[i] - i * d + N);
        cnt[a[i] - i * d + N]++;
    }

    int mx = 0;
    for(int i : w){
        ckmax(mx, cnt[i]);
        cnt[i] = 0;
    }
    return mx;
}

const int B = 700;

int calc(vector<int> &a) {
    int mx = 0;
    for (int d = 0; d <= B; ++d) {
        ckmax(mx, getRes(a, d, 0, sz(a) - 1));
    }

    vector<pair<int, pii>> w;

    for(int l = 0; l < sz(a); ++l){
        for(int r = l + 1; r < min(sz(a), l + B); ++r){
            if((a[r] - a[l]) % (r - l) == 0)
                w.push_back({(a[r] - a[l]) / (r - l), {l, r}});
        }
    }


    for(int i = 0; i < sz(w); ++i){
        int d = w[i].fi, l = w[i].se.fi, r = w[i].se.se; 
        ckmax(mx, getRes(a, d, l, r));
    }

    return mx;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    if(n == 1){
        cout << 0;
        return 0;
    }
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    int res = 0;
    ckmax(res, calc(a));
    reverse(all(a));
    ckmax(res, calc(a));

    cout << n - res;
}