#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back

const int N = 1e5 + 10, K = 400;
int ans = 0;

void solve(int n, vector<int> a) {
    for (int j = 0; j < K; j++) {
        map<int,int> mp;
        if (j > 0 && ans > (N + j - 1) / j) break;
        for (int i = 0; i < n; i++) {
            mp[a[i] + i * j]++;
        }
        for (auto to : mp) {
            ans = max(ans, to.second);
        }
    }
    int mx = (N + K - 1) / K + 3;
    vector<map<int,int>> bst(n);
    for (int i = n - 1; i >= 0; i--) {
        for (int j = i + 1; j < min(n, i + K); j++) {
            int val = a[j] - a[i];
            if (val >= 0 && val % (j - i) == 0) {
                int x = val / (j - i);
                if (x < K) continue;
                if (bst[j].find(x) != bst[j].end()) {
                    bst[i][x] = bst[j][x] + 1;
                } else {
                    bst[i][x] = 1;
                }
                ans = max(ans, bst[i][x]);
            }
        }
    }
}

vector<int> rev(vector<int> a) {
    reverse(a.begin(), a.end());
    return a;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    solve(n, a), solve(n, rev(a));
    cout << n - ans << endl;
    return 0;
}
