#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
#define int long long
using namespace std;
//typedef tree<int,null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int mod = 998244353;
const int maxn = 2e5;
vector <pair<int, pair < int, int>>> g[maxn];
int num[maxn];
int minp[maxn + 1];
vector<int> prime;
int x[maxn];
int y[maxn];

void dfs(int v, int p) {
    for (auto to: g[v]) {
        if (to.first == p)continue;
        x[to.first] = to.second.first;
        y[to.first] = to.second.second;
        dfs(to.first, v);
    }
}

int elem[maxn + 1];
int need[maxn + 1];

void calc(int v, int p) {
    if (p != -1) {
        int o = y[v];
        while (o != 1) {
            int pr = minp[o];
            elem[pr]++;
            o /= pr;
        }
        o = x[v];
        while (o != 1) {
            int pr = minp[o];
            elem[pr]--;
            need[pr] = min(need[pr], elem[pr]);
            o /= pr;
        }
    }
    for (auto to: g[v]) {
        if (to.first == p)continue;
        calc(to.first, v);
    }
    if (p != -1) {
        int o = y[v];
        while (o != 1) {
            int pr = minp[o];
            elem[pr]--;
            o /= pr;
        }
        o = x[v];
        while (o != 1) {
            int pr = minp[o];
            elem[pr]++;
            o /= pr;
        }
    }
}

int pw(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        int yy = pw(a, b / 2);
        return yy * yy % mod;
    } else {
        return pw(a, b - 1) * a % mod;
    }
}

int A = 1;

void calc_num(int v, int p, int last) {
    if (p == -1) {
        num[v] = last;
    } else {
        num[v] = last * y[v] % mod * pw(x[v], mod - 2) % mod;
    }
    for (auto to: g[v]) {
        if (to.first == p)continue;
        calc_num(to.first, v, num[v]);
    }
}

signed main() {
    cin.tie();
    cout.tie();
    for (int i = 2; i <= maxn; ++i) {
        if (minp[i] == 0) {
            minp[i] = i;
            prime.push_back(i);
        }
        for (int j = 0; j < prime.size(); ++j) {
            if (prime[j] * i > maxn || prime[j] > minp[i]) {
                break;
            }
            minp[prime[j] * i] = prime[j];
        }
    }
    int Z;
    cin >> Z;
    while (Z--) {
        int n;
        cin >> n;
        A = 1;
        for (int i = 0; i < n; ++i) {
            g[i].clear();
            elem[i + 1] = 0;
            need[i + 1] = 0;
            num[i] = 0;
        }
        for (int i = 0; i < n - 1; ++i) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            int x, y;
            cin >> x >> y;
            g[a].push_back({b, {x, y}});
            g[b].push_back({a, {y, x}});
        }
        dfs(0, -1);
        calc(0, -1);
        for (int i = 1; i <= n; ++i) {
            for (int j = 0; j < -need[i]; ++j) {
                A *= i;
                A %= mod;
            }
        }
        calc_num(0, -1, A);
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            sum += num[i];
            sum %= mod;
        }
        cout << sum << "\n";
    }
}