#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "iomanip"
#include "bitset"
#include "set"
#include "array"
#include "map"
#define all(x) x.begin(), x.end()
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int res = 1;
    for (int i = -600; i <= 600; ++i) {
        map<int, int> cnt;
        for (int j = 0; j < n; ++j) {
            cnt[a[j] + i * j]++;
        }
        int mx = 0;
        for (auto q : cnt)
            mx = max(q.second, mx);
        res = max(res, mx);
    }
    for (int i = 0; i < n; ++i) {
        map<int, int> cnt;
        for (int j = max(0, i - 300); j < min(n, i + 300); ++j) {
            if (i == j)
                continue;
            if ((a[j] - a[i]) % (j - i) == 0)
                cnt[(a[j] - a[i]) / (j - i)]++;
        }
        int mx = 0;
        for (auto q : cnt)
            mx = max(q.second + 1, mx);
        res = max(res, mx);
    }
    cout << n - res << '\n';
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
}
