/**

The_Rubbish

TTTTT h            RRRRR         b      b                  h
T T T h            R   R         b      b       i          h
  T   hhh eee      R   R  u  u   bbbb   bbbb   iii   ssss  hhh
  T   h h e e      RRRRR  u  u   b   b  b   b   i   s      h h
  T   h h eee      RRR    u  u   b   b  b   b   i    sss   h h
  T   h h e        R  R   u  u   b   b  b   b   i       s  h h
  T   h h eee ____ R   R  uuu u  bbbb   bbbb   iii  ssss   h h

**/

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define pb push_back
#define pii pair < int, int >
#define ld long double 
#define endl '\n'

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > oset;

const int N = 200007, MOD = 1000000007;

int st(int a, int b)
{
	if (b == 0) return 1;
	if (b == 1) return a;
	int ans = st(a, b / 2);
	ans *= ans;
	ans %= MOD;
	if ((b & 1) > 0) 
	{
		ans *= a;
	    ans %= MOD;
	}
	return ans;
}

bool is_prime(int x)
{
	if ((x & 1) > 0)
	{
		if (x == 2) return true;
		return false;
	}
	for (int i = 3;i <= sqrt(x);i += 2)
		if (x % i == 0) return false;
	return (x > 1);
}

struct segtree
{
	int t[N * 4], dop[N * 4];
	void build(int v, int l, int r, int A[])
	{
		if (l == r)
		{
			t[v] = A[l];
			dop[v] = -1;
			return;
		}
		int mid = (l + r) / 2;
		build(v * 2, l, mid, A);
		build(v * 2 + 1, mid + 1, r, A);
		t[v] = t[v * 2] + t[v * 2 + 1];
		dop[v] = -1;
	}
	void push(int v)
	{
		if (dop[v] == -1) return;
		t[v] += dop[v];
		dop[v * 2] += dop[v];
		dop[v * 2 + 1] += dop[v];
		dop[v] = -1;
	}
	int get(int v, int l, int r, int cl, int cr)
	{
		if (cr < l || cl > r) return 0;
		push(v);
		if (cl <= l && r <= cr) return t[v];
		int mid = (l + r) / 2;
		return get(v * 2, l, mid, cl, cr) + get(v * 2 + 1, mid + 1, r, cl, cr);
	}
	void upd(int v, int l, int r, int cl, int cr, int x)
	{
		if (cr < l || cl > r) return;
		push(v);
		if (cl <= l && r <= cr)
		{
			dop[v] += x;
			push(v);
		}
		int mid = (l + r) / 2;
		upd(v * 2, l, mid, cl, cr, x);
		upd(v * 2 + 1, mid + 1, r, cl, cr, x);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
};

void solve()
{
	string s;
	cin >> s;
	string ans = "";
	bool p[26];
	for (int i = 0;i < 26;i++)
		p[i] = 0;
	int pos = s.size() - 1;
	for (int i = s.size() - 1;i >= 0;i--)
		if (p[s[i] - 'a'] == 0) 
		{
			p[s[i] - 'a'] = 1;
			pos = i;
		}
	for (int i = pos;i < s.size();i++)
		cout << s[i];
	cout << endl;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif // LOCAL
	int t;
	cin >> t;
	while (t--)
		solve();
}
