#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 1e5;
const int A = 26;

ll gcd(ll a, ll b)
{
    while (b)
    {
        a %= b;
        swap(a, b);
    }
    return a;
}

struct Node{
    vector <int> g;
    Node()
    {
        for (int i = 0; i < A; i++)
            g.push_back(-1);
    }
};

struct Point{
    ll x;
    ll y;
    Point() : x(0), y(0) {};
    Point(ll _x, ll _y) : x(_x), y(_y) {};

    Point operator- (const Point& a)
    {
        return {x - a.x, y - a.y};
    }
    Point operator+ (const Point& a)
    {
        return {x + a.x, y + a.y};
    }
    Point operator* (ld k)
    {
        return {x * k, y * k};
    }
    ll len()
    {
        return x * x + y * y;
    }
    ld len2()
    {
        return sqrt(len());
    }
};

ll vec(Point a, Point b)
{
    return a.x * b.y - a.y * b.x;
}
ll skal(Point a, Point b)
{
    return a.x * b.x + a.y * b.y;
}



int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        string s;
        cin >> s;
        vector <int> a(A, 0);
        for (int i = 0; i < s.size(); i++)
            a[s[i] - 'a']++;
        bool ok = false;
        for (int i = 0; i < s.size(); i++)
        {
            if (!ok)
            {
                if (a[s[i] - 'a'] == 1)
                    ok = true;
                else
                    a[s[i] - 'a']--;
            }
            if (ok)
                cout << s[i];
        }
        cout << "\n";
    }
}
