#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll

const int MOD = 998244353;
const int MAXN = 2e5 + 100;
vector<vector<int> > sp[MAXN];
int mp[MAXN];
int used[MAXN];
int r[MAXN];
int rev[MAXN];
int tot = 0;
int used_cnt = 0;

int gcd(int x, int y) {
	if (y == 0) {
		return x;
	}
	return gcd(y, x % y);
}

int fast_pow(int x, int y) {
	if (y == 0) {
		return 1;
	}
	if (y % 2 == 0) {
		return fast_pow(x * x % MOD, y / 2);
	}
	else {
		return x * fast_pow(x, y - 1) % MOD;
	}
}

void prec() {
	r[1] = 1;
	rev[1] = 1;
	for (int x = 2; x < MAXN; ++x) {
		rev[x] = fast_pow(x, MOD - 2);
		if (r[x] == 0) {
			r[x] = x;
			for (int y = x * x; y < MAXN; y += x) {
				if (r[y] == 0) {
					r[y] = x;
				}
			}
		}
	}
}

void devide(int x) {
	while(x != 1) {
		if (used[r[x]] != used_cnt) {
			used[r[x]] = used_cnt;
			mp[r[x]] = 0;
		}
		mp[r[x]]--;
		x /= r[x];
	}
}

void power(int x) {
	while(x != 1) {
		if (used[r[x]] != used_cnt) {
			used[r[x]] = used_cnt;
			mp[r[x]] = 0;
		}
		mp[r[x]]++;
		x /= r[x];
	}
}

int get_gcd(int x) {
	int ans = 1;
	vector<int> log;
	while(x != 1) {
		if (used[r[x]] != used_cnt) {
			used[r[x]] = used_cnt;
			mp[r[x]] = 0;
		}
		if (mp[r[x]] != 0) {
			ans *= r[x];
			mp[r[x]]--;
			log.push_back(r[x]);	
		}
		x /= r[x];
	}
	for (auto el : log) {
		++mp[el];
	}
	return ans;
}

int dfs(int u, int p, int now) {
	int v, x, y;
	tot = (tot + now) % MOD;
	int pw = 1;
	for (auto vec : sp[u]) {
		v = vec[0];
		x = vec[1];
		y = vec[2];
		if (v == p) {
			continue;
		}
		int g = get_gcd(x);
		pw = (pw * x / g) % MOD;
		now = (now * x / g) % MOD;
		tot = (tot * x / g) % MOD;
		// power(d, x);
		devide(g);
		power(y);
		// devide(d, x);
		int tmp = dfs(v, u, (now * rev[x] % MOD) * y % MOD);
		pw = (pw * tmp) % MOD;
		now = (now * tmp) % MOD;
		devide(y);
		power(x);
	}
	return pw;
}

void solve() {
	++used_cnt;
	int n;
	cin >> n;
	int u, v, x, y;
	for (int i = 0; i < n - 1; ++i) {
		cin >> u >> v >> x >> y;
		--u;
		--v;
		int g = gcd(x, y);
		sp[u].push_back({v, x / g, y / g});
		sp[v].push_back({u, y / g, x / g});
	}
	int st = 0;
	for (int i = 0; i < n; ++i) {
		if (sp[i].size() == 1) {
			st = i;
			break;
		}
	}
	dfs(st, -1, 1);
	cout << tot << endl;
	for (int i = 0; i < n; ++i) {
		sp[i].clear();
		tot = 0;
	}
	return;
}

int32_t main() {
	// freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	prec();
	int tests = 1;
	cin >> tests;
	while(tests--) {
		solve();
	}
}