#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x)  (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;

int n;
const int maxn = 100005;
const int block = 50;
vector<int> a;

int ans = 0;


void solve(int d) {
    map<ll, ll> mp;
    for (ll i = 0; i < n; i++) {
        ll tv = a[i] - i * d;
        mp[tv]++;
    }

    for (auto p: mp) {
        ans = max(ans, (int)p.second);
    }
}

int cnt[maxn * 2];

void solve2() {
    for (int i = 0; i < n; i++) {
        vector<int> tc;
        for (int j = i + 1; j <= min(n - 1, i + maxn / block); j++) {
            int dv = a[j] - a[i];
            if (abs(dv) % (j - i)) continue;
            dv /= (j - i);
            tc.push_back(dv + maxn);
            cnt[dv + maxn]++;
        }

        for (int x: tc) {
            ans = max(ans, cnt[x] + 1);
        }

        for (int x: tc) cnt[x]--;
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    map<int, int> ts;
    for (int x: a) {
        ts[x]++;
    }
    for (auto p: ts) {
        ans = max(ans, p.second);
    }
    for (int d = 1; d <= block; d++) {
        solve(d);
    }
    reverse(all(a));

    for (int d = 1; d <= block; d++) {
        solve(d);
    }
    solve2();

    cout << n - ans << nl;
}
