#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <algorithm>
#include <map>
#include <string>
#include <numeric>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <queue>

using namespace std;

using ll = long long;
using ld = long double;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;
template <typename... T>
using tup = tuple<T...>;

template <typename A, typename B>
inline istream& operator>> (istream& in, pa<A, B>& p);

template <typename T>
inline istream& operator>> (istream& in, v<T>& a) {
	for (T& t : a) {
		in >> t;
	}
	return in;
}

template <typename A, typename B>
inline istream& operator>> (istream& in, pa<A, B>& p) {
	return in >> p.first >> p.second;
}

inline void solve() {
	ll n;
	cin >> n;
	v<ll> a(n);
	cin >> a;
	ll s = accumulate(a.begin(), a.end(), 0ll);
	map<ll, ll> m;
	for (ll x : a) {
		++m[x];
	}
	map<ll, ll> m2;
	m2[s] = 1;
	while (m2.size() > 0) {
		ll x = m2.rbegin()->first;
		ll cnt = m2[x];
		m2.erase(x);
		cnt -= m[x];
		if (cnt > 0) {
			if (x == 1) {
				cout << "NO\n";
				return;
			}
			ll a = x / 2;
			ll b = (x + 1) / 2;
			m2[a] += cnt;
			m2[b] += cnt;
		}
	}
	cout << "YES\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}