#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MAXN = 2e5 + 10;
const int mod = 998244353;
const long long inf = 1e18;

int lp[MAXN];

void dfs(int v, int p, vector<vector<array<int, 3> > > &g, vector<int> &cur, vector<int> &need) {
    for (auto &[to, x, y] : g[v]) {
        if (to == p)
            continue;
        int k = 0;
        k = y;
        vector<pair<int, int> > was;
        while (k > 1) {
            was.push_back({lp[k], -1});
            cur[lp[k]]++;
            k /= lp[k];
        }
        k = x;
        while (k > 1) {
            if (cur[lp[k]] > 0) {
                was.push_back({lp[k], +1});
                cur[lp[k]]--;
            } else {
                need.push_back(lp[k]);
                was.push_back({lp[k], +1});
            }
            k /= lp[k];
        }
        dfs(to, v, g, cur, need);
        for (int i = (int)was.size() - 1; i >= 0; i--) {
            cur[was[i].fi] += was[i].se;
        }
    }
}

int bpow(int a, int n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0)
        return bpow((a * a) % mod, n / 2);
    return bpow(a, n - 1) * a % mod;
}

int ans;

void get_ans(int v, int p, vector<vector<array<int, 3> > > &g, int tmp) {
    ans += tmp;
    for (auto &[to, x, y] : g[v]) {
        if (to == p)
            continue;
        int nw = tmp;
        nw *= y;
        nw %= mod;
        nw *= bpow(x, mod - 2);
        nw %= mod;
        get_ans(to, v, g, nw);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<array<int, 3> > > g(n);
    for (int i = 1; i < n; i++) {
        int a, b, x, y;
        cin >> a >> b >> x >> y;
        a--, b--;
        g[a].push_back({b, x, y});
        g[b].push_back({a, y, x});
    }
    vector<int> cur(MAXN);
    vector<int> need;
    dfs(0, 0, g, cur, need);
    ans = 0;
    int tmp = 1;
    for (auto e : need) {
        tmp *= e;
        tmp %= mod;
    }
    get_ans(0, 0, g, tmp);
    cout << ans % mod << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(10);

    lp[0] = 1;
    lp[1] = 1;
    for (int i = 2; i < MAXN; i++) {
        if (lp[i] == 0) {
            lp[i] = i;
            for (int j = i * i; j < MAXN; j += i) {
                lp[j] = i;
            }
        }
    }

    int T = 1;
    cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}