#include <iostream>
#include <set>
using namespace std;
multiset<long long> split(multiset<long long>& a, multiset<long long>& s)
{
    multiset<long long> res;
    for (auto el : s)
    {
        if (el == 1)
        {
            res.insert(1);
        }
        else
        {
            if (a.find(el / 2) != a.end())
            {
                a.erase(a.find(el / 2));
            }
            else
            {
                res.insert(el / 2);
            }
            if (a.find((el + 1) / 2) != a.end())
            {
                a.erase(a.find((el + 1) / 2));
            }
            else
            {
                res.insert((el + 1) / 2);
            }
        }
    }
    return res;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        int n;
        long long sum = 0;
        cin >> n;
        if (n == 1)
        {
            int temp;
            cin >> temp;
            cout << "YES" << '\n';
        }
        else
        {
            multiset<long long> a, s;
            for (int i = 0; i < n; i++)
            {
                long long temp;
                cin >> temp;
                sum += temp;
                a.insert(temp);
            }
            s.insert(sum);
            while (true)
            {
                s = split(a, s);
                if (s.size() > a.size())
                {
                    cout << "NO" << '\n';
                    break;
                }
                else if (s.size() == 0 && a.size() == 0)
                {
                    cout << "YES" << '\n';
                    break;
                }
            }
        }
    }
}
