#include <iostream>
#include <iomanip>
#include <vector>
#include <assert.h>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <bitset>
#include <random>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;
const ll MOD2 = 998244353;
const ll INF = 2e18;

//#define int ll
#define ve vector
#define ft first
#define sd second
#define scan(h, n) for (int ijkl = 0; ijkl < n; ++ijkl) cin >> h[ijkl];
#define pb push_back

mt19937 rnd(3241233);

ll pown(ll n, ll cnt, ll mod = (1ll << 63)) {
	if (cnt == 0) return 1;
	if (cnt == 1) return n;
	if (cnt % 2 == 0) return pown(n * n % mod, cnt / 2, mod);
	return pown(n * n % mod, cnt / 2, mod) * n % mod;
}

ve < ve < pair < ll , pair <ll, ll> > > > g;

ve<ll> cnt;
ve<ll> mx(200010, 0);
ve<ll> tec(200010, 0);
ve<int> pr[200010];
set <int> used;

void dfs(int v, int p = -1, ll koef = 1) {
	cnt[v] = koef;
	for (auto u : g[v]) {
		if (u.ft != p) {
			for (auto el : pr[u.sd.sd]) {
				--tec[el];
			}
			for (auto el : pr[u.sd.ft]) {
				++tec[el];
				if (tec[el] > 0) used.insert(el);
				mx[el] = max(mx[el], tec[el]);
			}
			dfs(u.ft, v, koef * u.sd.ft % MOD2 * pown(u.sd.sd, MOD2 - 2, MOD2) % MOD2);
			for (auto el : pr[u.sd.sd]) {
				++tec[el];
			}
			for (auto el : pr[u.sd.ft]) {
				--tec[el];
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	for (int i = 2; i <= 200000; ++i) {
		if (pr[i].empty()) {
			for (int j = i; j <= 200000; j += i) {
				int c = j;
				while (c % i == 0) {
					pr[j].pb(i);
					c /= i;
				}
			}
		}
	}
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		g.assign(n, {});
		cnt.assign(n, 1);
		for (int i = 1; i < n; ++i) {
			ll a, b, x, y;
			cin >> a >> b >> x >> y;
			--a; --b;
			g[a].pb({ b, {x, y} });
			g[b].pb({ a, {y, x} });
		}
		dfs(0);
		ll a0 = 1;	
		for (auto i : used) {
			a0 *= pown(i, mx[i], MOD2);
			a0 %= MOD2;
			mx[i] = 0;
		}
		used.clear();
		//cout << a0 << "\n";
		ll sum = 0;
		for (int i = 0; i < n; ++i) {
			sum += a0 * pown(cnt[i], MOD2 - 2, MOD2);
			sum %= MOD2;
		}
		cout << sum << "\n";
	}
	return 0;
}