#include <bits/stdc++.h>

using namespace std;

const int64_t maxa = 200005;
const int64_t mod = 998244353;

vector<vector<pair<int64_t,pair<int64_t,int64_t>>>> g;
map<int64_t,int64_t> res;
map<int64_t,int64_t> t;
int64_t mindiv[maxa] = {0};
int64_t ans = 0;

int64_t binpow(int64_t a,int64_t b)
{
    return (b == 0 ? 1 : (b%2 == 0 ? (binpow((a*a)%mod,b/2)) : (a*binpow(a,b-1))%mod));
}
int64_t del(int64_t a,int64_t b)
{
    return (a*binpow(b,mod-2))%mod;
}

void dfs(int v,int p,int64_t dr)
{
    ans += dr;
    ans = ans%mod;
    for(auto u:g[v])
    {
        if(u.first != p)
        {
            int64_t ch = u.second.first;
            int64_t zn = u.second.second;
            while(mindiv[ch])
            {
                t[mindiv[ch]]--;
                res[mindiv[ch]] = max(res[mindiv[ch]],t[mindiv[ch]]);
                ch/=mindiv[ch];
            }
            while(mindiv[zn])
            {
                t[mindiv[zn]]++;
                res[mindiv[zn]] = max(res[mindiv[zn]],t[mindiv[zn]]);
                zn/=mindiv[zn];
            }
            dfs(u.first,v,del((dr*u.second.first)%mod,u.second.second));
            ch = u.second.first;
            zn = u.second.second;
            while(mindiv[ch])
            {
                t[mindiv[ch]]++;
                ch/=mindiv[ch];
            }
            while(mindiv[zn])
            {
                t[mindiv[zn]]--;
                zn/=mindiv[zn];
            }
        }
    }
    return ;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for(int i = 2;i < maxa;++i)
    {
        if(mindiv[i] == 0)
        {
            for(int j = 2*i;j < maxa;j+=i)
            {
                mindiv[j] = i;
            }
            mindiv[i] = i;
        }
    }
    int64_t tt;
    cin >> tt;
    while(tt--)
    {
        g.clear();
        res.clear();
        t.clear();
        int64_t n;
        cin >> n;
        ans = 0;
        g.resize(n);
        for(int i = 0;i < n-1;++i)
        {
            int64_t u,v,x,y;
            cin >> u >> v >> x >> y;
            u--;
            v--;
            g[u].push_back({v,{y,x}});
            g[v].push_back({u,{x,y}});
        }
        dfs(0,-1,1);
        for(auto c:res)
        {
            for(int i = 0;i < c.second;++i)
            {
                ans*=c.first;
                ans = ans%mod;
            }
        }
        cout << ans << "\n";
    }
}
