﻿#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <string>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <random>
#include <algorithm>
#include <time.h>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair<int, int> pii;

mt19937 rng(time(0));

#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define pb push_back
#define eb emplace_back
#define Sum(x) accumulate(All(x), 0ll)
#define X first
#define Y second

const int INF = 1e9 + 5;

void solve() {
    int n, v;
    cin >> n;
    multiset<int> s;
    for (int i = 0; i < n; i++) {
        cin >> v;
        s.insert(v);
    }
    while (s.size() > 1) {
        auto a = *s.begin();
        s.erase(s.begin());
        auto b = *s.begin();
        s.erase(s.begin());
        if (abs(a - b) > 1) {
            cout << "NO\n";
            return;
        }
        s.insert(a + b);
    }
    cout << "YES\n";
}

int main()
{
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
