﻿#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <string>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <random>
#include <algorithm>
#include <time.h>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair<ll, ll> pii;

mt19937 rng(time(0));

#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define pb push_back
#define eb emplace_back
#define Sum(x) accumulate(All(x), 0ll)
#define X first
#define Y second

const ll INF = 1e9 + 5;

void solve() {
    ll n, v;
    cin >> n;
    multiset<ll> have, need;
    ll s = 0;
    for (ll i = 0; i < n; i++) {
        cin >> v;
        s += v;
        need.insert(v);
    }
    if (n == 1) {
        cout << "YES\n";
        return;
    }
    have.insert(s);
    while (need.size() > 0 && have.size() < n+2) {
        if (have.empty()) {
            cout << "NO\n";
            return;
        }
        auto f = --have.end();
        ll a = (*f) / 2, b = (*f) - a;
        if (need.find(a) != need.end()) {
            need.erase(need.find(a));
        }
        else
            have.insert(a);
        if (need.find(b) != need.end()) {
            need.erase(need.find(b));
        }
        else
            have.insert(b);
        have.erase(f);
    }
    cout << (need.empty() ? "YES\n" : "NO\n");
}

signed main()
{
    ll t = 1;
    cin >> t;
    while (t--)
        solve();
}
