﻿#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <string>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <random>
#include <algorithm>
#include <time.h>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair<ll, ll> pii;

mt19937 rng(time(0));

#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define pb push_back
#define eb emplace_back
#define Sum(x) accumulate(All(x), 0ll)
#define X first
#define Y second

const ll INF = 1e9 + 5;
const ll MAXN = 1e5;

const ll SQRT = 316;

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++)
		cin >> a[i];
	ll res = 1;
	for (ll i = 0; i < n; i++) {
		map<ll, ll> g;
		ll cur = 0;
		for (ll j = max(0ll, i - SQRT); j <= min(n - 1, i + SQRT); j++) {
			if (j == i) continue;
			ll dx = a[j] - a[i];
			ll dy = j - i;
			if (dy == 0 || dx % dy == 0)
				cur = max(cur, ++g[dx / dy]);
		}
		res = max(res, cur + 1);
	}
	for (ll d = -SQRT; d <= SQRT; d++) {
		ll ans = 0;
		map<ll, ll> cnt;
		for (ll i = 0; i < n; i++) {
			ans = max(ans, ++cnt[MAXN + a[i] - i * d]);
		}
		res = max(res, ans);
	}
	cout << n-res;
}

signed main()
{
	solve();
}
