#include <bits/stdc++.h>

using namespace std;

const int maxc = 45e6;
const int shift = 22e6;

const int maxn = 3e5;
const int shiftn = 15e4;

int c[maxc];
vector < pair <int, int> > dg[maxn];

vector <int> par(shiftn), s(shiftn);

int get_par(int x) {
    int res = x;
    while (res != par[res]) {
        res = par[res];
    }
    int y = x;
    while (y != res) {
        y = par[y];
        par[x] = res;
        x = y;
    }
    return res;
}

void unite(int x, int y) {
    x = get_par(x), y = get_par(y);
    if (x == y) return;
    if (s[x] > s[y]) {
        s[x] += s[y];
        par[y] = par[x];
    } else {
        s[y] += s[x];
        par[x] = y;
    }
}

void solve() {
    int n; cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int k = 200;
    int an = 1;
    for (int d = -k; d <= k; ++d) {
        for (int i = 0; i < n; ++i) {
            c[a[i] + d * i + shift]++;
            an = max(an, c[a[i] + d * i + shift]);
        }
        for (int i = 0; i < n; ++i) {
            c[a[i] + d * i + shift]--;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < min(n, i + shiftn / k); ++j) {
            if (abs(a[i] - a[j]) % (j - i) == 0) {
                dg[(a[i] - a[j]) / (j - i) + shiftn].push_back({i, j});
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        s[i] = 1; par[i] = i;
    }
    for (int i = 0; i < maxn; ++i) {
        for (auto [x, y] : dg[i]) {
            unite(x, y);
        }
        for (auto [x, y] : dg[i]) {
            an = max(an, s[x]);
            an = max(an, s[y]);
            s[x] = 1; s[y] = 1;
            par[x] = x; par[y] = y;
        }
    }
    cout << n - an << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t; t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
