#include <bits/stdc++.h>
//#include <bits/extc++.h>


using namespace std;

#define int long long

//using namespace __gnu_cxx;
//using namespace __gnu_pbds;

//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd();

const int N = 200005;
const int M = 998244353;


int rev(int a, int m) {
    if (a == 1) return 1;
    return (1 - rev(m % a, a) * m) / a + m;
}


vector<int> fact(int a) {
    vector<int> ans;
    for (int i = 2; i * i <= a; ++i) {
        while (a % i == 0) {
            ans.push_back(i);
            a /= i;
        }
    }
    if (a != 1) ans.push_back(a);
    return ans;
}


vector<pair<int, pair<int, int>>> gr[N];

vector<int> vec[N];

map<int, int> cnt_verg, cnt_nig, cnt_ans;
int ans = 0;

void dfs(int u, int pr) {
    for (auto c: gr[u]) {
        if (c.first == pr) continue;
        vector<pair<bool, int>> sob1, sob2;
        for (auto c2: vec[c.second.first]) {
            if (cnt_nig[c2] > 0) {
                cnt_nig[c2]--;
                sob1.push_back({false, c2});
            } else {
                cnt_verg[c2]++;
                sob1.push_back({true, c2});
            }
        }
        for (auto c2: vec[c.second.second]) {
            if (cnt_verg[c2] > 0) {
                cnt_verg[c2]--;
                sob2.push_back({false, c2});
            } else {
                cnt_nig[c2]++;
                sob2.push_back({true, c2});
                cnt_ans[c2] = max(cnt_ans[c2], cnt_nig[c2]);
            }
        }
        dfs(c.first, u);

        for (auto c2: sob1) {
            if (c2.first) {
                cnt_verg[c2.second]--;
            } else {
                cnt_nig[c2.second]++;
            }
        }

        for (auto c2: sob2) {
            if (c2.first) {
                cnt_nig[c2.second]--;
            } else {
                cnt_verg[c2.second]++;
            }
        }
    }
}

void dfs2(int u, int pr, int now) {
    ans += now;
    ans %= M;
    for (auto c: gr[u]) {
        if (c.first == pr) continue;
        dfs2(c.first, u, (now * c.second.first % M) * rev(c.second.second, M) % M);
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        gr[i].clear();
    }
    cnt_verg.clear();
    cnt_ans.clear();
    cnt_nig.clear();
    ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, a, b;
        cin >> u >> v >> a >> b;
//        swap(a, b);
        u--;
        v--;
        int g = __gcd(a, b);
        a /= g;
        b /= g;
        gr[u].push_back({v, {b, a}});
        gr[v].push_back({u, {a, b}});
    }
    dfs(0, 0);
    int now = 1;
    for (auto c: cnt_ans) {
        for (int i = 0; i < c.second; ++i) {
            now *= c.first;
            now %= M;
        }
    }
//    cout << now << endl;
    dfs2(0, 0, now);
    cout << ans << "\n";
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 2; i < N; ++i) {
        vec[i] = fact(i);
    }
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
