#include <bits/stdc++.h>

using namespace std;

const int maxa = 1e9 + 5, maxn = 2e5 + 3;

int a[maxn], l = 0, n;

bool check(long long x, unordered_map<int, int>& cnt) {
    if (x < a[l] || l == n) {
        return 0;
    }
    if (x < maxa && cnt[x]) {
        cnt[x]--;
        while (l < n && !cnt[a[l]]) {
            l++;
        }
        return 1;
    }
    if (x == 1) {
        return 0;
    }
    if (check(x / 2, cnt) && check((x + 1) / 2, cnt)) {
        return 1;
    } else {
        return 0;
    }
}

void solve() {
    cin >> n;
    long long sum = 0;
    unordered_map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i]]++;
        sum += a[i];
    }
    sort(a, a + n);
    l = 0;
    cout << (check(sum, cnt) ? "YES" : "NO") << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}

