//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define int long long
//#define ll long long
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()

const int MAXN = 2e5 + 10;
const int inf = 3e18;
const int mod = 998244353;
//const int mod = 1e9 + 7;
//const int p = 228;

int binpow(int a, int b) {
    int p = 1;
    while (b > 0) {
        if (b & 1)
            (p *= a) %= mod, b--;
        (a *= a) %= mod;
        b >>= 1;
    }
    return p;
}

vector<int> prost(MAXN, -1);
vector<int> rev(MAXN);

void precalc() {
    prost[0] = prost[1] = 1;
    for (int i = 2; i < sz(prost); ++i) {
        if (prost[i] == -1) {
            prost[i] = i;
            for (int j = i * i; j < sz(prost); j += i)
                if (prost[j] == -1)
                    prost[j] = i;
        }
    }
    rev[1] = 1;
    for (int i = 2; i < MAXN; ++i) {
        rev[i] = binpow(i, mod - 2);
    }
}

int n;
vector<vector<pair<int, pair<int, int>>>> g;
vector<int> ans;
vector<int> d;

void SIZE(int v, int p) {
    d[v] = 1;
    for (auto[w, musor]:g[v]) {
        if (w == p)
            continue;
        SIZE(w, v);
        d[v] += d[w];
    }
}

void dfs(int v, int p, map<int, int> &cur) {
    pair<int, int> mx = {0, -1};
    for (int i = 0; i < sz(g[v]); ++i) {
        if (g[v][i].first == p)
            continue;
        mx = max(mx, {d[g[v][i].first], i});
    }
    int mass = mx.second;
    if (mass == -1)
        return;
    int found = g[v][mass].first;
    dfs(found, v, cur);
    int x1 = g[v][mass].second.first;
    while (x1 > 1) {
        cur[prost[x1]]++;
        x1 /= prost[x1];
    }
    int x2 = g[v][mass].second.second;
    while (x2 > 1) {
        int t = prost[x2];
        int cnt = 0;
        while (x2 > 1 && prost[x2] == t) {
            ++cnt;
            x2 /= t;
        }
        cur[t] = max(0ll, cur[t] - cnt);
        if (cur[t] == 0)
            cur.erase(t);
    }

    for (auto[w, koef]:g[v]) {
        if (w == p || w == found)
            continue;
        map<int, int> rem;
        dfs(w, v, rem);
        x1 = koef.first;
        while (x1 > 1) {
            rem[prost[x1]]++;
            x1 /= prost[x1];
        }
        x2 = koef.second;
        while (x2 > 1) {
            int t = prost[x2];
            int cnt = 0;
            while (x2 > 1 && prost[x2] == t) {
                ++cnt;
                x2 /= t;
            }
            rem[t] = max(0ll, rem[t] - cnt);
            if (rem[t] == 0)
                rem.erase(t);
        }
        for (auto[c, y]:rem)
            cur[c] = max(cur[c], y);
    }
}

void otvet(int v, int p) {
    for (auto[w, koef]:g[v]) {
        if (w == p)
            continue;
        ans[w] = (ans[v] * koef.second) % mod * rev[koef.first] % mod;
        otvet(w, v);
    }
}

void solve() {
    cin >> n;
    g.assign(n, {});
    ans.assign(n, 0);
    d.assign(n, 0);
    for (int t = 0; t < n - 1; ++t) {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        int D = __gcd(x, y);
        x /= D;
        y /= D;
        --i, --j;
        g[i].push_back({j, {x, y}});
        g[j].push_back({i, {y, x}});
    }
    map<int, int> cur;
    SIZE(0, 0);
    dfs(0, 0, cur);
    ans[0] = 1;
    for (auto[c, y]:cur)
        (ans[0] *= binpow(c, y)) %= mod;
    otvet(0, 0);
    int sum = 0;
    for (auto x:ans) {
//        cout << x << " ";
        (sum += x) %= mod;
    }
    cout << sum << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
