#include <bits/stdc++.h>
#define x first
#define y second
#define sz(a) (int)a.size()
#define pb push_back

using namespace std;
const int mod = 998244353;
typedef long long ll;

void solve();

int bin_pow(int x, int k) {
    if (k == 0)
        return 1;
    if (k % 2 == 0) {
        int ans = bin_pow(x, k / 2);
        return ((ll)ans * ans) % mod;
    } else {
        return ((ll)bin_pow(x, k - 1) * x) % mod;
    }
}

int uf[200010];

unordered_map <int, int> pops;

struct chl {
    unordered_map <int, int> mp;
    void umn(chl &b) {
        for (auto i : b.mp) {
            mp[i.x] += i.y;
        }
    }
    void delt(chl &b) {
        for (auto i : b.mp) {
            mp[i.x] -= i.y;
            if (mp[i.x] == 0)
                mp.erase(i.x);
            else
                pops[i.x] = min(pops[i.x], mp[i.x]);
        }
    }
    void gc(chl &b) {
        for (auto i : b.mp) {
            if (min(i.y, mp[i.x]) != 0)
                mp[i.x] = min(i.y, mp[i.x]);
        }
    }
};

chl dp[200010];

int ff[200010];
bool used[200010];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 0; i <= 200000; ++i) {
        ff[i] = i;
        uf[i] = bin_pow(i, mod - 2);
    }
    for (int i = 2; i <= 200000; ++i) {
        if (!used[i]) {
            for (int j = i; j <= 200000; j+=i) {
                used[j] = 1;
                while (ff[j] % i == 0) {
                    dp[j].mp[i]++;
                    ff[j] /= i;
                }
            }
        }
    }
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}


struct node {
    int u, x, y;
};

vector <node> g[200010];

bitset <200010> bb;
bitset <200010> bb2;

chl d;

void dfs(int v) {
    bb[v] = 1;
    for (auto u : g[v]) {
        if (!bb[u.u]) {
            d.umn(dp[u.x]);
            d.delt(dp[u.y]);
            dfs(u.u);
            d.delt(dp[u.x]);
            d.umn(dp[u.y]);
        }
    }
}

int ans, rr;

void dfs2(int v) {
    bb2[v] = 1;
    ans = (ans + rr) % mod;
    for (auto u : g[v]) {
        if (!bb2[u.u]) {
            rr = ((ll)rr * u.x) % mod;
            rr = ((ll)rr * uf[u.y]) % mod;
            dfs2(u.u);
            rr = ((ll)rr * u.y) % mod;
            rr = ((ll)rr * uf[u.x]) % mod;
        }
    }
}


void solve() {
    bb = 0;
    bb2 = 0;
    int n, x, y, ind1, ind2, gc;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < n - 1; ++i) {
        cin >> ind1 >> ind2 >> x >> y;
        gc = __gcd(x, y);
        x /= gc, y /= gc;
        ind1--, ind2--;
        g[ind1].pb({ind2, y, x});
        g[ind2].pb({ind1, x, y});
    }
    ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!bb[i]) {
            d.mp.clear();
            pops.clear();
            dfs(i);
            rr = 1;
            for (auto u : pops) {
                rr = ((ll)rr * bin_pow(u.x, abs(u.y))) % mod;
            }
            dfs2(i);
        }
    }
    cout << ans << '\n';
}
