#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int ll
#define ld long double

#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpii vector<pii>
#define pipii pair<int, pii>
#define vpipii vector<pipii>

template <class T1, class T2> istream& operator>>(istream& in, pair<T1, T2>& a) {
    in >> a.first >> a.second;
    return in;
}
template <class T1, class T2> ostream& operator<<(ostream& out, pair<T1, T2>& a) {
    out << a.first << ' ' << a.second;
    return out;
}
template <class T> istream& operator>>(istream& in, vector<T>& a) {
    for (auto& aa : a) {
        in >> aa;
    }
    return in;
}
template <class T> ostream& operator<<(ostream& out, vector<T>& a) {
    for (auto& aa : a) {
        out << aa << ' ';
    }
    return out;
}

const int N = 2e5;
const int inf = 1e9;
const ll INF = 1e18;
const ld PI = 3.1415926535;

void solve() {
    int n; cin >> n;
    vi a(n); cin >> a;
    sort(a.begin(), a.end());
    multiset<int> k;
    int sum = 0;
    for (auto aa : a) k.insert(aa), sum += aa;
    vi q; q.push_back(sum);
    while (q.size()) {
        if (!k.size() || q.back() < *k.begin()) {
            cout << "NO\n";
            return;
        }
        if (k.count(q.back())) {
            int x = q.back();
            q.pop_back();
            k.erase(k.lower_bound(x));
        } else {
            int a = q.back() / 2;
            int b = q.back() - a;
            q.pop_back();
            q.push_back(a);
            q.push_back(b);
        }
    }
    cout << "YES\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}
