#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int ll
#define ld long double

#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpii vector<pii>
#define pipii pair<int, pii>
#define vpipii vector<pipii>

template <class T1, class T2> istream& operator>>(istream& in, pair<T1, T2>& a) {
    in >> a.first >> a.second;
    return in;
}
template <class T1, class T2> ostream& operator<<(ostream& out, pair<T1, T2>& a) {
    out << a.first << ' ' << a.second;
    return out;
}
template <class T> istream& operator>>(istream& in, vector<T>& a) {
    for (auto& aa : a) {
        in >> aa;
    }
    return in;
}
template <class T> ostream& operator<<(ostream& out, vector<T>& a) {
    for (auto& aa : a) {
        out << aa << ' ';
    }
    return out;
}

const int N = 3e5;
const int inf = 1e9;
const ll INF = 1e18;
const ld PI = 3.1415926535;
const int M = 998244353;

map<int, int> maxd;
map<int, int> cur;
int st(int a, int b) {
    if (b == 0) return 1;
    int aa = st(a, b / 2);
    aa = aa * aa % M;
    if (b % 2 == 1) aa = a * aa % M;
    return aa;
}
vvi del;

vpipii a[N];
void dfs(int v, int p = -1) {
    for (auto go : a[v]) {
        int u = go.first, x = go.second.first, y = go.second.second;
        if (u == p) continue;
        for (auto d : del[y]) {
            cur[d]--;
        }
        for (auto d : del[x]) {
            ++cur[d];
            maxd[d] = max({0ll, cur[d], maxd[d]});
        }
        dfs(u, v);
        for (auto d : del[y]) {
            cur[d]++;
        }
        for (auto d : del[x]) {
            --cur[d];
        }
    }
}

int ans = 0, max_del = 1;
void find(int v, int p = -1) {
    ans += max_del;
    ans %= M;
    for (auto go : a[v]) {
        int u = go.first, x = go.second.first, y = go.second.second;
        if (u == p) continue;
        int was = max_del;
        max_del = max_del * y % M * st(x, M - 2) % M;
        find(u, v);
        max_del = was;
    }
}

void solve() {
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        a[i].clear();
    }
    maxd.clear();
    cur.clear();
    ans = 0, max_del = 1;
    del = vvi(n + 1);
    for (int i = 2; i <= n; ++i) {
        int x = i;
        for (int j = 2; j * j <= x; ++j) {
            while (x % j == 0) {
                del[i].push_back(j);
                x /= j;
            }
        }
        if (x > 1) del[i].push_back(x);
    }
    for (int i = 0; i < n - 1; ++i) {
        int v, u, x, y; cin >> v >> u >> x >> y;
        a[--v].push_back({--u, {x, y}});
        a[u].push_back({v, {y, x}});
    }
    /*for (int i = 0; i < n - 1; ++i) {
        int v = i, u = i + 1, x = i + 1, y = 1; //cin >> v >> u >> x >> y;
        a[v].push_back({u, {x, y}});
        a[u].push_back({v, {y, x}});
    }*/
    dfs(0);
    for (auto d : maxd) {
        max_del *= st(d.first, d.second);
        max_del %= M;
    }
    find(0);
    cout << ans << '\n';
}

signed main() {
    /*vi f(100);
    f[0] = 1;
    for (int i = 1; i < 100; ++i) {
        f[i] = i * f[i - 1] % M;
    }
    cout << f[20] << endl;
    int sum = 0;
    for (int i = 1; i <= 19; ++i) {
        sum += f[i];
        sum %= M;
    }
    cout << sum << endl;*/
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}
/*
1
10
1 2 1 2
2 3 1 3
3 4 1 4
4 5 1 5
5 6 1 6
6 7 1 7
7 8 1 8
8 9 1 9
9 10 1 10
 */