#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int ll
#define ld long double

#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpii vector<pii>
#define pipii pair<int, pii>
#define vpipii vector<pipii>

template <class T1, class T2> istream& operator>>(istream& in, pair<T1, T2>& a) {
    in >> a.first >> a.second;
    return in;
}
template <class T1, class T2> ostream& operator<<(ostream& out, pair<T1, T2>& a) {
    out << a.first << ' ' << a.second;
    return out;
}
template <class T> istream& operator>>(istream& in, vector<T>& a) {
    for (auto& aa : a) {
        in >> aa;
    }
    return in;
}
template <class T> ostream& operator<<(ostream& out, vector<T>& a) {
    for (auto& aa : a) {
        out << aa << ' ';
    }
    return out;
}

const int N = 2e5;
const int inf = 1e9;
const ll INF = 1e18;
const ld PI = 3.1415926535;

void solve() {
    int k; cin >> k;
    string s; cin >> s;
    int n = 1 << k;
    vector<pair<char, int>> c;
    for (int i = 0; i < n; ++i) {
        c.push_back({s[i], i});
    }
    sort(c.begin(), c.end());
    vi p(n);
    p[c[0].second] = 0;
    for (int i = 1; i < n; ++i) {
        p[c[i].second] = p[c[i - 1].second];
        if (c[i].first != c[i - 1].first) ++p[c[i].second];
    }
    int len = 1;
    while (len < n) {

        vector<pair<pii, int>> val(n);
        for (int i = 0; i < n; ++i) {
            val[i] = {{p[i], p[i ^ len]}, i};
        }
        sort(val.begin(), val.end());
        p[val[0].second] = 0;
        for (int i = 1; i < n; ++i) {
            p[val[i].second] = p[val[i - 1].second];
            if (val[i].first != val[i - 1].first) ++p[val[i].second];
        }

        len *= 2;
    }
    int x = 0;
    for (int i = 0; i < n; ++i) {
        if (!p[i]) x = i;
    }
    for (int i = 0; i < n; ++i) {
        cout << s[i ^ x];
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}
