#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1000000007;
const ll MOD2 = 998244353;
#define all(x) x.begin(), x.end()
#define break_(x) {x; return;}

void solve(int test_case)
{
    string s; cin >> s;
    vector<int> cnt(26, 0);
    int n = s.size();
    int lst = n - 1;
    for (int i = n - 1; i >= 0; --i)
    {
        if (cnt[s[i] - 'a'] == 0)
        {
            lst = i;
        }
        ++cnt[s[i] - 'a'];
    }
    for (int i = lst; i < n; ++i) cout << s[i];
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    srand(time(NULL));
    int t = 1; cin >> t;
    for (int i = 0; i < t; ++i) solve(i);
}