#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1000000007;
const ll MOD2 = 998244353;
#define all(x) x.begin(), x.end()
#define break_(x) {x; return;}

multiset<ll> st;

bool slv(ll w)
{
    if (st.count(w))
    {
        st.erase(st.find(w));
        return true;
    }
    if (w == 1) return false;
    if (slv(w / 2LL) == false) return false;
    if (slv(w / 2LL + (w % 2LL)) == false) return false;
    return true;
}

void solve(int test_case)
{
    st.clear();
    int n; cin >> n; ll sm = 0;
    for (int i = 0; i < n; ++i)
    {
        ll nw; cin >> nw;
        st.insert(nw); sm += nw;
    }
    if (slv(sm)) cout << "YES\n";
    else cout << "NO\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    srand(time(NULL));
    int t = 1; cin >> t;
    for (int i = 0; i < t; ++i) solve(i);
}