#include<bits/stdc++.h>

#define int long long

#define ff first
#define ss second
#define _ << " " <<
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 2e5 + 111;
const int MOD = 998244353;

ll gcd(ll x, ll y) {
    if (x == 0 || y == 0) return (x + y);
    return gcd(y, x % y);
}

ll pw(ll x, ll y) {
    if (y == 0) return 1;
    if (y & 1) return (x * pw(x, y - 1)) % MOD;
    return pw((x*x) % MOD, y / 2);
}

int prime[MXN];

vector<pii> fact(int x) {
    vector<pii> res;
    while (x > 1) {
        int p = prime[x];
        int k = 0;
        while (x % p == 0) {
            ++k;
            x /= p;
        }
        res.push_back(make_pair(p, k));
    }
    return res;
}

int n;

ll sum = 0;
ll sum_node = 1;
ll cnt = 0;
map<int, int> mp;

vector<pair<int, pii>> g[MXN];

void mp_upd(int i, int x) {
    if (x >= 0) {
        mp[i] += x;
        sum_node *= pw(i, x);
        sum_node %= MOD;
    } else {
        x = abs(x);
        mp[i] -= x;
        sum_node *= pw(pw(i, x), MOD - 2);
        sum_node %= MOD;
    }
}

void dfs(int v, int p) {
    //cout << "dfs" _ v _ p << endl;
    sum += sum_node;
    sum %= MOD;
    cnt++;
    //cout << "ok1" << endl;
    for (auto to: g[v]) {
        //cout << "ok2" << endl;
        int u = to.ff;
        if (u == p) continue;
        int x = to.ss.ff;
        int y = to.ss.ss;
        //cout << "ok3" << endl;
        vector<pii> f_x = fact(x);
        //cout << "ok4" << endl;
        for (auto t: f_x) {
            int p = t.ff;
            int k = t.ss;
            if (mp[p] < k) {
                int delta = k - mp[p];
                mp_upd(p, delta);
                sum *= pw(p, delta);
                sum %= MOD;
            }
        }
        //cout << "ok5" << endl;
        vector<pii> f_y = fact(y);
        for (auto t: f_x) {
            int p = t.ff;
            int k = t.ss;
            mp_upd(p, -k);
        }
        //cout << "ok6" << endl;
        for (auto t: f_y) {
            int p = t.ff;
            int k = t.ss;
            mp_upd(p, k);
        }
        //cout << "ok7" << endl;
        dfs(u, v);
        //cout << "ok8" << endl;
        for (auto t: f_y) {
            int p = t.ff;
            int k = t.ss;
            mp_upd(p, -k);
        }
        //cout << "ok9" << endl;
        for (auto t: f_x) {
            int p = t.ff;
            int k = t.ss;
            mp_upd(p, k);
        }
        //cout << "ok10" << endl;
    }
    //cout << "ok11" << endl;
}


void solve() {
    cin >> n;
    sum = 0;
    sum_node = 1;
    cnt = 0;
    mp.clear();
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int z = 0; z < n - 1; ++z) {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        int nod = gcd(x, y);
        x /= nod;
        y /= nod;
        --i; --j;
        //cout << "!" _ i _ j _ x _ y << endl;
        g[i].push_back(make_pair(j, make_pair(x, y)));
        g[j].push_back(make_pair(i, make_pair(y, x)));
    }
    dfs(0, -1);
    cout << sum << "\n";
}

int32_t main() {
    for (ll i = 2; i < MXN; ++i) {
        if (prime[i] != 0) continue;
        prime[i] = i;
        for (ll j = i * i; j < MXN; j += i) {
            if (prime[j] == 0) prime[j] = i;
        }
    }
    ///freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}


