#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

void f(multiset<ll>& q, ll curr, int& tmp, int n) {
	if (tmp > 2 * n - 2) {
		return;
	}
	auto it = q.find(curr);
	if (it != q.end()) {
		q.erase(it);
		return;
	}
	tmp++;
	f(q, (curr + 1) / 2, tmp, n);
	tmp++;
	f(q, curr / 2, tmp, n);
}

void solve()
{
	int n;
	cin >> n;
	vector<int> a(n);
	ll sum = 0;
	multiset<ll> q;
	for (auto& elem : a) {
		cin >> elem;
		sum += (ll)elem;
		q.insert(elem);
	}
	sort(a.begin(), a.end());
	int tmp = 0;
	f(q, sum, tmp ,n);
	if (q.size() != 0) {
		cout << "NO\n";
		return;
	}
	cout << "YES\n";
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	int t;
	for (cin >> t; t > 0; t--) {
		solve();
	}
}