#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define all(x) (x).begin(), (x).end()
#define pb push_back

template <typename T>
inline int len(T& x) {
    return x.size();
}

const ll MOD = 1e9 + 7;
const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const int maxN = 2e5 + 9;

void solve() {
    int n; cin >> n;
    multiset<ll> a, b;


    bool ok = true;
    ll cs = 0;
    for(int i = 0; i < n; ++i) {
        ll x; cin >> x;
        a.insert(x);
        cs += x;
    }
    b.insert(cs);

    while(ok && len(a) > len(b)) {
        ll mx = *b.rbegin();
        if(a.find(mx) != a.end()) {
            b.erase(b.find(mx));
            a.erase(a.find(mx));
            continue;
        }
        ll x = mx / 2;
        ll y = mx - x;
        b.erase(b.find(mx));
        b.insert(x); b.insert(y);
    }

    if(ok) {
        auto uka = a.begin();
        auto ukb = b.begin();
        while(uka != a.end()) {
            ok &= *uka == *ukb;
            ++uka; ++ukb;
        }
    }


    if(ok) cout << "YES\n";
    else cout << "NO\n";
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*
6
1 1 1 1 1 1


2 2 2
 */