#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <cmath>
#include <map>
#include <random>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <iomanip>

using namespace std;
//#pragma GCC optimize(3)
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("inline")
//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#define double long double
#define int long long
//const double eps = 1e-4;
const long long MX = 2e18;
const long long MX9 = 2e9;
const int MXN = 8e5;
const int MOD = 998244353;
vector<vector<vector<int> > > gr;

vector<pair<int, int> > dp;
map<int, int> ans;
map<int, int> now;
vector<int> mindel;
vector<bool> used;

void dfs(int v) {
    used[v] = 1;
    for (auto u: gr[v]) {
        if (used[u[0]])
            continue;
        int x = u[2];
        while (x > 1) {
            now[mindel[x]]++;
            x /= mindel[x];
        }
        x = u[1];
        while (x > 1) {
            now[mindel[x]]--;
            if (now[mindel[x]] < 0)
                ans[mindel[x]] = min(ans[mindel[x]], now[mindel[x]]);
            x /= mindel[x];
        }
        dfs(u[0]);
        x = u[2];
        while (x > 1) {
            now[mindel[x]]--;
            x /= mindel[x];
        }
        x = u[1];
        while (x > 1) {
            now[mindel[x]]++;
            x /= mindel[x];
        }
    }
}

int answer = 1;

int fast(int a, int n) {
    if (n == 1)
        return (a % MOD);
    if (n == 0)
        return 1;
    if (n % 2 == 0) {
        int b = fast(a, n / 2);
        return (b * b) % MOD;
    }
    return (a * fast(a, n - 1)) % MOD;
}

int sum = 0;

void dfs2(int v) {
    used[v] = 1;
    sum = (sum + answer) % MOD;
    for(auto u : gr[v]){
        if(used[u[0]])
            continue;
        int rem = answer;
        answer = (((answer * u[2]) % MOD) * fast(u[1], MOD - 2)) % MOD;
        dfs2(u[0]);
        answer = rem;
    }
}

void solve() {
    int n;
    cin >> n;
    gr.clear();
    gr.resize(n);
    ans.clear();
    now.clear();
    mindel.clear();
    mindel.resize(n + 1, -1);
    used.clear();
    used.resize(n, false);
    for (int i = 2; i <= n; ++i) {
        if (mindel[i] != -1)
            continue;
        mindel[i] = i;
        for (int j = i * i; j <= n; j += i)
            if (mindel[j] == -1)
                mindel[j] = i;
    }
    for (int ii = 0; ii < n - 1; ++ii) {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        --i;
        --j;
        gr[i].push_back({j, x, y});
        gr[j].push_back({i, y, x});
    }
    dfs(0);
    answer = 1;
    for (auto u: ans) {
        if (u.second < 0)
            answer = (answer * fast(u.first, -u.second)) % MOD;
    }
    fill(used.begin(), used.end(), false);
    sum = 0;
    dfs2(0);
    cout << sum << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}