#include <bits/stdc++.h>
using namespace std;

#define int long long
#define endl '\n'


const int mod = 998244353;
vector<int> mindel(300000, -1);
vector<vector<pair<int, pair<int, int>>>> A;
int NOD(int a, int b){
    if(a < b) swap(a, b);
    if(b == 0)return a;
    return NOD(b, a % b);
}
int Pow(int x, int n){
    if(n == 0) return 1;
    int p = Pow(x, n / 2);
    p = (p * p) % mod;
    if(n % 2 == 1) p = ((p * x) % mod);
    return p;
}
int ans = 0;
map<int, int> M;
void dfs(int i, int last){
    for(auto ii: A[i]){
        if(ii.first != last) {
            map<int, int> M2, M3;
            int z = ii.second.second;
            while (z != 1){
                if(M2.find(mindel[z]) == M2.end()) M2[mindel[z]] = 0;
                M2[mindel[z]]++;
                z /= mindel[z];
            }
            z = ii.second.first;
            while (z != 1){
                if(M3.find(mindel[z]) == M3.end()) M3[mindel[z]] = 0;
                M3[mindel[z]]++;
                z /= mindel[z];
            }
            for (auto key: M2) {
                if(M.find(key.first) == M.end()){
                    M[key.first] = 0;
                }
                M[key.first] = max(M[key.first] - key.second, (int)0);
            }
            for (auto key: M3) {
                if(M.find(key.first) == M.end()){
                    M[key.first] = 0;
                }
                M[key.first] += key.second;
            }
            dfs(ii.first, i);
            for (auto key: M2) {
                if(M.find(key.first) == M.end()){
                    M[key.first] = 0;
                }
                M[key.first] += key.second;
            }
            for (auto key: M3) {
                if(M.find(key.first) == M.end()){
                    M[key.first] = 0;
                }
                M[key.first] -= key.second;
            }
        }
    }
}
void dfs2(int i, int last, int zz){
    ans += zz;
    //cout << i + 1 << ' ' << zz << endl;
    ans %= mod;
    for(auto ii: A[i]){
        if(ii.first != last){
            int zz2 = zz;
            zz2 *= ii.second.first;
            zz2 %= mod;
            zz2 *= Pow(ii.second.second, mod - 2);
            zz2 %= mod;
            dfs2(ii.first, i, zz2);
        }
    }
}
void solve(){
    int n;
    cin >> n;
    A.clear();
    A.resize(n);
    M.clear();
    for (int i = 0; i < n - 1; ++i) {
        int a, b, x, y;
        cin >> a >> b >> x >> y;
        a--;
        b--;
        int z = NOD(x, y);
        x /= z; y /= z;
        A[b].push_back({a, {x, y}});
        A[a].push_back({b, {y, x}});
    }
    dfs(0, -1);
    int zz = 1;
    for(auto key: M){
        zz *= Pow(key.first, key.second);
        zz %= mod;
    }
    //cout << endl;
    ans = 0;
    dfs2(0, -1, zz);
    //cout << zz << endl;
    cout << ans << endl;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    for (int i = 2; i < 200000; ++i) {
        if(mindel[i] == -1){
            mindel[i] = i;
            for (int j = i * i; j < 200001; j += i) {
                if(mindel[j] == -1) mindel[j] = i;
            }
        }
    }
    int XXX = 1;
    cin >> XXX;
    while (XXX--) solve();
}
