#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<map>
#include<set>
#include<array>
#include<random>
#include<stack>
#include<queue> 

using namespace std;
using ll = long long;
using ld = long double;

mt19937 gen(0);
const int IINF = 2e9;
const ll LINF = 4e18;
const ld EPS = 1e-12;

#define all(x) x.begin(), x.end()
#define print(x) cout << #x << ": " << x << endl;
#define print_arr(x) cout << #x << ": "; for(auto y: x) cout << y << ' '; cout << endl;


ll gcd(ll a, ll b){
	if (b == 0) return a;
	return gcd(b, a % b);
}


void solve(){
	int n;
	cin >> n;
	vector<ll> a(n);
	for (auto& x: a) cin >> x;
	ll fs_mx = 0, sc_mx = 0;
	for (auto x: a){
		if (fs_mx < x){
			sc_mx = fs_mx;
			fs_mx = x;
		}
		else if (sc_mx < x){
			sc_mx = x;
		}
	}
	cout << fs_mx + sc_mx << '\n';
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int abba = 1;
	cin >> abba;
	while(abba--){
		solve();
	}
}