#include <iostream>
#include <vector>
#include <string>

using namespace std;

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    int used[26] = { 0 };
    int best_i = n - 1;
    for (int i = n - 1; i >= 0; i--) {
        int j = s[i] - 'a';
        if (!used[j]) {
            best_i = i;
        }
        used[j] = true;
    }
    for (int i = best_i; i < n; i++) {
        cout << s[i];
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
