#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second
#define dou long double

#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define allv(vvv) vvv.begin(), vvv.end()
#define si(vvv) ((int)vvv.size())
#define bk back()

#define deb if(debug)
#define cth deb cout << "H\n";
#define ctv(vvv) deb{for(auto iii: vvv) cout << iii << " "; cout << '\n';}
#define ctvp(vvv) deb{for(auto iii: vvv) cout << iii.fi << " " << iii.se << "   "; cout << '\n';}
#define ctvv(vvv) deb for(int iii = 0; iii < si(vvv); ++iii){cout << iii << ": "; for(auto jjj: vvv[iii]) cout << jjj << " "; cout << '\n';}

const bool debug = 0;

struct edgs{
	int nxt;
	vector <int> x, y;
	int xv, yv;
};

vector <vector <edgs>> g;
vector <int> cnt;
vector <int> ans;
ll M = 998244353;

void dfs(int ver, int p){
	deb cout << ver << "   ";
	ctv(cnt)
	for(auto i: g[ver])
		if(i.nxt != p){
			for(auto j: i.x)
				--cnt[j];
			for(auto j: i.y){
				++cnt[j];
				ans[j] = max(ans[j], cnt[j]);
			}
			dfs(i.nxt, ver);
			for(auto j: i.x)
				++cnt[j];
			for(auto j: i.y)
				--cnt[j];
		}
}

ll pw(ll a, ll cntp){
	if(!cntp) return 1LL;
	if(cntp&1) return pw(a, cntp-1)*a%M;
	ll b = pw(a, cntp/2);
	return b*b%M;
}

ll ansval = 1, anssum = 0;

void dfssum(int ver, int p, ll now){
	anssum += now;
	anssum %= M;
	for(auto i: g[ver])
		if(i.nxt != p){
			now *= i.xv*pw(i.yv, M-2)%M;
			now %= M;
			dfssum(i.nxt, ver, now);
			now *= i.yv*pw(i.xv, M-2)%M;
			now %= M;
		}
}

int main(){
	if(!debug) ios_base::sync_with_stdio(0), cin.tie(0);

	int t;
	cin >> t;
	while(t--){
		int n;
		cin >> n;
		g.clear();
		cnt.clear();
		ans.clear();
		g.resize(n);
		cnt.resize(n+4);
		ans.resize(n+4);
		int C1, C2, C3, C4;
		for(int i = 0; i < n-1; ++i){
			cin >> C1 >> C2 >> C3 >> C4;
			int C3b = C3;
			int C4b = C4;
			--C1;
			--C2;
			vector <int> x, y;
			int p = 2;
			while(p*p <= C3){
				while(C3%p == 0){
					C3 /= p;
					x.pb(p);
				}
				++p;
			}
			if(C3 > 1)
				x.pb(C3);
			p = 2;
			while(p*p <= C4){
				while(C4%p == 0){
					C4 /= p;
					y.pb(p);
				}
				++p;
			}
			if(C4 > 1)
				y.pb(C4);
			g[C1].pb({C2, y, x, C4b, C3b});
			g[C2].pb({C1, x, y, C3b, C4b});
		}
		dfs(0, -1);
		ansval = 1;
		anssum = 0;
		for(int i = 1; i < n+4; ++i){
			ansval *= pw(i, ans[i]);
			ansval %= M;
		}
		dfssum(0, -1, ansval);
		cout << anssum << '\n';
	}

	return 0;
}
/*
1
4
3 2 3 4
1 2 4 3
1 4 2 4
*/
