#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <queue>
#include <numeric>
#include <algorithm>

#define all(a) (a).begin(), (a).end()
#define ssize(a) (int)(a).size()

using namespace std;

using ll = long long;



void solve() {
	int n;
	cin >> n;

	vector<ll> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	map<ll, int> cnt;
	for (int x : a) {
		++cnt[x];
	}

	ll s = accumulate(all(a), 0LL);
	map<ll, int> cur;
	cur.insert({ s, 1 });
	while (true) {
		if (ssize(cur) == 0) {
			break;
		}
		map<ll, int> new_cur;
		for (auto[x, k] : cur) {
			auto it = cnt.find(x);
			if (it != cnt.end()) {
				int q = min(it->second, k);
				k -= q;
				it->second -= q;
			}
			if (k > 0) {
				if (x == 1) {
					cout << "NO\n";
					return;
				}
				else {
					new_cur[x / 2] += k;
					new_cur[(x + 1) / 2] += k;
				}
			}
		}
		cur = new_cur;
	}
	cout << "YES\n";
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << flush;
	}

	return 0;
}