#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <utility>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <string>
#include <sstream>
#include <random>
#include <cstdio>
#include <cstdlib>

using namespace std;

void solve() {

	long long n;
	cin >> n;
	vector<long long> a(n);
	vector<long long> olddel(n);
	long long w = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		w += a[i];
	}
	if (n == 1) {
		cout << "YES\n";
		return;
	}
	sort(a.begin(), a.end());
	reverse(a.begin(), a.end());
	long long cnt0 = 1, cnt1 = 0;
	bool can = true;
	int ind = 0;
	while (w != 1) {
		long long newcnt0 = 0, newcnt1 = 0;
		if (w & 1ll) {
			newcnt0 = cnt0;
			newcnt1 = cnt0 + cnt1 + cnt1;
		}
		else {
			newcnt0 = cnt0 + cnt0 + cnt1;
			newcnt1 = cnt1;
		}
		w >>= 1ll;
		while (ind < n && newcnt1 > 0) {
			if (a[ind] > w + 1ll) {
				can = false;
				break;
			}
			while (ind < n && a[ind] == w + 1ll && newcnt1 > 0) {
				++ind;
				--newcnt1;
			}
			break;
		}
		if (!can) {
			break;
		}
		while (ind < n && newcnt0 > 0) {
			if (a[ind] > w) {
				can = false;
				break;
			}
			while (ind < n && a[ind] == w && newcnt0 > 0) {
				++ind;
				--newcnt0;
			}
			break;
		}
		if (!can) {
			break;
		}
		cnt0 = newcnt0;
		cnt1 = newcnt1;
	}
	if (can) {
		cnt1 = cnt0 + cnt1 + cnt1;
		if (cnt1 == n - ind) {
			cout << "YES\n";
		}
		else {
			cout << "NO\n";
		}
	}
	else {
		cout << "NO\n";
	}

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}