#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <chrono>

#define ll long long
#define ld long double
#define pii pair < int, int >
#define pll pair < ll, ll >
#define fi first
#define se second
#define pb push_back
#define inf (int)1e9
#define INF (ll)1e18
#define y1 aabsfasd
#define endl '\n'
#define m_t make_tuple

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
mt19937 rng((unsigned ll)chrono::steady_clock::now().time_since_epoch().count());
const ll md = 998244353;
const ld pi = acos(-1);
const clock_t start_time = clock();

ll i, j, z, n, x, y, ans, need[200501], sum, curr[200501], k1, k2, mn[200501];

vector < pll > v[200501];

vector < tuple < ll, ll, ll > > c[200501];

bool used[200501];

ll mod(ll a)
{
    return (a % md + md) % md;
}

ll bin_pow(ll a, ll b)
{
    ll res = 1;
    while (b > 0){
        if (b & 1) res = res * a % md;
        a = a * a % md;
        b >>= 1;
    }
    return res;
}

void dfs(ll u)
{
    used[u] = true;
    for (auto x : c[u]){
        ll i, c1, c2;
        tie(i, c1, c2) = x;
        if (!used[i]){
            for (auto w : v[c1]){
                curr[w.fi] += w.se;
            }
            for (auto w : v[c2]){
                curr[w.fi] -= w.se;
                if (curr[w.fi] < 0){
                    need[w.fi] += -curr[w.fi];
                    curr[w.fi] = 0;
                }
            }
            dfs(i);
            for (auto w : v[c1]) curr[w.fi] -= w.se;
            for (auto w : v[c2]) curr[w.fi] += w.se;
        }
    }
}

void dfs2(ll u)
{
    used[u] = true;
    sum = (sum + ans * k1 % md * bin_pow(k2, md - 2) % md) % md;
    for (auto x : c[u]){
        ll i, c1, c2;
        tie(i, c1, c2) = x;
        if (!used[i]){
            ll lk1 = k1, lk2 = k2;
            k1 = k1 * c1 % md;
            k2 = k2 * c2 % md;
            dfs2(i);
            k1 = lk1, k2 = lk2;
        }
    }
}

void solve()
{
    cin >> n;

    for (i = 1; i <= n; i++){
        need[i] = curr[i] = 0;
        c[i].clear();
        used[i] = false;
    }

    for (i = 1; i < n; i++){
        cin >> j >> z >> x >> y;
        c[j].pb(m_t(z, y, x));
        c[z].pb(m_t(j, x, y));
    }

    ans = 1;
    sum = 0;
    dfs(1);

    for (i = 1; i <= n; i++) ans = ans * bin_pow(i, need[i]) % md;
    fill(used + 1, used + n + 1, false);
    k1 = k2 = 1;
    dfs2(1);

    cout << sum << endl;
}

int main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios::sync_with_stdio(0);
    cin.tie(0);

    for (i = 2; i <= 2e5; i++){
        if (mn[i]) continue;
        for (j = i; j <= 2e5; j += i) if (!mn[j]) mn[j] = i;
    }

    for (i = 1; i <= 2e5; i++){
        ll curr = i;
        while (curr > 1){
            if (v[i].empty() || v[i].back().fi != mn[curr]) v[i].pb({mn[curr], 1});
            else v[i].back().se++;
            curr /= mn[curr];
        }
    }

    ll q = 1;
    cin >> q;

    while (q--) solve();

    #ifdef LOCAL
        cout << endl;
        cout << setprecision(2) << fixed << "Time: " << ((ld)clock() - start_time) / (ld)CLOCKS_PER_SEC << endl;
    #endif // LOCAL

    return 0;
}
