#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using ld = long double;

bool check(ll n, multiset<int>& s)
{
    if (s.find(n) != s.end())
    {
        s.erase(s.find(n));
        return true;
    }
    if (n == 1)
        return false;
    ll x = n / 2;
    ll y = n - x;
    return check(x, s) && check(y, s);
}

void solve()
{
    int n = 0;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    multiset<int> s;
    for (int i = 0; i < n; ++i)
        s.insert(a[i]);

    ll sum = accumulate(all(a), 0ll);

    if (check(sum, s))
        cout << "YES\n";
    else
        cout << "NO\n";
    return;

    while(s.size() > 1)
    {
        int x = *s.begin();
        s.erase(s.begin());
        int y = *s.begin();
        s.erase(s.begin());
        if (y - x > 1)
        {
            cout << "NO\n";
            return;
        }
        s.insert(x + y);
    }
    cout << "YES\n";
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int t = 0;
    cin >> t;

    while(t--)
    {
        solve();
    }

    return 0;
}