#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using ld = long double;

const int K = 200;
const int MAXN = 100'000;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n = 0;
    cin >> n;

    int ans = n - 1;

    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    for (int step = -K; step < K; ++step)
    {
        vector<ll> b = a;
        for (int i = 0; i < n; ++i)
            b[i] -= step * i;
        map<ll, int> cnt;
        for (int i = 0; i < n; ++i)
            ++cnt[b[i]];
        for (auto [num, c] : cnt)
            ans = min(ans, n - c);
    }

    int len = MAXN / K + 2;
    for (int i = 0; i < n; ++i)
    {
        map<int, int> steps;
        for (int j = 1; j < min(n - i, len); ++j)
        {
            if ((a[i + j] - a[i]) % j == 0)
                ++steps[(a[i + j] - a[i]) / j];
        }
        for (auto [num, c] : steps)
            ans = min(ans, n - c - 1);
    }

    cout << ans << "\n";

    return 0;
}