#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using ld = long double;

const int K = 500;
const int MAXN = 100'000;

int a[MAXN];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n = 0;
    cin >> n;

    int ans = n - 1;
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    unordered_map<int, int> cnt;
    for (int step = -K; step < K; ++step)
    {
        for (int i = 0; i < n; ++i)
            a[i] -= step * i;
        for (int i = 0; i < n; ++i)
            ++cnt[a[i]];
        for (const auto& [num, c] : cnt)
            ans = min(ans, n - c);
        for (int i = 0; i < n; ++i)
            a[i] += step * i;    
        cnt.clear();
    }

    int len = MAXN / K + 2;
    unordered_map<int, int> steps;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 1; j < min(n - i, len); ++j)
        {
            if ((a[i + j] - a[i]) % j == 0)
                ++steps[(a[i + j] - a[i]) / j];
        }
        for (const auto& [num, c] : steps)
            ans = min(ans, n - c - 1);
        cnt.clear();
    }

    cout << ans << "\n";

    return 0;
}