#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

#define int long long


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ans = n;
    for (int i = -500; i <= 500; ++i) {
        unordered_map<int, int> cnt;
        for (int j = 0; j < n; ++j) {
            cnt[a[j] + i * j]++;
        }
        for (auto j: cnt) {
            ans = min(ans, n - j.second);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n && j - i < 40; ++j) {
            int res = a[j] - a[i];
            if (res % (j - i) == 0) {
                res /= (j - i);
                unordered_map<int, int> cnt;
                for (int j1 = i; j1 < n && j1 - i < 40; ++j1) {
                    cnt[a[j1] - res * j1]++;
                }
                for (auto j1: cnt) {
                    ans = min(ans, n - j1.second);
                }
            }
        }
    }
    cout << ans;
}
