#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <map>
#include <ctime>
#include <random>

using namespace std;

typedef long long ll;

// #define int ll

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

vector<vector<int>> graph;
map<int, int> eee;
vector<int> glub;
vector<map<int, int>>kkk;
map<int, int> aaa;

int bin_pow(int a, int n, int mod) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		int b = bin_pow(a, n / 2, mod);
		return (ll)b * b %  mod;
	}
	else {
		return (ll)a * bin_pow(a, n - 1, mod) % mod;
	}
}

void dfs(int v, int p = -1) {
	for (auto to : graph[v]) {
		if (to != p) {
			glub[to] = glub[v] + 1;
			dfs(to, v);
		}
	}
}

void dfs1(int v, int p = -1) {
	for (auto to : graph[v]) {
		if (to != p) {
			for (auto el : kkk[to]) {
				eee[el.first] += el.second;
				if (eee[el.first] < 0) {
					aaa[el.first] = max(aaa[el.first], -eee[el.first]);
				}
			}
			dfs1(to, v);
			for (auto el : kkk[to]) {
				eee[el.first] -= el.second;
			}
		}
	}
}

int summ = 0;

void dfs2(int v, int temp, int p = -1) {
	summ += temp;
	summ %= 998244353;
	for (auto to : graph[v]) {
		if (to != p) {
			int eee = temp;
			for (auto el : kkk[to]) {
				if (el.second >= 0) {
					temp = (ll)temp * bin_pow(el.first, el.second, 998244353) % 998244353;
				}
				else {
					temp = (ll)temp * bin_pow(bin_pow(el.first, -el.second, 998244353), 998244351, 998244353) % 998244353;
				}
			}
			dfs2(to, temp, v);
			temp = eee;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	vector<int> lala(2 * (int)1e5 + 228);
	for (int i = 2; i < 2 * 1e5 + 228; i++) {
		if (lala[i] == 0) {
			lala[i] = i;
			for (int j = 2 * i; j < 2 * 1e5 + 228; j += i) {
				if (lala[j] == 0) {
					lala[j] = i;
				}
			}
		}
	}
	while (t--) {
		int n;
		cin >> n;
		graph.clear();
		graph.resize(n);
		glub.clear();
		glub.resize(n);
		vector<pair<pair<int, int>, map<int, int>>> edges(n);
		for (int _ = 0; _ + 1 < n; _++) {
			int i, j, x, y;
			cin >> i >> j >> x >> y;
			i--, j--;
			map<int, int> mm;
			while (x > 1) {
				mm[lala[x]]--;
				x /= lala[x];
			}
			while (y > 1) {
				mm[lala[y]]++;
				y /= lala[y];
			}
			graph[i].push_back(j);
			graph[j].push_back(i);
			edges[_] = { {i, j}, mm};
		}
		dfs(0);
		kkk.clear();
		kkk.resize(n);
		for (int i = 0; i + 1 < n; i++) {
			int u = edges[i].first.first, v = edges[i].first.second;
			auto mm = edges[i].second;
			if (glub[u] < glub[v]) {
				kkk[v] = mm;
			}
			else {
				for (auto &el : mm) {
					el.second = -el.second;
				}
				kkk[u] = mm;
			}
		}
		eee.clear();
		aaa.clear();
		dfs1(0);
		summ = 0;
		int temp = 1;
		for (auto el : aaa) {
			temp = (ll)bin_pow(el.first, el.second, 998244353) * temp % 998244353;
		}
		
		dfs2(0, temp);
		cout << summ << '\n';
	}
    return 0;
}

