#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())

const int LOG_MAX_N = 2e6 + 1;
int lg[LOG_MAX_N];

void doPrecalc() {
    lg[1] = 0;
    for (int i = 2; i < LOG_MAX_N; ++i) {
        lg[i] = lg[i / 2] + 1;
    }
}

const int INF = 1e18 + 3;
using umap = unordered_map <int, int>;

//2

umap getDividers(int a) {
    umap ans;
    for (int i = 2; i * i <= a; ++i) {
        while (a % i == 0) {
            ++ans[i];
            a /= i;
        }
    }
    if (a > 1) {
        ++ans[a];
    }
    return ans;
}

const int MOD = 998'244'353;

int binPow(int a, int n) {
    if (n <= 0) {
        return 1ll;
    }
    if (n & 1) {
        return (binPow(a, n - 1) * a) % MOD;
    } else {
        return binPow((a * a) % MOD, n >> 1);
    }
}

int f(int a) {
    return binPow(a, MOD - 2);
}

bool isPrime(int a) {
    for (int i = 2; i * i <= a; ++i) {
        if (a % i == 0) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector <int> v(n);
    for (auto &i : v) {
        cin >> i;
    }
    random_device eng;
    mt19937 rnd(eng());
    int iter = 500;
    int ans = 0;
    while (iter--) {
        int p = rnd() % n;
        umap cnt;
//        cout << p << " ";
        for (int i = 0; i < n; ++i) {
            if (i == p) {
                continue;
            }
            if (abs(v[p] - v[i]) % abs(p - i)) {
                continue;
            }
            ++cnt[(v[p] - v[i]) / (p - i)];
        }
        for (auto [a, b] : cnt) {
            ans = max(ans, b);
        }
    }
    cout << n - ans - 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
//    cout.tie(nullptr);
    doPrecalc();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
