#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 200500;
const int mod = 998244353;

int pow_(int n, int power) {
    if (power == 0) {
        return 1;
    }
    if (power % 2 == 1) {
        return pow_(n, power - 1) * n % mod;
    }
    int val = pow_(n, power / 2);
    return val * val % mod;
}

vector<pair<int, pair<int, int>>> g[MAXN];
int dev[MAXN];

map<int, int> get_fact(int x, int y) {
    map<int, int> res;
    while (x != 1) {
        res[dev[x]]++;
        x /= dev[x];
    }
    while (y != 1) {
        res[dev[y]]--;
        y /= dev[y];
    }
    return res;
}

map<int, int> ogo, mn;

void dfs(int v, int p, pair<int, int> now) {
    auto fact = get_fact(now.first, now.second);
    for (auto el: fact) {
        ogo[el.first] += el.second;
        mn[el.first] = min(mn[el.first], ogo[el.first]);
    }
    for (auto e: g[v]) {
        if (e.first != p) {
            dfs(e.first, v, e.second);
        }
    }
    for (auto el: fact) {
        ogo[el.first] -= el.second;
    }
}

int ans = 0;

void dfs2(int v, int p, int now) {
    ans += now;
    ans %= mod;
    for (auto e: g[v]) {
        if (e.first != p) {
            dfs2(e.first, v, now * e.second.first % mod * pow_(e.second.second, mod - 2) % mod);
        }
    }
}

void sol() {
    int n;
    cin >> n;
    fill(g, g + n + 5, vector<pair<int, pair<int, int>>>());
    for (int _ = 0; _ < n - 1; _++) {
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        int ddd = __gcd(x, y);
        x /= ddd, y /= ddd;
        g[i].push_back({j, {y, x}});
        g[j].push_back({i, {x, y}});
    }
    ogo = {};
    mn = {};
    dfs(1, -1, {1, 1});
    int hihi = 1;
    for (auto el: mn) {
        if (el.second < 0) {
            for (int i = 0; i < -el.second; i++) {
                hihi = hihi * el.first % mod;
            }
        }
    }
    ans = 0;
    dfs2(1, -1, hihi);
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (int i = 2; i < MAXN; i++) {
        if (dev[i] != 0) {
            continue;
        }
        for (int j = i; j < MAXN; j += i) {
            dev[j] = i;
        }
    }
    int t = 1;
    cin >> t;
    while (t--) {
        sol();
    }
}
