#include <bits/stdc++.h>

//#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

vector<int> inds[26];

vector<int> get_bin(int n) {
    vector<int> res;
    for (int i = 0; i < 18; i++) {
        res.push_back(n % 2);
        n /= 2;
    }
    reverse(all(res));
    return res;
}

int get_from(vector<int> res) {
    int now = 0;
    for (int el: res) {
        now *= 2;
        now += el;
    }
    return now;
}

const int MAXN = (1 << 18) * 18;
int trie[MAXN][2];
int prev_[MAXN][2];
int nv = 1;

void addtrie(vector<int> a, int kok) {
    int v = 0;
    for (int el: a) {
        if (trie[v][el] == 0 || prev_[v][el] != kok) {
            trie[v][el] = nv++;
            prev_[v][el] = kok;
        }
        v = trie[v][el];
    }
}

vector<int> mn(vector<int> a, int kok) {
    int v = 0;
    vector<int> res;
    for (int el: a) {
        if (trie[v][el] != 0 && prev_[v][el] == kok) {
            res.push_back(0);
            v = trie[v][el];
        } else {
            res.push_back(1);
            v = trie[v][1 - el];
        }
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    n = (1 << n);
    string s;
    cin >> s;
    vector<int> a;
    for (char el: s) {
        a.push_back(el - 'a');
    }
    for (int i = 0; i < n; i++) {
        inds[a[i]].push_back(i);
    }
    vector<int> left(n);
    iota(all(left), 0);
    for (int j = 0; j < 25; j++) {
//        for (int i = 0; i < MAXN; i++) {
//            trie[i][0] = trie[i][1] = 0;
//        }
        nv = 1;
        vector<int> now;
        for (int i = 0; i < n; i++) {
            if (a[i] > j) {
                now.push_back(i);
                addtrie(get_bin(i), j + 1);
            }
        }
        if ((int) now.size() == n) {
            continue;
        }
        if (now.empty() ) {
            break;
        }
        vector<pair<int, int>> kek;
        for (int el: left) {
            kek.push_back({get_from(mn(get_bin(el), j + 1)), el});
        }
        int mx = max_element(all(kek))->first;
        left = {};
        for (auto el: kek) {
            if (el.first == mx) {
                left.push_back(el.second);
            }
        }
    }
    int res = left[0];
    string t;
    for (int i = 0; i < n; i++) {
        t += s[i ^ res];
    }
    cout << t << '\n';
}
