//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("-ffast-math")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define vec vector
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sqr(x) (x) * (x)
#define cube(x) (x) * (x) * (x)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

mt19937 rng(time(0));

typedef long long ll;
typedef long double ld;

//#define int ll
//#define double ld

typedef pair<int, int> pii;
typedef tuple<int, int, int> tiii;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = 998244353;

int binpow(int b, int e, int m = MOD) {
    int ans = 1;
    while(e) {
        if(e & 1) ans = 1LL * ans * b % m;
        b = 1LL * b * b % m;
        e >>= 1;
    }
    return ans;
}

template<typename T> void umin(T &x, T y) { if(x > y) x = y; }
template<typename T> void umax(T &x, T y) { if(x < y) x = y; }

const int SIZE = 1e6 + 5;

int n, a[SIZE], b[SIZE], x[SIZE], y[SIZE], ans, fst, erat[SIZE];
vec<tiii> g[SIZE];
gp_hash_table<int, int> fact;
gp_hash_table<int, int> cur;

void dfs1(int x, int e) {
    for(auto [i, X, Y] : g[x]) {
        if(i == e) continue;
        int tmp;

        tmp = Y;
        while(tmp > 1) {
            cur[erat[tmp]]++;
            tmp /= erat[tmp];
        }
        tmp = X;
        while(tmp > 1) {
            cur[erat[tmp]]--;
            umax(fact[erat[tmp]], -cur[erat[tmp]]);
            tmp /= erat[tmp];
        }

        dfs1(i, x);

        tmp = Y;
        while(tmp > 1) {
            cur[erat[tmp]]--;
            tmp /= erat[tmp];
        }
        tmp = X;
        while(tmp > 1) {
            cur[erat[tmp]]++;
            tmp /= erat[tmp];
        }
    }
}

void dfs(int x, int e, int cval) {
    (ans += cval) %= MOD;
    for(auto [i, X, Y] : g[x]) {
        if(i != e) {
            dfs(i, x, 1LL * cval * Y % MOD * binpow(X, MOD - 2) % MOD);
        }
    }
}

void solve() {
    cin >> n;
    for(int i = 0; i < n - 1; i++) {
        cin >> a[i] >> b[i] >> x[i] >> y[i];
        a[i]--, b[i]--;
        int g = __gcd(x[i], y[i]);
        x[i] /= g;
        y[i] /= g;
    }
    for(int i = 0; i < n - 1; i++) {
        g[a[i]].eb(b[i], x[i], y[i]);
        g[b[i]].eb(a[i], y[i], x[i]);
    }

    dfs1(0, -1);
    fst = 1;
    for(auto [a, b] : fact) {
        fst = 1LL * fst * binpow(a, b) % MOD;
    }
    dfs(0, -1, fst);

    cout << ans;

    ans = 0;
    fact.clear();
    cur.clear();
    for(int i =0 ; i < n; i++) {
        g[i].clear();
    }

}

signed main() {
    for(int i = 2; i < SIZE; i++) {
        if(erat[i]) continue;
        for(int j = erat[j]; j < SIZE; j += i) {
            erat[j] = i;
        }
    }

    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int t = 1;
    cin >> t;

    while(t--) {
        solve();
        cout << "\n";
    }

    return 0;
}
