#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("-ffast-math")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define vec vector
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sqr(x) (x) * (x)
#define cube(x) (x) * (x) * (x)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

mt19937 rng(time(0));

typedef long long ll;
typedef long double ld;

//#define int ll
//#define double ld

typedef pair<int, int> pii;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = 998244353, INF = 1e9;

int binpow(int b, int e, int m = MOD) {
    int ans = 1;
    while(e) {
        if(e & 1) ans = 1LL * ans * b % m;
        b = 1LL * b * b % m;
        e >>= 1;
    }
    return ans;
}

template<typename T> void umin(T &x, T y) { if(x > y) x = y; }
template<typename T> void umax(T &x, T y) { if(x < y) x = y; }

const int SIZE = 1e5 + 5, P = 1000;

int n, a[SIZE];
gp_hash_table<int, int> cnt[2 * P + 5];
int bcnt[2 * P + 5];

void solve() {
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int ans = INF;

    for(int d = -P; d < P; d++) {
        for(int i = 0; i < n; i++) {
            umax(bcnt[d + P], ++cnt[d + P][a[i] - i * d]);
        }
        umin(ans, n - bcnt[d + P]);
    }

    for(int i = 0; i < n; i++) {
        for(int j = 1; j < SIZE / P && i + j < n; j++) {
            int d = a[i + j] - a[i];
            if(abs(d) % j) {
                continue;
            }
            d /= j;
            int curans = 0;
            gp_hash_table<int, int> ccnt;
            if(abs(d) < P) {
                continue;
            }
            for(int k = 0; k < SIZE / P && i + k < n; k++) {
                umax(curans, ++ccnt[a[i + k] - (i + k) * d]);
            }
            umin(ans, n - curans);
        }
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int t = 1;
//    cin >> t;

    while(t--) {
        solve();
        cout << "\n";
    }

    return 0;
}
