#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
// #include <priority_queue>
#include <unordered_set>
#include <bitset>
#include <algorithm>

#define int long long
#define endl '\n'
#define all(x) x.begin(), x.end()

using namespace std;

typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


const int maxn = 2e5 + 228;
int abc[maxn];

int sum = 0;

vector<pair<int, pii>> g[maxn];

vi get(int a) {
    vi cnt;
    while (abc[a] != -1) {
        cnt.push_back(abc[a]);
        a /= abc[a];
    }
    return cnt;
}

void add(map<int, int>& a, vi b) {
    for (int i : b)
        a[i]++;
}

const int mod = 998244353;

int binpow(int n, int k) {
    if (!k)
        return 1;
    if (k & 1)
        return binpow(n, k - 1) * 1ll * n % mod;
    int b = binpow(n, k / 2);
    return b * 1ll * b % mod;
}

map<int, int> a0;

void dfs(int v, map<int, int>& cur, int p = -1) {
    for (auto i : g[v]) {
        if (i.first == p)
            continue;
        vi kek1 = get(i.second.first);
        vi kek2 = get(i.second.second);
        for (int i : kek1)
            cur[i]++;
        for (int i : kek2)
            cur[i]--;
        for (int i : kek1) {
            a0[i] = max(a0[i], cur[i]);
        }
        for (int i : kek2) {
            a0[i] = max(a0[i], cur[i]);
        }
        dfs(i.first, cur, v);
        for (int i : kek1)
            cur[i]--;
        for (int i : kek2)
            cur[i]++;
    }
}

int ans[maxn];

void dfs(int v, int p = -1) {
    for (auto i : g[v]) {
        if (i.first == p)
            continue;
        ans[i.first] = ans[v] * i.second.second % mod * binpow(i.second.first, mod - 2) % mod;
        dfs(i.first, v);
    }
}

int gcd(int a, int b) {
    return (b ? gcd(b, a % b) : a);
}


void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        g[i].clear();
    a0.clear();
    for (int i = 0; i + 1 < n; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--;
        g[a].push_back(make_pair(b, make_pair(c, d)));
        g[b].push_back(make_pair(a, make_pair(d, c)));
    }
    map<int, int> kek;
    dfs(0, kek);
    ans[0] = 1;
    for (pii i : a0){
        ans[0] = ans[0] * binpow(i.first, i.second) % mod;
    }
    dfs(0);
    int sum = 0;
    for (int i = 0; i < n; i++){
        sum += ans[i];
    }
    sum %= mod;
    cout << sum << endl;
}

signed main() {
    for (int i = 0; i < maxn; i++)
        abc[i] = -1;
    for (int i = 2; i < maxn; i++) {
        if (abc[i] == -1) {
            for (int j = i; j < maxn; j += i) {
                if (abc[j] == -1) {
                    abc[j] = i;
                }
            }
        }
    }
    int q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}
