#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2e5 + 20;

vector<tuple<int, int, int>> g[N];

vector<int> m[N];
vector<int> mda[N];


int have[N], used[N], bal[N];//, add[N];

const ll mod = 998244353;
ll go, res;

map<int, int> add;

void dfs1(int v, int p){
//      debug(v, have[2], used[2]);
//      debug(v, go, have[2], used[2]);
      for(auto [to, x, y] : g[v]){
            if(to == p)
                  continue;
            for(int h : m[y]){
                  if(have[h] > used[h]){
                        ++ used[h];
                  }else{
                        mda[to].push_back(h);
                        ++ bal[h];
                        add[h] = max(add[h], bal[h]);
//                        vis[h] = true;
//                        go = (go * h) % mod;
                  }
            }
//            debug(v, to, go);
            for(int h : m[x]){
                  ++ have[h];
            }
            dfs1(to, v);
            for(int h : m[y]){
                  -- used[h];
            }
            for(int h : mda[to]){
                  ++ used[h];
                  -- bal[h];
            }
            for(int h : m[x]){
                  -- have[h];
            }
      }
}

ll bpow(ll x, ll y){
      if(!y)
            return 1ll;
      if(y & 1ll)
            return x * bpow(x, y - 1) % mod;
      ll z = bpow(x, y / 2);
      return z * z % mod;
}

ll dv(ll x, ll y){
      return x * bpow(y, mod - 2) % mod;
}

void dfs2(int v, int p, ll c){
      res += c;
      res %= mod;
      for(auto [to, x, y] : g[v]){
            if(to == p)
                  continue;
            ll b = x * dv(c, y) % mod;
            dfs2(to, v, b);
      }
}

int xyz[N];

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      #ifdef LOCAL
      freopen("input.txt", "r", stdin);
      #endif
      for(int i = 2; i < N; i ++){
            if(!xyz[i]){
                  for(int j = i + i; j < N; j += i)
                        xyz[j] = i;
            }
      }
      for(int i = 2; i < N; i ++){
            int x = i;
            while(xyz[x] > 0){
                  m[i].push_back(xyz[x]);
                  x /= xyz[x];
            }
            if(x != 1)
                  m[i].push_back(x);
      }
//      for(int i = 1; i <= 10; i ++){
//            debug(i, m[i]);
//      }
      int t; cin >> t;
      while(t --){
            go = 1;
            res = 0;
            int n; cin >> n;
            for(int i = 1; i <= n; i ++){
                  g[i].clear();
                  mda[i].clear();
            }
            for(int _ = 0; _ < n - 1; _ ++){
                  int i, j, x, y;
                  cin >> i >> j >> x >> y;
                  int z = __gcd(x, y);
                  x /= z;
                  y /= z;
                  g[i].emplace_back(j, y, x);
                  g[j].emplace_back(i, x, y);
            }
            dfs1(1, 1);
            for(auto [x, y] : add){
                  go = (go * bpow(x, y)) % mod;
            }
            add.clear();
//            debug(go);
            dfs2(1, 1, go);
            cout << res % mod << "\n";
      }
}
