#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define range(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

multiset<ll> s;

bool Solve(ll x) {
    if (x == 0)
        return false;
    auto it = s.find(x);
    if (it != s.end()) {
        s.erase(it);
        return true;
    }
    return Solve(x / 2) && Solve((x + 1) / 2);
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        ll sum = 0;
        s.clear();
        sfor(i, 0, n - 1) {
            ll x;
            cin >> x;
            sum += x;
            s.insert(x);
        }
        if (Solve(sum))
            cout << "YES\n";
        else
            cout << "NO\n";
    }
}
