﻿/*

t.me/gorill40
t.me/averageCFenjoyer
t.me/brawl_geom
t.me/ptreap

*/

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <algorithm>
#include <stack>
#include <string>
#include <assert.h>
#include <cmath>
#include <iomanip>
#include <fstream>
#include <random>
#include <set>
#include <map>
#define int long long
using namespace std;

const int mod = 998244353;
const int maxn = 2e5 + 1;

int gcd(int a, int b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

int pw(int x, int n) {
    if (n == 0)
        return 1;
    int t = pw(x * x % mod, n / 2);
    if (n % 2)
        t = t * x % mod;
    return t;
}

int obr(int x) {
    return pw(x, mod - 2);
}

struct edge {
    int v, x, y;
};


vector <int> prime;
vector <int> e(maxn, -1);
vector <vector <edge>> g;

int cur_chisl = 0;
int cur_zn = 1;

int nok_znam = 1;

map <int, int> chisl, znam, innok;

int ans = 0;
bool nado = true;

void add_edge(int u, int v, int x, int y) {
    int d = gcd(x, y); x /= d, y /= d;
    edge g1 = { v, x, y };
    edge g2 = { u, y, x };
    g[u].push_back(g1);
    g[v].push_back(g2);
}

void mult_chisl(int x) {
    while (x > 1) {
        int y = e[x];

        if (znam[y] == 0) {
            chisl[y]++;
            cur_chisl = cur_chisl * y % mod;
        }
        else {
            znam[y]--;
            cur_zn = cur_zn * obr(y) % mod;
        }

        x /= y;
    }
}

void mult_znam(int x) {
    while (x > 1) {
        int y = e[x];

        if (chisl[y] == 0) {
            znam[y]++;
            cur_zn = cur_zn * y % mod;

            if (nado) {
                if (znam[y] > innok[y]) {
                    innok[y] = znam[y];
                    nok_znam = nok_znam * y % mod;
                }
            }
        }
        else {
            chisl[y]--;
            cur_chisl = cur_chisl * obr(y) % mod;
        }

        x /= y;
    }
}

void dfs1(int u, int p = -1) {
    for (const auto &ee : g[u]) {
        int v = ee.v;
        int x = ee.x;
        int y = ee.y;
        if (v == p)
            continue;
        mult_chisl(y);
        mult_znam(x);
        dfs1(v, u);
        mult_chisl(x);
        mult_znam(y);
    }
}

void dfs2(int u, int p = -1) {
    ans = (ans + nok_znam * obr(cur_zn) % mod * cur_chisl % mod) % mod;
    for (const auto& ee : g[u]) {
        int v = ee.v;
        int x = ee.x;
        int y = ee.y;
        if (v == p)
            continue;
        mult_chisl(y);
        mult_znam(x);
        dfs2(v, u);
        mult_chisl(x);
        mult_znam(y);
    }
}

void solve() {
    int n; cin >> n;
    g.clear(); g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, x, y; cin >> u >> v >> x >> y; u--, v--;
        add_edge(u, v, x, y);
    }


    cur_chisl = 1;
    cur_zn = 1;
    nok_znam = 1;
    chisl.clear();
    znam.clear();
    innok.clear();
    nado = true;
    dfs1(0);

    ans = 0;
    cur_chisl = 1;
    cur_zn = 1;
    chisl.clear();
    znam.clear();
    innok.clear();
    nado = false;
    dfs2(0);

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    srand(time(NULL));

    for (int i = 2; i < maxn; i++) {
        if (e[i] == -1) {
            e[i] = i;
            prime.push_back(i);
        }
        for (int j = 0; j < prime.size() && prime[j] <= e[i] && i * prime[j] < maxn; j++) {
            e[i * prime[j]] = prime[j];
        }
    }

    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}