#include <iostream>
#include <set>

const int maxN = 2e5;

bool flag;
int t, n, a[maxN];
long long start;
std::multiset<long long> s1, s2;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> t;
	while (t--) {
		std::cin >> n;
		s1.clear();
		s2.clear();
		start = 0;
		for (int i = 0; i < n; i++) {
			std::cin >> a[i];
			s2.insert(-a[i]);
			start += a[i];
		}
		flag = true;
		s1.insert(-start);
		while (!s1.empty() && !s2.empty()) {
			long long t1 = *s1.begin();
			s1.erase(s1.begin());
			long long t = *s2.begin();
			t1 = -t1;
			t = -t;
			if (t1 < t) {
				flag = false;
				break;
			}
			if (t1 == t) {
				s2.erase(s2.begin());
				continue;
			}
			long long t2 = (t1 + 1) / 2, t3 = t1 / 2;
			s1.insert(-t2);
			s1.insert(-t3);
		}
		std::cout << (flag ? "YES\n" : "NO\n");
	}
	return 0;
}