#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <vector>
#include <string>
#include <map>
#include <queue>
#include <deque>
#include <random>
#define _CRT_SECURE_NO_WARNINGS
using namespace std;
mt19937 rnd(228337);

using ll = long long;
//#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const ll INF = 1e9 + 9;
const int N = 1e6 + 9;

int a[N];

int z[N];

void zfunc(string& s)
{
    z[0] = 0;
    int l = 0, r = 0;
    for (int i = 1; i < s.size(); i++)
    {
        z[i] = max(0, min(r - i, z[i - l]));
        while (i + z[i] < s.size() && s[z[i]] == s[i + z[i]])
            z[i]++;
        if (r <= i + z[i])
        {
            l = i;
            r = i + z[i];
        }
    }
}

int cnt[N];

signed main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif


    
    
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        string s;
        cin >> s;
        for (int i = 'a'; i <= 'z'; i++)
            cnt[i] = 0;
        for (int i = 0; i < s.size(); i++)
            cnt[s[i]]++;
        reverse(all(s));
        while (s.size())
        {
            int c = s.back();
            if (cnt[c] > 1)
            {
                s.pop_back();
                cnt[c]--;
            }
            else
                break;
        }
        reverse(all(s));
        cout << s << endl;
        
    }
}