#define _GLIBCXX_DEBUG

#include "bits/stdc++.h"

#define int long long
#define ll long long
#define all(x) begin(x), end(x)
#define pii pair<int, int>

using namespace std;
const int max_n = 2e5 + 100;
const int inf = 998244353;


int lp[max_n];

pii val[max_n];

pii vec[max_n];

struct prek {
    int to, a, b;

    prek() {}

    prek(int to, int a, int b) : to(to), a(a), b(b) {}
};

int timer = 1;


vector<prek> gr[max_n];

vector<pii > g(int x) {
    vector<pii > ans;
    while (x != lp[x]) {
        int o = lp[x];
        int cnt = 0;
        while (x % o == 0)
            cnt++, x /= o;
        ans.emplace_back(o, cnt);
    }
    if (x != 1)
        ans.emplace_back(x, 1);
    return ans;
}

vector<pii > f(int a, int b) {
    map<int, int> mp;
    auto o1 = g(a);
    auto o2 = g(b);
    for (pii c : o1)
        mp[c.first] = -c.second;
    for (pii c : o2)
        mp[c.first] = mp[c.first] + c.second;
    vector<pii > ans;
    for (pii o3 : mp)
        ans.emplace_back(o3);
    return ans;
}

set<int> touched;

void add(int x, int cnt) {
    if (val[x].first != timer) {
        val[x] = {timer, 0}, touched.insert(x);
    }
    if (vec[x].first != timer)
        vec[x] = {timer, 0};
    val[x].second += cnt;
    vec[x].second = max(vec[x].second, val[x].second);
}


void dfs(int v, int par) {
    for (prek to  :gr[v]) {
        if (to.to == par) continue;
        int a = to.a;
        int b = to.b;
        int g = __gcd(a, b);
        a /= g;
        b /= g;
        auto o = f(a, b);
        for (pii c : o)
            add(c.first, c.second);
        dfs(to.to, v);
        for (pii c : o)
            add(c.first, -c.second);
    }
}

int bin_pow(int a, int b) {
    int ans = 1;
    while (b) {
        if (b & 1) ans *= a;
        a *= a;
        a %= inf;
        ans %= inf;
        b >>= 1;
    }
    return ans;
}

int inv[max_n];

int inv_(int x) {
    return bin_pow(x, inf - 2);
}

int glob = 0;

void dfs2(int v, int par, int pref) {
    glob += pref;
    for (prek to : gr[v]) {
        if (to.to == par) continue;
        dfs2(to.to, v, (((pref * to.a) % inf) * inv[to.b]) % inf);
    }
}


signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
#ifdef EDILYA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    iota(all(lp), 0);
    for (int i = 2; i < max_n; i++) {
        if (lp[i] != i) continue;
        for (int j = i * i; j < max_n; j += i)
            lp[j] = min(lp[j], i);
    }
    for (int i = 1; i < max_n; i++)
        inv[i] = inv_(i);
    int t = 1;
    cin >> t;
    while (t--) {
        timer++;
        touched.clear();
        int n;
        cin >> n;

        for (int i = 0; i < n; i++)
            gr[i].clear();
        for (int i = 0; i < n - 1; i++) {
            int v, u, a, b;
            cin >> v >> u >> a >> b;
            v--, u--;
            gr[v].emplace_back(u, b, a);
            gr[u].emplace_back(v, a, b);
        }
        dfs(0, 0);
        int loc = 1;
        for (int c = 0; c < max_n; c++) {
            if (vec[c].second <= 0) continue;
            loc *= bin_pow(c, vec[c].second);
            loc %= inf;
        }
        dfs2(0, 0, loc);
        cout << glob % inf << '\n';
        glob = 0;
    }
}