#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

#define ll long long
#define pb push_back
#define f first
#define s second
#define ld long double

using namespace std;
using namespace __gnu_pbds;

typedef tree<ll, null_type, less<ll>, rb_tree_tag,
tree_order_statistics_node_update> oset;

const ll MOD = 998244353;
const ll N = 2e5 + 7;
vector<pair<ll, pair<ll,ll>>> v[N];
ll a1[N], x[N], y[N];
vector<ll> del[N];
ll obr[N];

ll bin_pow(ll a, ll st) {
if(st == 0) return 1;
if(st % 2) return (a * 1ll * bin_pow(a, st - 1)) % MOD;
ll x = bin_pow(a, st / 2);
return (x * 1ll * x) % MOD;
}
void dfs(ll v1, ll pr) {
  for(auto to: v[v1]) {
	if(to.f == pr) continue;
	for(auto to2: del[to.s.f]) {
		x[to2]++;
	}
   for(auto to2: del[to.s.s]) {
		y[to2]++;
		while(a1[to2] + x[to2] - y[to2] < 0) a1[to2]++;
	}
	dfs(to.f, v1);
  for(auto to2: del[to.s.f]) {
		x[to2]--;
	}
   for(auto to2: del[to.s.s]) {
		y[to2]--;
	}
  }
}
ll ans = 0;
ll a;
void dfs2(ll v1, ll pr) {
ans += a;
ans %= MOD;
for(auto to: v[v1]) {
	if(to.f == pr) continue;
	for(auto to2: del[to.s.f]) {
		a = (a * 1ll * to2) % MOD;
	}
   for(auto to2: del[to.s.s]) {
		a = (a * 1ll * obr[to2]) % MOD;
	}
	dfs2(to.f, v1);
	for(auto to2: del[to.s.s]) {
		a = (a * 1ll * to2) % MOD;
	}
   for(auto to2: del[to.s.f]) {
		a = (a * 1ll * obr[to2]) % MOD;
	}
  }
}
int32_t main() {
	
cin.tie(0);
cout.tie(0);
ios_base::sync_with_stdio(0);

#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif // LOCAL
    
    for(ll j = 2; j < N; j++) {
		  if(del[j].size() == 0) {
				obr[j] = bin_pow(j, MOD - 2);
			for(ll q = j; q < N; q+= j) {
				 ll e = q;
				 while(e % j == 0) del[q].pb(j), e /= j;
			}
		  }
    }
	ll t;
	cin >> t;
	while(t--) {
	    ll n;
	    cin >> n;
	    for(int j = 1; j <= n; j++) {
				v[j - 1].clear();
			a1[j] = 0; x[j] = 0; y[j] = 0;
	    }
	    for(int s = 0; s < n - 1; s++) {
			ll i, j, x, y;
			cin >> i >> j >> x >> y;
			i--; j--;
			v[i].pb({j, {y, x}});
			v[j].pb({i, {x, y}});
	    }
	    ll root = 0;
	    while(v[root].size() > 1) root++;
        dfs(root, root);
        a = 1; ans = 0;
        for(ll j = 1; j <= n; j++) {
			if(a1[j]) while(a1[j]--) {
				a = (a * 1ll * j) % MOD;
			}
        }	
        dfs2(root, root); 
        cout << ans << '\n';   
	}
}
