#include <iostream>
#include <algorithm>
#include <cstdio>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <random>
#include <chrono>
#include <bitset>
#include <vector>
#include <immintrin.h>
#include <stack>
#include <deque>
#include <queue>

void solve(int64_t x, std::map<int64_t, int32_t>& hist, bool& ok) {
    if(hist[x] > 0) {
        hist[x]--;
        return;
    }
    if(x == 1) {
        ok = false;
        return;
    }
    int64_t m = x / 2;
    solve(m, hist, ok);
    if(!ok)
        return;
    solve(x - m, hist, ok);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0 ;t < num_tests; t++) {
        int32_t n;
        std::cin >> n;

        int32_t* arr = new int32_t[n];
        for(int32_t i = 0; i < n; i++)
            std::cin >> arr[i];

        std::map<int64_t, int32_t> hist;
        for(int32_t i = 0; i < n; i++)
            hist[arr[i]]++;

        int64_t sum = 0;
        for(int32_t i = 0; i < n; i++)
            sum += arr[i];

        bool ok = true;
        solve(sum, hist, ok);
        std::cout << (ok ? "YES" : "NO") << "\n";
    }
    return 0;
}




