#include <bits/stdc++.h>
#define vec vector
#define fi first
#define se second
#define umap unordered_map
#define uste unordered_set
#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define endl "\n"

int mod = 998244353;

using namespace std;

//mt19937 gen(time(0));

vec<int> fun(int x) {
    vec<int> ans;
    for (int i = 2; i * i <= x; ++i) {
        if (x % i == 0) {
            ans.push_back(i);
            x /= i;
            i--;
        }
    }
    if (x != 1) ans.push_back(x);
    return ans;
}

vec<int> cou1, cou2, ans;

vec<vec<pair<int, pair<int, int>>>> v;
vec<pair<int, int>> drb;

int fst(int a, int b) {
    if (b == 0) return 1;
    if (b % 2 == 0) return fst((a * a) % mod, b / 2);
    return (fst(a, b - 1) * a) % mod;
}

void dfs(int now, int p) {
    //cout << "DFS " << now << ' ' << p << endl;
    for (int i = 0; i < v[now].size(); ++i) {
        int ne = v[now][i].fi;
        auto [x, y] = v[now][i].se;
        auto [x1, y1] = drb[now];
        if (ne == p) continue;
        vec<int> v1 = fun(x), v2 = fun(y);
        vec<pair<int, int>> d1, d2;
        vec<int> vx, vy;
        for (auto it: v1) {
            if (cou2[it] > 0) {
                cou2[it]--;
                x1 = (x1 * it % mod);
                d2.push_back({it, +1});
            } else {
                vx.push_back(it);
            }
        }
        for (auto it: v2) {
            if (cou1[it] > 0) {
                cou1[it]--;
                y1 = (y1 * it) % mod;
                d1.push_back({it, +1});
            } else {
                vy.push_back(it);
            }
        }
        for (auto it: vx) {
            cou1[it]++;
            x1 = (x1 * it) % mod;
            ans[it] = max(ans[it], cou1[it]);
            d1.push_back({it, -1});
        }
        for (auto it: vy) {
            cou2[it]++;
            y1 = (y1 * it) % mod;
            d2.push_back({it, -1});
        }
        drb[ne] = {x1, y1};
        dfs(ne, now);
        for (auto [a, b]: d1) cou1[a] += b;
        for (auto [a, b]: d2) cou2[a] += b;
    }
    //for (auto it: cou1) cout << it << ' ';
    //cout << endl;
    /*int u = 1;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < cou1[i]; ++j) {
            u = (u * i) % mod;
        }
    }
    int s = 0;*/
}

void solve() {
    int n; cin >> n;
    v.clear();
    v.resize(n);
    cou1.clear();
    cou2.clear();
    ans.clear();
    drb.clear();
    drb.resize(n, {1, 1});
    cou1.resize(n + 1, 0);
    cou2.resize(n + 1, 0);
    ans.resize(n + 1, 0);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        a--; b--;
        int g = __gcd(c, d);
        c /= g;
        d /= g;
        v[a].push_back({b, {c, d}});
        v[b].push_back({a, {d, c}});
    }
    dfs(0, -1);
    /*for (auto it: ans) cout << it << ' ';
    cout << endl;
    for (auto it: drb) cout << it.fi << ' ' << it.se << endl;*/
    int u = 1;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < ans[i]; ++j) u = (u * i) % mod;
    }
    //cout << u << endl;
    int s = u;
    for (int i = 1; i < n; ++i) {
        int w = (u * drb[i].se) % mod;
        w = (w * fst(drb[i].fi, mod - 2)) % mod;
        s = (s + w) % mod;
    }
    cout << s << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.in", "r", stdin);
    int tests = 1;
    cin >> tests;
    while (tests > 0) {
        solve();
        tests--;
    }
    return 0;
}
