#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <set>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

#define endl '\n'

int t;
int n;
multiset<long long> target;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n;
		long long sum = 0;
		target.clear();
		for (int i = 0; i < n; i++)
		{
			int a;
			cin >> a;
			target.insert(a);
			sum += a;
		}

		queue<long long> que;
		que.push(sum);
		for (int i = 0; i < n - 1; i++)
		{
			long long x = que.front();
			que.pop();

			long long p1 = x / 2LL;
			auto it = target.find(p1);
			if (it != target.end() && *it == p1)
			{
				target.erase(it);
			}
			else
			{
				que.push(p1);
			}

			long long p2 = x - p1;
			it = target.find(p2);
			if (it != target.end() && *it == p2)
			{
				target.erase(it);
			}
			else
			{
				que.push(p2);
			}
		}

		if (que.empty() || n == 1)
		{
			cout << "YES" << endl;
		}
		else
		{
			cout << "NO" << endl;
		}
	}
}