#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <cstring>
#include <vector>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define puf push_front
#define pob pop_back
#define pof pop_front


#define int long long

using namespace std;
//using namespace __gnu_pbds;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
//typedef tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update> ord_set;




const int MOD = 998244353;


int mult(int a, int b) {
    return (1ll * a * b) % MOD;
}


int fast_add(int a, int p) {
    int b = 1;

    while (p) {
        if (p & 1) {
            b = mult(a, b);
        }

        a = mult(a, a);
        p >>= 1;
    }

    return b;
}

int inv(int a) {
    return fast_add(a, MOD - 2);
}




struct dot {
    int u, x, y;
};

vector<vector<dot> > g;

int ans = 0;

vector<int> cur;

vector<int> visited;
vector<int> used;

vector<int> seg;
vector<int> dv;


void dfs(int v, int p = -1, int d = 1) {
    int ok = 0;


    if (p != -1 && used[p]) {

        dot to;
        for (dot tmp : g[v]) {
            if (tmp.u == p) {
                to = tmp;
                break;
            }
        }

        int u = p;

        cur[v] = mult(cur[u], to.x);
        int l = lcm(cur[v], to.y) % MOD;

        l = mult(l, inv(cur[v]));

        for (int x : visited) {
            cur[x] = mult(cur[x], l);
        }

        cur[v] = mult(mult(cur[u], to.x), inv(to.y));
        visited.pub(v);
        ok = 1;

        //cout << "!!! " << v<< " " << u << " " << cur[u] << " " << to.x << " "  << to.y << "\n";
        used[v] = 1;
    }


    for (dot to : g[v]) {
        int u = to.u;
        if (u == p) {
            continue;
        }

        dfs(u, v);
    }
}



void solve_solve_solve() {
    int n;
    cin >> n;


    g.clear();
    g.resize(n);

    cur.assign(n, 1);
    used.assign(n, 0);
    visited.clear();

    dv.resize(n, 1);

    for (int i = 0; i < n - 1; i++) {
        int v, u, x, y;
        cin >> v >> u >> x >> y;

        v--, u--;

        int G = gcd(x, y);
        x /= G;
        y /= G;

        g[v].pub({u, x, y});
        g[u].pub({v, y, x});
    }

    used[0] = 1;
    visited.pub(0);
    dfs(0);

    /*
    cout << "cur = \n";
    for (int i : cur) {
        cout << i << " ";
    }
    cout << "\n\n";
       */

    int ans = 0;

    for (int i = 0; i < n; i++) {
        cur[i] = mult(cur[i], inv(dv[i]));
    }

    for (int i = 0; i < n; i++) {
        ans += cur[i];
        ans %= MOD;
    }

    cout << ans << "\n";
}


signed main() {
    //fill_primes();

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);


    int Q = 1;
    cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
