#pragma GCC("-O3, no-stack-protector")
#pragma GCC("unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <cstring>
#include <vector>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define puf push_front
#define pob pop_back
#define pof pop_front


using namespace std;
//using namespace __gnu_pbds;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
//typedef tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

const int NMAX = 100010;

int a[NMAX];

void solve_solve_solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    unordered_map<int, int> dp[n];

    int d;
    for (int i = 1; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            d = a[i] - a[j];
            if (d % (j - i)) {
                continue;
            }
            d /= (j - i);
            if (dp[i].find(d) != dp[i].end()) {
                continue;
            }

            if (dp[j].find(d) == dp[j].end()) {
                dp[i][d] = 2;
            } else {
                dp[i][d] = dp[j][d] + 1;
            }
        }
    }

    int res = 1;

    for (int i = 0; i < n; i++) {
        for (auto it : dp[i]) {
            res = max(res, it.y);
            /*
            if (it.x == -1) {
                cout << "??? " << i << " " << it.x << " " << it.y << "\n";
            }

            if (it.y == 4) {
                cout << "!!! " << i << " " << it.x << "\n";
            }
            */
        }
    }

    //cout << "res = " << res << "\n";


    cout << n - res << "\n";

}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);


    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
