#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pb push_back
#define sz(a) int32_t(a.size())
#define endl '\n'
//#define int long long

const int N = 2e5 + 100;
const int M = 26;
const int mod = 998244353;
const int inf = 1e9 + 7;

int a[N], ans[N], lp[N], cnt[N], mn[N], ch, used[N], del[N], uk;
vector < int > pr;
vector < pair < int, pair < int, int > > > g[N];
vector < pair < int, int > > P[N];

int bp(int a, int i)
{
    int ans = 1;
    for(; i > 0; i /= 2)
    {
        if (i % 2) ans = (1ll * ans * a) % mod;
        a = (1ll * a * a) % mod;
    }
    return ans;
}

void DFS(int v, int pr)
{
    for(auto to: g[v])
    {
        if (to.F == pr) continue;
        vector < int > all;
        for(auto x: P[to.S.F])
        {
            cnt[x.F] -= x.S;
            all.pb(x.F);
        }
        for(auto x: P[to.S.S])
        {
            cnt[x.F] += x.S;
            all.pb(x.F);
        }
        for(auto to: all)
            mn[to] = min(mn[to], cnt[to]);
        DFS(to.F, v);
        for(auto x: P[to.S.F])
            cnt[x.F] += x.S;
        for(auto x: P[to.S.S])
            cnt[x.F] -= x.S;
    }
}

void dfs(int v, int pr)
{
    for(auto to: g[v])
    {
        if (to.F == pr) continue;
        ans[to.F] = (1ll * ans[v] * bp(to.S.F, mod - 2)) % mod;
        ans[to.F] = (1ll * ans[to.F] * to.S.S) % mod;
        dfs(to.F, v);
    }
}

void solve()
{
    int n;
    cin >> n;
    for(int i = 0; i <= n; i++)
    {
        g[i].clear();
        mn[i] = cnt[i] = 0;
    }
    int st;
    for(int i = 0; i < n - 1; i++)
    {
        int x, y, c, d;
        cin >> x >> y >> c >> d;
        x--; y--;
        g[x].pb({y, {c, d}});
        g[y].pb({x, {d, c}});
    }
    int root = 0;
    for(int i = 0; i < n; i++)
    {
        if (sz(g[i]) < 2)
        {
            root = i;
            break;
        }
    }
    DFS(root, root);
    ch = 1;
    for(int i = 2; i <= n; i++)
        if (mn[i] < 0) ch = (1ll * ch * bp(i, abs(mn[i]))) % mod;
    ans[root] = ch;
    dfs(root, root);
    int sum = 0;
    for(int i = 0; i < n; i++)
    {
        sum += ans[i];
        sum %= mod;
    }
    cout << sum << endl;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    for(int i = 2; i < N; i++)
    {
        if (lp[i] == 0)
        {
            lp[i] = i;
            pr.pb(i);
        }
        for(int j = 0; j < pr.size() && pr[j] <= lp[i] && pr[j] * i < N; j++)
            lp[pr[j] * i] = pr[j];
    }

    for(int i = 2; i < N; i++)
    {
        int ch = i;
        while (ch > 1)
        {
            int d = lp[ch];
            if (!sz(P[i]) || P[i].back().F != d) P[i].pb({d, 1});
            else P[i].back().S++;
            ch /= d;
        }
    }

    int T;
    cin >> T;
    while (T--)
        solve();
}
