#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>

#define int long long
#define sz(x) (int)x.size()
#define pw(x) (1LL<<x)
#define sqr(x) ((x)*(x))
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pii pair<int,int>
#define fi first
#define se second
#define p_b push_back
#define m_p make_pair

using namespace std;

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int T;
    cin >> T;
    while(T--)
    {
        int n;
        cin >> n;
        vector < int > a(n);
        for(auto &i : a)
            cin >> i;
        int sum = 0;
        unordered_map < int, int > cnt;
        for(auto &i : a)
        {
            sum += i;
            cnt[i]++;
        }
        queue < int > q;
        q.push(sum);
        while(sz(q) && sz(q) <= n)
        {
            int w = q.front();
            q.pop();
            if(cnt[w])
            {
                cnt[w]--;
                continue;
            }
            q.push(w / 2);
            q.push((w + 1) / 2);
        }
        cout << (sz(q) ? "NO\n" : "YES\n");
    }
    return 0;
}
