#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <random>
#include <vector>
#include <queue>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,mmx,abm,popcnt,tune=native")

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef long double ld;

const ll cst = 3e5 + 5;
const ll inf = (ll)1e18 + 228;
const ll mod = 1e9 + 7;

void operator delete(void*);

inline void solve() {
	ll n;
	cin >> n;
	vector<ll> vc(n);
	for (ll& i : vc) cin >> i;
	sort(all(vc));
	reverse(all(vc));
	cout << vc[0] + vc[1];
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
	return 0;
}