#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <random>
#include <vector>
#include <queue>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,mmx,abm,popcnt,tune=native")

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef long double ld;

const ll cst = 3e5 + 5;
const ll inf = (ll)1e18 + 228;
const ll mod = 998244353;

void operator delete(void*);

/*

cout << rand() = OK 100% probability

*/

ll n;

ll arr[cst];

mt19937 gen(1227133769);

ll gcd(ll a, ll b) {
	return (b) ? (gcd(b, a % b)) : (a);
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll str = clock();
	cin >> n;
	for (ll i = 0; i < n; i++) cin >> arr[i];
	ll answ = n - 2;
	vector<ll> sfl(n, 0);
	iota(all(sfl), 0);
	shuffle(all(sfl), gen);
	for (ll _ = 0; _ < n; _++) {
		if (clock() - str >= 4900) break;
		ll as = sfl[_];
		vector<pair<ll, ll>> vc;
		for (ll i = 0; i < n; i++) {
			if (i == as) continue;
			ll ch = arr[i] - arr[as];
			ll zn = i - as;
			if (zn < 0) {
				zn = -zn;
				ch = -ch;
			}
			ll gc = gcd(abs(ch), zn);
			ch /= gc;
			zn /= gc;
			vc.push_back({ ch, zn });
		}
		sort(all(vc));
		ll cnt = 1;
		for (ll i = 1; i < vc.size(); i++) {
			if (vc[i] == vc[i - 1]) cnt++;
			else cnt = 1;
			answ = min(answ, n - cnt - 1);
		}
	}
	cout << max(0ll, answ);
	return 0;
}