#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 2e5 + 100, INF = 1e18, BASE = 131, MOD = 1e9 + 7;
const double EPS = 0.0001;

int t, n, a[N], sum, e;
map<int, int> cnt;
bool ok;

void dfs(int x) {
    if (cnt.count(x) && cnt[x] > 0) {
        cnt[x]--;
        return;
    }
    e++;
    if (e > n - 1) {
        ok = false;
        return;
    }
    dfs(x / 2);
    if (e > n - 1) {
        ok = false;
        return;
    }
    dfs(x / 2 + x % 2);
}

void solve() {
    cin >> t;
    while (t--) {
        cin >> n;
        sum = 0;
        e = 0;
        cnt.clear();
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            sum += a[i];
            cnt[a[i]]++;
        }
        ok = true;
        dfs(sum);
        if (ok) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }
}
