#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, K = 200, INF = 1e18, BASE = 131, MOD = 998244353;
const double EPS = 0.0001;

int n, a[N], cnt[2 * N], ans = 2;

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (n <= 2) {
        cout << n;
        return;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < K && i + j < n; j++) {
            if ((a[i + j] - a[i]) % j == 0) {
                cnt[(a[i + j] - a[i]) / j + N]++;
                ans = max(ans, cnt[(a[i + j] - a[i]) / j + N] + 1);
            }
        }
        for (int j = 1; j < K && i + j < n; j++) {
            if ((a[i + j] - a[i]) % j == 0) {
                cnt[(a[i + j] - a[i]) / j + N]--;
            }
        }
    }
    unordered_map<int, int> ma;
    for (int d = -K; d <= K; d++) {
        ma.clear();
        for (int i = 0; i < n; i++) {
            ma[a[i] - d * i]++;
            ans = max(ans, ma[a[i] - d * i]);
        }
    }
    cout << n - ans;
}
