#include<iostream>
#include<vector>
#include<stack>
#include<deque>
#include<iomanip>
#include<algorithm>
#include<map>
#include<string>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b)
{
	if (a == 0)
		return b;
	while (b != 0)
	{
		ll t = a % b;
		a = b;
		b = t;
	}
	return a;
}

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return bin_pow(a, step - 1) * a;
	ll now = bin_pow(a, step / 2);
	return now * now;
}

void solveA()
{
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		vector<int>a(n);
		for (auto& i : a)
			cin >> i;
		sort(a.rbegin(), a.rend());
		cout << a[0] + a[1]<<"\n";
	}
}

int main() {
	solveA();
}