#include<iostream>
#include<vector>
#include<stack>
#include<deque>
#include<iomanip>
#include<algorithm>
#include<set>
#include<map>
#include<string>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b)
{
	if (a == 0)
		return b;
	while (b != 0)
	{
		ll t = a % b;
		a = b;
		b = t;
	}
	return a;
}

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return bin_pow(a, step - 1) * a;
	ll now = bin_pow(a, step / 2);
	return now * now;
}

void solveC()
{
	int t;
	cin >> t;
	while (t--)
	{
		multiset<ll>a, b;
		ll sum = 0;
		int n;
		cin >> n;
		while (n--)
		{
			ll q;
			cin >> q;
			a.insert(q);
			sum += q;
		}
		b.insert(sum);
		bool f = 0;
		while (true)
		{
			auto p = *b.begin();
			b.erase(b.begin());
			auto l = a.find(p);
			if (l != a.end())
			{
				a.erase(l);
			}
			else
			{
				b.insert(p / 2);
				b.insert((p + 1) / 2);
			}
			if (a.size() == 0)
				break;
			if (*b.begin() < *a.begin())
			{
				f = 1;
				break;
			}
		}
		if (!f)
			cout << "yes\n";
		else
			cout << "no\n";
	}
}
	

int main() {
	solveC();
}