#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define pii pair<int, int>
#define f first
#define s second
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve(){
    int n;
    cin >> n;
    vector<ll>a(n);
    ll sum = 0;
    map<ll, int>fr;
    for(auto &x: a){
        cin >> x;
        sum += x;
        fr[x]++;
    }
    if(n == 1){
        cout << "Yes\n";
        return;
    }
    multiset<ll, greater<ll>>st;
    st.insert(sum);
    int iter = 0;
    while(!st.empty() && iter < n - 1){
        iter++;
        ll x = *st.begin();  
        if(fr.count(x) && fr[x] > 0){
            fr[x]--;
            st.erase(st.begin());
            iter--;
        }
        else{
            //cout << x << ' ';
            st.erase(st.begin());
            st.insert(x / 2);
            st.insert((x + 1) / 2);
        }
    }
    //cout << '\n';
    if(st.size()){
        for(auto it = st.begin(); it != st.end(); it++){
            //cout << *it << ' ';
            if(fr.count(*it) && fr[*it] > 0){
                fr[*it]--;
            }
            else{
                cout << "No\n";
                return;
            }
        }
        cout << "Yes\n";
    }
    else cout << "Yes\n";
}

int main(){
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}