﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>
#include <random>
#include <cassert>

using namespace std;

#define int long long
#define double long double
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))

const int INF = 1e9 + 7;
const int MOD = 998244353;
const int N = 1ll << 3;

const int al = 'z' - 'a' + 1;

void solve() {
    int n;
    cin >> n;
    vi a(n);
    multiset<int> st;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        st.insert(a[i]);
    }
    while ((int)st.size() > 1) {
        int a1 = *st.begin();
        st.erase(st.begin());
        int a2 = *st.begin();
        st.erase(st.begin());
        if (a2 - a1 > 1) {
            cout << "NO\n";
            return;
        }
        st.insert(a1 + a2);
    }
    cout << "YES\n";
}

signed  main(){
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
