#include<algorithm>
#include<iostream>
#include<vector>
#include<string>
#include<unordered_map>

using namespace std;

void solve() {
	int n; cin >> n; 
	long long sum = 0;
	unordered_map<long long, int> cnt;
	for (int i = 0; i < n; ++i) {
		int a; cin >> a;
		cnt[a]++;
		sum += a;
	}

	if (n == 1) {
		cout << "YES\n"; return;
	}

	vector<long long> q = { sum };
	while (!q.empty()) {
		long long curr = q.back(); q.pop_back();
		long long n1 = curr / 2;
		long long n2 = curr - n1;
		auto it = cnt.find(n1);
		if (it != cnt.end() && it->second > 0) {
			--it->second;
		}
		else {
			if (n1 == 1) {
				cout << "NO\n"; return;
			}
			q.push_back(n1);
		}
		it = cnt.find(n2);
		if (it != cnt.end() && it->second > 0) {
			--it->second;
		}
		else {
			if (n2 == 1) {
				cout << "NO\n"; return;
			}
			q.push_back(n2);
		}
	}
	cout << "YES\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int ttt; cin >> ttt;
	while (ttt > 0) {
		solve(); --ttt;
	}
	return 0;
}