#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
//using namespace __gnu_pbds;


//typedef tree <int,null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

#define int int64_t
#define pii pair <int,int>
#define F first
#define S second

//#define min(a,b) ((a<b)?a:b)
//#define max(a,b) ((a<b)?b:a)

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 2e5+27, M = 998244353, lg = 20;

int sum (int a, int b) {
    a += b;
    if (a >= M) a -= M;
    return a;
}

int mul (int a, int b) {
    return (a*1ll*b)%M;
}

int bp (int x, int y) {
    if (y == 0) {
        return 1;
    }
    if (y&1) {
        return mul(x, bp(x, y-1));
    }
    int z = bp(x, y/2);
    return mul(z, z);
}

vector<pii> g[N];
vector<pair<int,pii>> G[N];

int sm = 0;
int pr = 0;

void dfs (int v, int p, int w) {
//    cout << v << ' ' << p << ' ' << w << endl;
    sm = sum(sm, w);
    for (auto i:g[v]) {
        if (i.F != p) {
            dfs (i.F, v, mul(i.S, w));
        }
    }
}

map <int,int> now, mx;

vector <pii> fact[N];


void DFS (int v, int p, int c, int d) {
    for (pii i:fact[c]) {
        now[i.F] -= i.S;
    }
    for (pii i:fact[d]) {
        now[i.F] += i.S;
        mx[i.F] = max(mx[i.F], now[i.F]);
    }
    for (auto i:G[v]) {
        if (i.F != p) {
            DFS(i.F, v, i.S.F, i.S.S);
        }
    }
    for (pii i:fact[c]) {
        now[i.F] += i.S;
    }
    for (pii i:fact[d]) {
        now[i.F] -= i.S;
    }
}

void solve () {
    int n;
    cin >> n;
    sm = 0;
    pr = 1;
    now.clear();
    mx.clear();
    for (int i=0;i<n;++i) {
        g[i].clear();
    }
    for (int i=0;i<n;++i) {
        G[i].clear();
    }
    for (int i=0;i<n-1;++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        int gc = __gcd(c, d);
        c /= gc;
        d /= gc;
        int c1 = bp(c, M-2), d1 = bp(d, M-2);
        a--;b--;
        g[b].push_back(pii{a, mul(c, d1)});
        g[a].push_back(pii{b, mul(d, c1)});
        G[b].push_back({a, pii{c, d}});
        G[a].push_back({b, pii{d, c}});
    }

    dfs (0, 0, 1);
    DFS (0, 0, 1, 1);

    for (auto i:mx) {
//        cout << i.F << ' ' << i.S << '\n';
        pr = mul(pr, bp(i.F, i.S));
    }

    cout << mul(sm, pr) << '\n';
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    for(int i=0;i<N;++i) {
        int x = i;
        for (int j=2;j*j<=x;++j) {
            if (x % j == 0) {
                int cnt= 0 ;
                while (x % j == 0) {
                    x /= j;
                    cnt++;
                }
                fact[i].push_back({j, cnt});
            }
        }
        if (x > 1) {
            fact[i].push_back({x, 1});
        }
    }
    int q = 1;
    cin >> q;
    for (;q;--q) {
        solve();
    }

    return 0;
}
