#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve() {
    string s;
    cin >> s;
    vector<int> cnt(26, 0);
    for (auto &elem : s) ++cnt[elem - 'a'];
    int n = s.size();
    int i;
    for (i = 0; i < n; ++i) {
        if (cnt[s[i] - 'a'] == 1) break;
        --cnt[s[i] - 'a'];
    }
    cout << s.substr(i) << en;
}

int32_t main() {
    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}