#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <random>

using namespace std;

mt19937 rnd(1337);

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
//#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve() {
    int n;
    cin >> n;
    const int k = 500;
    vector<int> a(n);
    for (auto &elem : a) cin >> elem;
//    vector<int> cnt(n + n, 0);
    int ans = min(n, 2);
    for (int d = -k; d <= k; ++d) {
        vector<int> aa(n);
        for (int i = 0; i < n; ++i) {
            aa[i] = a[i] - d * i;
        }
        sort(all(aa));
        int pr = INT32_MIN;
        int cnt = 0;
        int mx = 0;
        for (auto &elem : aa) {
            if (pr != elem) {
                mx = max(mx, cnt);
                cnt = 1;
            } else {
                ++cnt;
            }
            pr = elem;
        }
        mx = max(mx, cnt);
        ans = max(ans, mx);
    }

    int dx = (int(1e5) - 1) / (k - 1) + 10;

    for (int i = 0; i < n; ++i) {
        int l = max(0, i - dx + 1), r = min(i + dx, n);
        vector<int> d;
        for (int j = l; j < i; ++j) {
            if ((a[i] - a[j]) % (i - j) == 0) {
                d.push_back((a[i] - a[j]) / (i - j));
            }
        }

        for (int j = i + 1; j < r; ++j) {
            if ((a[j] - a[i]) % (j - i) == 0) {
                d.push_back((a[j] - a[i]) / (j - i));
            }
        }

        int pr = INT32_MIN;
        int cnt = 0;
        int mx = 0;
        for (auto &elem : d) {
            if (pr != elem) {
                mx = max(mx, cnt);
                cnt = 1;
            } else {
                ++cnt;
            }
            pr = elem;
        }
        mx = max(mx, cnt);
        ans = max(ans, mx + 1);
    }

    cout << n - ans;
}

int32_t main() {
    io();

#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}