#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

//tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update> Set;
//
const int TIME = std::chrono::system_clock::now().time_since_epoch().count();
//struct chash {
//    int operator()(int x) {
//        return x ^ RANDOM;
//    }
//};
//
//gp_hash_table<int, int, chash> table;

typedef long long ll;

#define int ll

std::mt19937 rnd(TIME);

const int MAXN = 1e5;
int a[MAXN];

void solve() {
    double START = clock();

    int n;
    std::cin >> n;
    for (auto &i : a) std::cin >> i;
    int ans = std::max(0ll, n - 2);
    int doneOps = 0;
    while (true) {
        if (doneOps >= 1'000'000 && (double)clock() - START > 4.8 * CLOCKS_PER_SEC) {
            break;
        }
        int i = rnd() % n;
        int j = rnd() % n;
        doneOps += 5;
        if (i > j) std::swap(i, j);
        if (i == j || (a[j] - a[i]) % (j - i)) continue;
        int k = (a[j] - a[i]) / (j - i);
        int now = 0;
        for (int z = 0; z < n; z++) {
            doneOps++;
            now += a[z] != a[i] + k * (z - i);
        }
        ans = std::min(ans, now);
    }
    std::cout << ans << '\n';
}

signed main() {
    int t = 1;
//    std::cin >> t;
    while (t--) {
        solve();
    }
}
