#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    do { solve(); } while (--t);
    return 0;
}

template<typename T>
void setMax(T &t, T other) { t = max(t, other); }

template<typename T>
void setMin(T &t, T other) { t = min(t, other); }

#define answerExit(ans) { cout << (ans) << '\n'; exit(0); }
#define answerReturn(ans) { cout << (ans) << '\n'; return; }

const int N = 1e5;
const int A = 1e5;
const int B = 0.6e3;
int cnt[N * B + 3 * A];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &x : a) cin >> x;
    int ans = 0;
    for (int s = -B; s <= B; ++s) {
        int delta = (s >= 0 ? 0 : -s * (n - 1));
        for (int i = 0; i < n; ++i) {
            setMax(ans, ++cnt[a[i] + i * s + delta]);
        }
        for (int i = 0; i < n; ++i) {
            --cnt[a[i] + i * s + delta];
        }
    }
    for (int l = 0; l < n; l += N / 2 / B) {
        int r = min(n, l + N / B);
        for (int i = l; i < r; ++i) {
            for (int j = l; j < r; ++j) {
                if (i == j) continue;
                if ((a[j] - a[i]) % (j - i) != 0) continue;
                setMax(ans, ++cnt[(a[i] - a[j]) / (i - j) + A] + 1);
            }
            for (int j = l; j < r; ++j) {
                if (i == j) continue;
                if ((a[j] - a[i]) % (j - i) != 0) continue;
                --cnt[(a[i] - a[j]) / (i - j) + A];
            }
        }
    }
    cout << n - ans << '\n';
}
