#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <x86intrin.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <bitset>
#include <climits>
#include <cstdio>
#include <array>
#include <string>
#include <set>
#include <map>
#include <random>

int main()
{
	//int n; std::cin >> n;
	//std::mt19937 mt;
	//// 10^10?
	//// n-2 upper bound (change all other numbers to fit)
	//// probability to find progression by guessing randomly: roughly (length / n)^2
	//// only integers!! prune random guessing?
	//// if elements are at distance d, their difference must be divisible by d
	//// what if there are many matches
	//// random guessing can find long progressions, brute force can find short progressions
	//std::vector<int> dat(n);
	////for(int i = 0; i < n; i++) scanf("%d", &dat[i]);
	//for(int i = 0; i < n; i++) dat[i] = mt() % n;

	////for(int d = 1; d < dat.size(); d++)
	////{
	////	int ans = 0;
	////	for(int i = 0; i < dat.size() - d; i++)
	////	{
	////		int j = i + d;
	////		bool ok = (dat[j] - dat[i]) % d == 0;
	////		ans += ok;
	////	}
	////	printf("%d\n", ans);
	////}
	//for(int d = 0; d < 10; d++)
	//{
	//	// look at array modulo d for each prime d in decreasing order?
	//	// find pairs. if progression has difference divisible by d, elements must be the same
	//	// ~n pairs on average :(
	//	std::array<int,100001> ctrs {};
	//	for(int i = 0; i < n; i++)
	//	{
	//		int x = dat[i] + i*d;
	//		if(x < 0 || x > 100001) continue;
	//		ctrs[dat[i]+i*d] += 1;
	//	}
	//	int mc = 0;
	//	for(int x : ctrs) mc = std::max(mc, x);
	//	printf("%d\n", mc);
	//}

	// try all integer differences, subtract each progression from the entire array, build counters
	// 

	// find pair that remains unchanged?
	// try to keep at least 3 numbers
	// iterate over first two?
	// a[i] = x, a[j] = y 
	
	// f: assume set of letters is a..z
	// set letter a to be first.
	// try to set letter a to be second
	// t[i] = 'a' -> s[i^j] == 'a'
	// t[0] == 'a' and t[1] == 'a'
	// s[j] == 'a' and s[j^1]=='a'
	// maximize k such that s[j^{0..k-1}]=='a'
	// t[0] == 'a' and t[1] == 'a' and t[2] == 'a' and t[4] == 'a'
	// s[j] == 'a' and s[j^1] == 'a' and s[j^2] == 'a' and s[j^4] == 'a'

	int _ = 0; std::cin >> _;
	std::string s; std::cin >> s;
	int n0 = s.size();
	while(s.size() != 262144) s += "a";
	std::set<char> st;
	for(char c : s) st.insert(c);
	std::vector<int> comp(128);
	std::vector<int> icomp(128);
	int ii = 0;
	for(char c : st)
	{
		char t = ii++ + 'a';
		comp[c] = t;
		icomp[t] = c;
	}
	for(char& c : s)
	{
		//printf("%c -> %c\n", c, comp[c]);
		c = comp[c];
	}
	//for(char c : s)
	// create bit mask for each letter
	// maximize number of 'a' at beginning
	// rolling 'AND' with these bitmasks
	// b[i] = a[i^k]
	// reorder 256-bit chunks based on prefix of i (minus last 8 bits)
	// for each 256-bit chunk, and with pre-reordered version based on suffix of i
	// use avx2 manually? probably not
	// just use bitset...
	typedef std::bitset<262144> bits;
	typedef std::array<uint8_t, 32768> data;
	std::vector<std::array<data, 256>> rows(26);
	for(int i = 0; i < 26; i++)
	{
		bits b {};
		for(int j = 0; j < 262144; j++)
		{
			b[j] = s[j] == 'a'+i;
		}
		for(int x = 0; x < 256; x++)
		{
			data c {};
			for(int j = 0; j < 262144; j++)
				if(b[j^x])
				{
					//if(x == 0) printf("%d at %d\n", i, j);
					c[j/8] |= 1 << j % 8;
				}
			rows[i][x] = c;
		}
		//printf("i=%d\n", i);
	}
	alignas(32) data cur_dat {};
	for(int i = 0; i < 32768; i++) cur_dat[i] = 255;
	for(int i = 0; i < 262144; i++)
	{
		for(int c = 0; c < 26; c++)
		{
			//try to put c 
			__m256i* to = (__m256i*)&cur_dat;
			__m256i_u* from = (__m256i_u*)rows[c][i%256].data();
			// 32 bytes at a time, 1024 iterations
			bool ok = false;
			int fx = i / 256;
			for(int x = 0; x < 1024; x += 4)
			{
				__m256i a = to[x] & from[x ^ fx];
				__m256i b = to[x+1] & from[x+1 ^ fx];
				__m256i c = to[x+2] & from[x+2 ^ fx];
				__m256i d = to[x+3] & from[x+3 ^ fx];
				auto t = _mm256_testz_si256(a, a);
				t &= _mm256_testz_si256(b,b);
				t &= _mm256_testz_si256(c,c);
				t &= _mm256_testz_si256(d,d);
				if(t != 1) { ok = true; break; }
				//static_assert(std::is_same_v<decltype(t), int>);
				//test somehow. if zero, break and place this char
			}
			if(!ok)
			{
				//printf("i=%d: c=%d failed\n", i, c);
				continue;
			}
			//printf("i=%d: c=%d\n", i, c);
			for(int x = 0; x < 1024; x+= 4)
				to[x] &= from[x ^ fx],
				to[x+1] &= from[x+1 ^ fx],
				to[x+2] &= from[x+2 ^ fx],
				to[x+3] &= from[x+3 ^ fx];
			break;
		}
		if(i % 2048 == 0)
		{
			int pc = 0;
			uint64_t* a = (uint64_t*)cur_dat.data();
			for(int x = 0; x < 32768 / 8; x++)
				pc += __builtin_popcountll(a[x]);
			//printf("pc=%d\n", pc);
			if(pc < 128) break;
		}
		//if(i > 262144 - 10)
		if(false)
		{
			printf("i=%d\n", i);
			for(int x = 0; x < 262144; x++)
			{
				if((cur_dat[x/8] >> (x % 8) & 1) != 0) printf("%d ", x);
			}
			printf("\n");
		}
	}
	int j = 0;
	//std::vector<std::string> strs;
	std::string min = "~";
	for(int j = 0; j < 262144; j++)
	{
		bool ok = cur_dat[j/8]>>(j%8)&1;
		if(!ok) continue;
		std::string t;
		for(int i = 0; i < 262144; i++)
			t.push_back(s[i^j]);
		if(t < min) min = t;
	}
	min = min.substr(262144 - n0);
	//printf("%s\n", min.data());
	for(char& c : min) c = icomp[c];
	printf("%s\n", min.data());
}

