#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& i : (x)) cerr << i << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::::::::::::::::::::

const int N = 1e5 + 5, OFF = 4e5;

int a[N];
vector<int> ev[2 * OFF];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (i > 0) {
            int fst = a[i] % i;
            for (int x = fst; x < OFF; x += i) {
                ev[x + OFF].emplace_back((a[i] - x) / i);
            }
            for (int x = fst - i; x >= -OFF; x -= i) {
                ev[x + OFF].emplace_back((a[i] - x) / i);
            }
        }
    }

    int ans = n;
    for (int x = 0; x < 2 * OFF; ++x) {
        int res = 0;
        sort(ev[x].begin(), ev[x].end());
        int now = 0;
        for (int i = 0; i < ev[x].size(); ++i) {
            if (i == 0 || ev[x][i] != ev[x][i - 1])
                now = 1;
            else
                ++now;
            strain(res, now);
        }
        if (x - OFF == a[0])
            ++res;
        relax(ans, n - res);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}

