#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())

template<typename Fun>
struct y_combinator {
    const Fun fun;

    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

    template<typename... Tail>
    decltype(auto) operator()(Tail&&... tail) const {
        return fun(ref(*this), forward<Tail>(tail)...);
    }
};

constexpr int MAX_MEM = 500 * 100004;
pair<int, ll> big[MAX_MEM];
int it = 0;

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &x : a) cin >> x;

    constexpr int B = 425, A = 1e5 + 4, MAX_LEN = A / B + 2;
    for (int i = 0; i < n; i++) {
        for (int d = -B; d <= B; d++) {
            big[it++] = {d, a[i] - 1ll * i * d};
        }
    }

    int ans = 1;
    auto solve = [&]() {
        sort(big, big + it);
        for (int i = 0, j = 0; i < it; i = j) {
            while (j < it && big[i] == big[j]) j++;
            ans = max(ans, j - i);
        }
    };
    solve();

    it = 0;
    vector<int> used(2 * A, -1);
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - MAX_LEN); j < min(n, i + MAX_LEN); j++) {
            if (i != j && (a[i] - a[j]) % (i - j) == 0) {
                int d = (a[i] - a[j]) / (i - j);
                if (used[d + A] == i) continue;
                used[d + A] = i;
                if (d > B || d < -B) big[it++] = {d, a[i] - 1ll * i * d};
            }
        }
    }

    solve();
    cout << n - ans << '\n';
}
