#include <bits/stdc++.h>
#define ll long long
#define ull unsigned long long
#define ld long double
#define mp make_pair
#define f first
#define s second
#define pb push_back
using namespace std;
const int INF = (int)(1e9 + 7);
const ll INFll = (ll)(1e18 + 7);
const ld Pi = acos(-1.0);
const int MOD = 998244353;
ll bin_pow(ll base, ll pow, ll mod){
    ll ans = 1;
    while(pow){
        if(pow & 1){
            ans *= base;
            ans %= mod;
            pow --;
        }
        base *= base;
        base %= mod;
        pow = (pow >> 1);
    }
    return ans;
}
vector <pair <int, pair <int, int> > > g[300000];
ll cnt[300000];
set <int> primes;
map <int, int> prime_power, smallest_power;
void debug_primes(){
    for(auto it = primes.begin(); it != primes.end(); it ++){
        int curr = *it;
        cout << curr << ':' << prime_power[curr] << "  ";
    }
    cout << '\n';
    return;
}
void mult(int x){
    for(int i = 2; i * i <= x; i ++){
        while(x % i == 0){
            primes.insert(i);
            prime_power[i] ++;
            x /= i;
        }
    }
    if(x != 1){
        primes.insert(x);
        prime_power[x] ++;
    }
    return;
}
void divide(int x){
    for(int i = 2; i * i <= x; i ++){
        while(x % i == 0){
            primes.insert(i);
            prime_power[i] --;
            smallest_power[i] = min(smallest_power[i], prime_power[i]);
            x /= i;
        }
    }
    if(x != 1){
        primes.insert(x);
        prime_power[x] --;
        smallest_power[x] = min(smallest_power[x], prime_power[x]);
    }
    return;
}
void get_base(int v, int pr){
    //cout << "\t" << v << '\n';
    //debug_primes();
    for(int i = 0; i < g[v].size(); i ++){
        if(g[v][i].f == pr){
            continue;
        }
        mult(g[v][i].s.s);
        divide(g[v][i].s.f);
        get_base(g[v][i].f, v);
        mult(g[v][i].s.f);
        divide(g[v][i].s.s);
    }
    return;
}
void dfs(int v, int pr){
    for(int i = 0; i < g[v].size(); i ++){
        if(g[v][i].f == pr){
            continue;
        }
        cnt[g[v][i].f] = (((cnt[v] * g[v][i].s.s) % MOD) * bin_pow(g[v][i].s.f, MOD - 2, MOD)) % MOD;
        dfs(g[v][i].f, v);
    }
    return;
}
int main(){
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    //cout.precision(16);
    int t;
    cin >> t;
    for(int timer = 0; timer < t; timer ++){
        int n;
        ll ans = 0;
        cin >> n;
        for(int i = 1; i <= n; i ++){
            cnt[i] = 0;
            g[i].clear();
        }
        for(int k = 1; k < n; k ++){
            int i, j, x, y;
            cin >> i >> j >> x >> y;
            g[i].pb(mp(j, mp(x, y)));
            g[j].pb(mp(i, mp(y, x)));
        }
        get_base(1, -1);
        cnt[1] = 1;
        for(auto it = primes.begin(); it != primes.end(); it ++){
            int curr = *it;
            cnt[1] *= bin_pow(curr, -smallest_power[curr], MOD);
            cnt[1] %= MOD;
            //cout << "\t\t" << curr << ' ' << smallest_power[curr] << '\n';
        }
        //cout << '\t' << cnt[1] << '\n';
        dfs(1, -1);
        for(int i = 1; i <= n; i ++){
            ans += cnt[i];
            ans %= MOD;
            //cout << '\t' << i << ' ' << cnt[i] << '\n';
        }
        cout << ans << '\n';
        prime_power.clear();
        smallest_power.clear();
    }
    return 0;
}
