#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

#define all(x) x.begin(), x.end()
#define nl '\n'
#define deb(x) cout << #x << " = " << x << ' ';
#define deb(x) cout << #x << " = " << x << nl;
#define rep(n) for (int i = 0; i < (n); i++)


typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ll> pll;
typedef double D;
typedef long double LD;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<vvpll> vvvpll;

template<class T> void print(T a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << nl;
}

template<class T> void print2(T a) {
	for (auto x : a) {
		print(x);
	}
	cout << nl;
}

void fastio() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

unordered_map<ll, int> s;

bool dfs(ll x) {
	if (x == 0) return false;
	if (s[x] > 0 ) {
		s[x]--;
		return true;
	}
	ll a = (x) / 2;
	ll b = (x+1) / 2;
	bool flag1 = false, flag2 = false;
	flag1 = dfs(a);
	if (!flag1) return false;
	flag2 = dfs(b);
	return flag1 & flag2;
}

void solve() {
	ll n, x, sum = 0;
	s = unordered_map<ll, int>();
	cin >> n;
	s.reserve(4 * n);
	for (int i = 0; i < n; i++) {
		cin >> x;
		sum += x;
		s[x]++;
	}
	if (dfs(sum)) cout << "YES\n";
	else cout << "NO\n";
}

signed main() {
	fastio();
	int t = 1;
	cin >> t;
	while (t) {
		solve();
		t--;
	}
}