#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int binpow(int a, int n, int mod) {
    if (n == 0) {
        return 1;
    }
    if (n & 1) return 1ll * a * binpow(a, n - 1, mod) % mod;
    int t = binpow(a, n >> 1, mod);
    return 1ll * t * t % mod;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t --> 0) {
        int n;
        cin >> n;
        vector<int> a(n);
        map<ll, int> cnta, cntet;
        map<ll, bool> enq;
        ll s = 0;
        for (auto &now : a) {
            cin >> now;
            s += now;
            ++cnta[now];
        }
        if (n == 1) {
            cout << "YES\n";
            continue;
        }

        queue<ll> useless;
        useless.push(s);
        bool ok = true;
        cntet[s] = 1;
        while (!useless.empty()) {
            ll fr = useless.front();
            useless.pop();
            int diff = cntet[fr] - cnta[fr];
            if (fr == 1) {
                ok = false; 
                break;
            }
            ll n1 = (fr + 1) / 2;
            ll n2 = fr / 2;
            cntet[fr] -= diff;
            cntet[n1] += diff;
            cntet[n2] += diff;
            if (!enq[n1] && cntet[n1] > cnta[n1]) {
                useless.push(n1);
                enq[n1] = true;
                // --cntet[n1];
            }
            if (n2 != n1 && !enq[n2] && cntet[n2] > cnta[n2]) {
                enq[n2] = true;
                // --cntet[n2];
                useless.push(n2);
            }
        }
        if (ok) {
            cout << "YES\n";
        }
        else {
            cout << "NO\n";
        }
    }
    return 0;
}