#include <iostream>
#include <algorithm>
#include <bitset>
#include <map>
#include <random>
#include <set>
#include <vector>
using namespace std;
using ll = long long;

const int MAXN = 1e5 + 123;
const int SQN = 320;
int a[MAXN];
int cnt[MAXN];
bitset<SQN> used;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int ans = 0;
    // k < SQN
    for (int k = -SQN; k < SQN; ++k) {
        map<int, int> b;
        for (int i = 0; i < n; ++i)
            ++b[a[i] - i * k];
        for (auto [t, c] : b)
            ans = max(ans, c);
    }
    //cout << n - ans << '\n';
    // i - j < SQN
    for (int i = 0; i < n; ++i) {
        used = 0;
        for (int j = i + 1; j < n && j < i + SQN; ++j) {
            if (used[j - i] || (a[j] - a[i]) % (j - i) != 0)
                continue;
            int k = (a[j] - a[i]) / (j - i);
            int b = a[j];
            int cnt = 2;
            for (int u = j + 1; u < n && u < i + SQN; ++u) {
                b += k;
                if (a[u] == b) {
                    ++cnt;
                    used[u - i] = 1;
                }
            }
            ans = max(ans, cnt);
        }
    }
    cout << n - ans << '\n';
}
