#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "iomanip"
#include "bitset"
#include "set"
#include "array"
#include "map"
#define all(x) x.begin(), x.end()
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int res = 0;
    for (int i = -1e5; i <= 1e5; ++i) {
        map<int, int> cnt;
        for (int j = 0; j < n; ++j) {
            cnt[a[j] + i * j]++;
            if (abs(j * i) > 2e5)
                break;
        }
        int mx = 0;
        for (auto q : cnt)
            mx = max(q.second, mx);
        res = max(res, mx);
    }
    cout << n - res << '\n';
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
}
