#include <bits/stdc++.h>

using namespace std;
#define fast ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'
#define int long long
#define ff first
#define ss second

const int MOD = 998244353;

void dfs(int v,vector<int>& used,vector<vector<pair<int,pair<int,int>>>>& g,vector<int>& res) {
    used[v] = 1;
    res[v] = 1;
    for(auto cur : g[v]) {
        int u = cur.ff,x = cur.ss.ff,y = cur.ss.ss;
        if(used[u]) {
            int vl = (res[u] * x) / __gcd(res[u] * x,y);
            res[v] = res[v] * vl / __gcd(res[v],vl);
            continue;
        }
        dfs(u,used,g,res);
        int vl = (res[u] * x) / __gcd(res[u] * x,y);
        res[v] = res[v] * vl / __gcd(res[v],vl);
    }
}

int get_ans(int v,int p,vector<vector<pair<int,pair<int,int>>>>& g,vector<int>& res) {
    int out = res[v];
    for(auto cur : g[v]) {
        int u = cur.ff,x = cur.ss.ff,y = cur.ss.ss;
        if(u == p) {
            continue;
        }
        res[u] = res[v] / x * y;
        out = (out + get_ans(u,v,g,res)) % MOD;
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<pair<int,pair<int,int>>>> g(n + 7);
    for(int i = 1;i <= n - 1; ++i) {
        int v,u,x,y;
        cin >> v >> u >> x >> y;
        int z = __gcd(x,y);
        x /= z;
        y /= z;
        g[v].push_back({u,{x,y}});
        g[u].push_back({v,{y,x}});
    }
    vector<int> used(n + 7),res(n + 7);
    dfs(1,used,g,res);
    cout << get_ans(1,0,g,res) << endl;
}

signed main() {
    fast;
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
