#include <bits/stdc++.h>

using namespace std;
#define fast ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'
//#define int long long
#define ff first
#define ss second
#define map unordered_map

const int MOD = 998244353;

int mpow(int x,int n) {
    int res = 1;
    while(n) {
        if(n & 1) res = (1ll * res * x) % MOD;
        x = (1ll * x * x) % MOD;
        n >>= 1;
    }
    return res;
}

vector<vector<pair<int,int>>> can(2e5 + 7);

void nok(int v,int x,vector<map<int,int>>& res) {
    for(auto [d,cnt] : can[x]) {
        res[v][d] = max(res[v][d],cnt);
    }
}

void del(int v,int x,vector<map<int,int>>& res) {
    for(auto [d,cnt] : can[x]) {
        res[v][d] -= cnt;
    }
}

void umn(int v,int x,vector<map<int,int>>& res) {
    for(auto [d,cnt] : can[x]) {
        res[v][d] += cnt;
    }
}

void big_nok(int v,int u,vector<map<int,int>>& res) {
    for(auto [d,cnt] : res[u]) {
        res[v][d] = max(res[v][d],cnt);
    }
}

void dfs(int v,int p,vector<vector<pair<int,pair<int,int>>>>& g,vector<map<int,int>>& res) {
    res[v][1] = 1;
    for(auto cur : g[v]) {
        int u = cur.ff,x = cur.ss.ff,y = cur.ss.ss;
        if(u == p) {
            nok(v,x,res);
            continue;
        }
        dfs(u,v,g,res);
        umn(u,x,res);
        del(u,y,res);
        big_nok(v,u,res);
        res[u].clear();
    }
}

int get_ans(int v,int p,vector<vector<pair<int,pair<int,int>>>>& g,int val) {
    int out = val;
    for(auto cur : g[v]) {
        int u = cur.ff,x = cur.ss.ff,y = cur.ss.ss;
        if(u == p) {
            continue;
        }
        out = (out + get_ans(u,v,g,((1ll * val * mpow(x,MOD - 2)) % MOD * y) % MOD)) % MOD;
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<pair<int,pair<int,int>>>> g(n + 7);
    for(int i = 1;i <= n - 1; ++i) {
        int v,u,x,y;
        cin >> v >> u >> x >> y;
        int z = __gcd(x,y);
        x /= z;
        y /= z;
        g[v].push_back({u,{x,y}});
        g[u].push_back({v,{y,x}});
    }
    vector<map<int,int>> res(n + 7);
    dfs(1,0,g,res);
    int cur = 1;
    for(auto [d,cnt] : res[1]) {
        for(int i = 1;i <= cnt; ++i) {
            cur = (1ll * cur * d) % MOD;
        }
    }
    cout << get_ans(1,0,g,cur) << endl;
}

signed main() {
    fast;
    for(int x = 1;x <= 2e5; ++x) {
        int val = x;
        for(int i = 2;i * i <= val; ++i) {
            if(x % i == 0) {
                int cnt = 0;
                while(val % i == 0) {
                    val /= i;
                    cnt += 1;
                }
                can[x].push_back({i,cnt});
            }
        }
        if(val > 1) {
            can[x].push_back({val,1});
        }
    }
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
