/**

The_Rubbish

TTTTT h            RRRRR         b      b                  h
T T T h            R   R         b      b       i          h
  T   hhh eee      R   R  u  u   bbbb   bbbb   iii   ssss  hhh
  T   h h e e      RRRRR  u  u   b   b  b   b   i   s      h h
  T   h h eee      RRR    u  u   b   b  b   b   i    sss   h h
  T   h h e        R  R   u  u   b   b  b   b   i       s  h h
  T   h h eee ____ R   R  uuu u  bbbb   bbbb   iii  ssss   h h

**/

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define pb push_back
#define pii pair < int, int >
#define ld long double 
#define endl '\n'

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > oset;

const int N = 200007, MOD = 998244353;

int st(int a, int b)
{
	if (b == 0) return 1;
	if (b == 1) return a;
	int anss = st(a, b / 2);
	anss *= anss;
	anss %= MOD;
	if ((b & 1) > 0) 
	{
		anss *= a;
	    anss %= MOD;
	}
	return anss;
}

int ans = 0;
vector < pair < int, pii > > g[N];
int A[N], V;
map < int, int > forv, now;
vector < int > d[N];

void DFS(int v, int pr)
{
	for (auto too:g[v])
	{
		int to = too.F, x = too.S.F, y = too.S.S;
		if (to == pr) continue;
		int x1 = x, gc = 1, pr = -1, prk = 0;
		for (auto to:d[x])
		{
			if (to != pr)
			{
				prk = min(prk, now[pr]);
				for (int i = 0;i < prk;i++)
					gc *= pr;
				pr = to;
			}
			prk++;
		}
		prk = min(prk, now[pr]);
		for (int i = 0;i < prk;i++)
			gc *= pr;
		x = x1;
		int need = x / gc;
		for (auto to:d[need])
		{
			now[to]++;
			forv[to]++;
		}
	}
	for (auto too:g[v])
	{
		int to = too.F, x = too.S.F, y = too.S.S;
		if (to == pr) continue;
		for (auto TO:d[x])
		{
			now[TO]--;
			forv[TO]--;
		}
		for (auto TO:d[y])
		{
			now[TO]++;
			forv[TO]++;
		}
		DFS(to, v);
		for (auto TO:d[y])
		{
			now[TO]--;
			forv[TO]--;
		}
		for (auto TO:d[x])
		{
			now[TO]++;
			forv[TO]++;
		}
	}
}

void DFS1(int v, int pr)
{
	ans += A[v];
	ans %= MOD;
	for (auto too:g[v])
	{
		int to = too.F, x = too.S.F, y = too.S.S;
		if (to == pr) continue;
		A[to] = (A[v] * st(x, MOD - 2)) % MOD;
		A[to] = (A[to] * y) % MOD;
		DFS1(to, v);
	}
}

void solve()
{
	int n;
	cin >> n;
	int x[n], y[n], a[n], b[n];
	for (int i = 0;i < n;i++)
		A[i] = 1;
	for (int i = 0;i < n - 1;i++)
	{
		cin >> a[i] >> b[i] >> x[i] >> y[i];
		int gc = __gcd(x[i], y[i]);
		x[i] /= gc;
		y[i] /= gc;
		a[i]--;
		b[i]--;
		g[a[i]].pb({b[i], {x[i], y[i]}});
		g[b[i]].pb({a[i], {y[i], x[i]}});
	}
	for (int i = 0;i < n;i++)
		if (g[i].size() == 1) V = i;
	DFS(V, V);
	for (int i = 2;i <= n;i++)	
		for (int j = 0;j < forv[i];j++)
			A[V] = (A[V] * i) % MOD;
	DFS1(V, V);
	cout << ans << endl;
	ans = 0;
	for (int i = 0;i < n;i++)
		g[i].clear();
	for (int i = 1;i <= n;i++)	
	{
		forv[i] = 0;
		now[i] = 0;
		A[i] = 1;
	}
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif // LOCAL
	for (int i = 1;i <= 200000;i++)
	{
		bool p = 0;
		for (int j = 2;j <= sqrt(i);j++)
		{
			if (i % j == 0)
			{
				p = 1;
				for (auto to:d[i / j])
					d[i].pb(to);
				d[i].pb(j);
				break;
			}
		}
		if (p == 0) d[i].pb(i);
		sort(d[i].begin(), d[i].end());
	}
	int t;
	cin >> t;
	while (t--)
		solve();
}
