/*
#pragma comment(linker, "stack:200000000")
#pragma GCC optimize("0fast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune-native")
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <fstream>
#include <unordered_set>
#include <cmath>
#include <cstring>
#include <chrono>
#include <queue>
#include <deque>
#include <stack>

// ext/pb_ds/assoc_container.hpp>
// __gnu_pbds

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

const ll inf = 1e18;
const ll mxn = 1e9 + 7;
const int mod = 1000000007; // 998244353
const ld eps = 1e-7;
const ld pi = acos(-1);

#define ff first
#define ss second
#define endl '\n'
#define ins insert
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;
#define fl() cout.flush()


/*
struct segtree {
    vector <int> tree;
    int sz;

    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1);
    }

    void update (int i, int v, int x, int lx, int rx) {

    }

    int get (int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {

        }
        if (lx >= l && rx <= r) {

        }
        int m = (lx + rx) / 2;
    }
};
*/


bool cmp (ll a, ll b) {
    return a > b;
}


void solve() {
    int n;
    cin >> n;
    vector <ll> a(n);
    // map <ll, ll> cnt;
    ll s = 0;
    multiset <ll, decltype(&cmp)> ms(&cmp);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ms.ins(a[i]);
        s += a[i];
    }
    vector <ll> m;
    m.pb(s);
    while (!m.empty()) {
        vector <ll> m1;
        for (auto i : m) {
            if (ms.find(i) != ms.end()) {
                ms.extract(i);
            }
            else {
                if (i == 1) {
                    cout << "NO" << endl;
                    return;
                }
                m1.pb((i + 1) / 2);
                m1.pb(i / 2);
            }
        }
        m = m1;
    }
    cout << "YES" << endl;
}


signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}