#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x)  (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;

const int block = (1 << 9);

struct node {

};

string ans;
string mp[block];
vector<int> pos[block];


bool isect(vector<int> &a, vector<bool> &b, int i) {
    vector<int> res;
    for (int x: a)  {
        if (b[x ^ i]) {
            res.push_back(x ^ i);
        }
    }

    if (gsize(res) == 0) return false;
    b.assign(gsize(b), false);
    for (int x: res) b[x] = true;
    return true;
}



void solve(string &s) {
    int n = gsize(s);
    if (n <= block) {
        ans = min(ans, s);
        return;
    }

    vector<pair<string, int>> ta;
    for (int i = 0; i < n; i += block) {
        string res = "";
        for (int j = i; j < i + block; j++) {
            res += s[j];
        }
        ta.emplace_back(res, i);
    }
    sort(all(ta));

    for (int i = 0; i < block; i++) pos[i].clear();

    int ci = 0;
    int iv = 0;
    for (int i = 0; i < gsize(ta); i++) {
        if (ta[i].first != ta[ci].first) {
            iv++;
            ci = i;
        }
        mp[iv] = ta[i].first;
        pos[iv].push_back(ta[i].second);
    }

    int m = n / block;
    vector<bool> cur_j(m, true);
    string tans;
    for (int i = 0; i < m; i++) {
        for (int x = 0; x < m; x++) {
            if (isect(pos[x], cur_j, i)) {
                tans += mp[x];
                break;
            }
        }
    }
    ans = min(ans, tans);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;
    ans = s;

    for (int j = 0; j < min(1 << n, block); j++) {
        string t = s;
        for (int i = 0; i < (1 << n); i++) {
            t[i] = s[i ^ j];
        }
        solve(t);
    }
    cout << ans << nl;
}
