#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <algorithm>
#include <map>
#include <string>
#include <numeric>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>

using namespace std;

using ll = long long;
using ld = long double;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;
template <typename... T>
using tup = tuple<T...>;

template <typename A, typename B>
inline istream& operator>> (istream& in, pa<A, B>& p);

template <typename T>
inline istream& operator>> (istream& in, v<T>& a) {
	for (T& t : a) {
		in >> t;
	}
	return in;
}

template <typename A, typename B>
inline istream& operator>> (istream& in, pa<A, B>& p) {
	return in >> p.first >> p.second;
}

inline void solve() {
	ll n;
	cin >> n;
	v<ll> a(n);
	cin >> a;
	sort(a.begin(), a.end(), greater<ll>());
	cout << (a[0] + a[1]) << '\n';
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}