#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
//#define int long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MAXN = 2e5 + 10;
const int mod = 998244353;
const long long inf = 1e18;
const int k = 250;


void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int ans = n;
    for (int d = -k; d < k; d++) {
        unordered_map<int, int> mp;
        int cur = 0;
        for (int i = 0; i < n; i++) {
            mp[v[i] + d * i]++;
            cur = max(cur, mp[v[i] + d * i]);
        }
        ans = min(ans, n - cur);
    }
    for (int i = 0; i < n; i++) {
        unordered_map<int, int> mp;
        int cur = 0;
        for (int j = max(i - k, 0ll); j < min(n, i + k); j++) {
            if (i == j)
                continue;
            if (j < i) {
                if ((v[i] - v[j]) % abs(i - j) == 0)
                    mp[(v[i] - v[j]) / abs(i - j)]++;
                cur = max(cur, mp[(v[i] - v[j]) / abs(i - j)]);
            } else {
                if ((v[j] - v[i]) % abs(i - j) == 0)
                    mp[(v[j] - v[i]) / abs(i - j)]++;
                cur = max(cur, mp[(v[j] - v[i]) / abs(i - j)]);
            }
        }
        cur++;
        ans = min(ans, n - cur);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(10);

    int T = 1;
//    cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}