#include<bits/stdc++.h>

using namespace std;

#define int long long

const long long mod = 998244353;

vector<bool> pr(3e5, true);
vector<vector<long long>> dels(3e5);
vector<long long> prime, nom(3e5);
vector<int> met;

void genPr(){
    int it = 0;
    for(int i = 2; i<pr.size(); ++i){
        if(pr[i]){
            nom[i] = it;
            ++it;
            prime.push_back(i);
            dels[i].push_back(i);
            for(int q = i*2; q<pr.size(); q+=i){
                pr[q] = false;
                long long dbl = q;
                while(dbl%i==0){
                    dbl/=i;
                    dels[q].push_back(i);
                }
            }
        }
    }
}

vector<int> nowM, mx;

void dfs1(int now, vector<vector<pair<int, pair<long long, long long>>>> &gr){
    met[now] = 1;
    for(int i = 0; i<gr[now].size(); ++i){
        int ch = gr[now][i].first;
        if(met[ch]==0){
            for(int q = 0; q<dels[gr[now][i].second.first].size(); ++q){
                long long cc = nom[dels[gr[now][i].second.first][q]];
                ++nowM[cc];
            }
            for(int q = 0; q<dels[gr[now][i].second.second].size(); ++q){
                long long cc = nom[dels[gr[now][i].second.second][q]];
                --nowM[cc];
            }
            for(int q = 0; q<dels[gr[now][i].second.first].size(); ++q){
                long long cc = nom[dels[gr[now][i].second.first][q]];
                mx[cc] = max(mx[cc], nowM[cc]);
            }
            for(int q = 0; q<dels[gr[now][i].second.second].size(); ++q){
                long long cc = nom[dels[gr[now][i].second.second][q]];
                mx[cc] = max(mx[cc], nowM[cc]);
            }
            dfs1(ch, gr);
            for(int q = 0; q<dels[gr[now][i].second.first].size(); ++q){
                long long cc = nom[dels[gr[now][i].second.first][q]];
                --nowM[cc];
            }
            for(int q = 0; q<dels[gr[now][i].second.second].size(); ++q){
                long long cc = nom[dels[gr[now][i].second.second][q]];
                ++nowM[cc];
            }
        }
    }
}

long long stp(long long a, long long st){
    if(st==0)
        return 1;
    long long it = stp(a, st/2);
    it = (it*it)%mod;
    if(st%2==1){
        it = (it*a)%mod;
    }
    return it;
}

long long obr(long long a){
    return stp(a, mod-2);
}

long long del(long long a, long long b){
    return (a*obr(b))%mod;
}

long long sm;
long long nw;

void dfs2(int now, vector<vector<pair<int, pair<long long, long long>>>> &gr){
    met[now] = 1;
    sm=(sm+nw)%mod;
    for(int i = 0; i<gr[now].size(); ++i){
        int ch = gr[now][i].first;
        if(met[ch]==0){
            nw = del(nw, gr[now][i].second.first);
            nw = (nw*gr[now][i].second.second)%mod;
            dfs2(ch, gr);
            nw = del(nw, gr[now][i].second.second);
            nw = (nw*gr[now][i].second.first)%mod;
        }
    }
}

void solve(){
    int n;
    cin >> n;
    nowM = vector<int>(30000);
    mx = vector<int>(30000);
    met = vector<int>(n);
    vector<vector<pair<int, pair<long long, long long>>>> gr(n);
    for(int i = 0; i<n-1; ++i){
        int a, b;
        long long ca, cb;
        cin >> a >> b >> ca >> cb;
        --a;
        --b;
        gr[a].push_back({b, {ca, cb}});
        gr[b].push_back({a, {cb, ca}});
    }
    dfs1(0, gr);
    long long it = 1;
    for(int i = 0; i<10; ++i){
        for(int q = 0; q<mx[i]; ++q){
            it = (it*prime[i])%mod;
        }
    }
    sm = 0;
    nw = it;
    met = vector<int>(n);
    dfs2(0, gr);
    cout << sm%mod << "\n";
}

main(){
    genPr();
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n = 1;
    cin >> n;
    while(n--){
        solve();
    }
}
