﻿#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <bitset>
#include <math.h>
#include <string>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <random>
#include <algorithm>
#include <time.h>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair<int, int> pii;

mt19937 rng(time(0));

#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define pb push_back
#define eb emplace_back
#define Sum(x) accumulate(All(x), 0ll)
#define X first
#define Y second

const int INF = 1e9 + 5;
const int MAXN = 1e5;

const int SQRT = 400;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int res = 1;
	for (int i = 0; i < n; i++) {
		map<int, int> g;
		int cur = 0;
		for (int j = max(0, i - SQRT); j <= min(n - 1, i + SQRT); j++) {
			if (j == i) continue;
			int dx = a[j] - a[i];
			int dy = j - i;
			if (dy == 0 || dx % dy == 0)
				cur = max(cur, ++g[dx / dy]);
		}
		res = max(res, cur + 1);
	}
	for (int d = -SQRT; d <= SQRT; d++) {
		int ans = 0;
		map<ll, int> cnt;
		for (int i = 0; i < n; i++) {
			ans = max(ans, ++cnt[(ll)MAXN + a[i] - 1ll * i * d]);
		}
		res = max(res, ans);
	}
	cout << n-res;
}

int main()
{
	solve();
}
