#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll
#ifndef LOCAL
//#define endl '\n'
#endif

#define all(v) (v).begin(),(v).end()
#define sz(v) ((int)(v).size())

void solve() {
    int n;
    cin >> n;
    multiset<int> s;
    int sm = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        s.insert(x);
        sm += x;
    }
    function<bool(int)> run;
    run = [&](int x) {
        if (s.count(x)) {
            s.erase(s.find(x));
            return true;
        }
        if (x == 1) {
            return false;
        }
        int a = x / 2;
        if (!run(a))
            return false;
        if (!run(x - a))
            return false;
        return true;
    };
    if (run(sm)) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
