#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

//#define int ll
#ifndef LOCAL
//#define endl '\n'
#endif

#define all(v) (v).begin(),(v).end()
#define sz(v) ((int)(v).size())

const int INF = 1e8;

void solve() {
    int n;
    cin >> n;
    vector<int> base(n);
    for (int i = 0; i < n; i++) {
        cin >> base[i];
    }
    deque<int> q;
    for (int i = 0; i < n; i++) {
        if (base[i]) {
            q.push_back(i);
        }
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int> ans(n, -1);
    vector<int> used(n);
    for (int v : q) {
        used[v] = 1;
        ans[v] = 0;
    }
    vector<int> ord;
    while (!q.empty()) {
        int v = q.front();
        ord.push_back(v);
        q.pop_front();
        for (int u : g[v]) {
            if (!used[u]) {
                used[u] = 1;
                ans[u] = ans[v] + 1;
                q.push_back(u);
            }
        }
    }
    vector<int> down(n, INF);
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            if (ans[i] == ans[j]) {
                down[i] = ans[i];
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            if (ans[j] > ans[i]) {
                down[j] = min(down[j], down[i]);
            }
        }
    }
    used.assign(n, 0);
    int cur_time = 1;
    for (int i = 0; i < n; i++) {
        cur_time++;
        deque<array<int, 3>> q;
        q.push_back({i, 0, 0});
        used[i] = cur_time;
        int max_ans = max(ans[i], ans[i] + (ans[i] - down[i]));
        while (!q.empty()) {
            int v = q.front()[0];
            int s = q.front()[1];
            int cur = q.front()[2];
            max_ans = max(max_ans, cur + max(ans[v], ans[v] + (ans[v] - down[v] + s)));
            q.pop_front();
            for (int u : g[v]) {
                if (used[u] != cur_time) {
                    if (ans[u] < ans[v]) {
                        used[u] = 1;
                        q.push_back({u, s + 1, cur + 1});
                    } else if (ans[u] == ans[v] && s != 0) {
                        used[u] = 1;
                        q.push_back({u, s - 1, cur + 1});
                    }
                }
            }
            if (clock() > 4.5 * CLOCKS_PER_SEC) {
                break;
            }
        }
        cout << max_ans << ' ';
    }
    cout << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
