#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <string>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 5e6;

map<int, int> m;

signed main()
{
#ifdef _CONSOLE
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		m.clear();
		int sum = 0;
		for (int i = 0; i < n; i++)
		{
			int a;
			cin >> a;
			m[a]++;
			sum += a;
		}
		queue<int> q;
		q.push(sum);
		while (!q.empty())
		{
			if (q.size() > n)
			{
				cout << "NO\n";
				goto nx;
			}
			int now = q.front();
			q.pop();
			if (m[now] > 0)
			{
				m[now]--;
			}
			else
			{
				q.push(now / 2);
				q.push(now - now / 2);
			}
		}
		cout << "YES\n";
	nx:;
	}
}