#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <string>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 1e5 + 5;
const int K = 350;

int a[N];
vector<pii> dp[N];

signed main()
{
#ifdef _CONSOLE
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	int ans = 0;
	for (int i = 0; i < K; i++)
	{
		vector<int> v;
		for (int j = 0; j < n; j++)
		{
			v.push_back(a[j] - j * i);
		}
		sort(all(v));
		int now = 1;
		for (int j = 1; j < v.size(); j++)
		{
			if (v[j] == v[j - 1])
			{
				now++;
				ans = max(now, ans);
			}
			else
			{
				now = 1;
			}
		}
		v.clear();
		for (int j = 0; j < n; j++)
		{
			v.push_back(a[j] + j * i);
		}
		sort(all(v));
		now = 1;
		for (int j = 1; j < v.size(); j++)
		{
			if (v[j] == v[j - 1])
			{
				now++;
				ans = max(now, ans);
			}
			else
			{
				now = 1;
			}
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = i - 1; j >= max(0LL, i - K); j--)
		{
			if ((a[i] - a[j]) % (i - j) == 0)
			{
				int k = (a[i] - a[j]) / (i - j);
				auto it = lower_bound(all(dp[j]), mp(k + 1, -1LL));
				int bon = 1;
				if (it != dp[j].begin())
				{
					it--;
					pii el = dp[j][it - dp[j].begin()];
					if (el.first == k)
					{
						bon = el.second;
					}
				}
				dp[i].push_back({ k,bon + 1 });
				ans = max(ans, bon + 1);
			}
		}
		sort(all(dp[i]));
	}
	cout << n - ans;
}