#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#define int long long
using namespace std;
int md = 998244353;
vector <int> rs(4e5);
set <int> prost;
map <int, int> v1;
map <int,int> mxr;
int ans = 0;
int gcd(int a, int b) {
	if (a == 0) {
		return b;
	}
	return gcd(b%a, a);
}
int binpow(int n, int k) {
	if (k == 0) {
		return 1;
	}
	int e = binpow(n, k / 2);
	e *= e;
	e %= md;
	if (k % 2) {
		e *= n;
		e %= md;
	}
	return e;
}
vector <vector <vector <int> > > g;
void dfs(int v, int p) {
	for (auto u : g[v]) {
		if (u[0] != p) {
			int rz1 = u[1];
			int um1 = u[2];
			
			set <int> pp;
			while (rz1 > 1) {
				v1[rs[rz1]]++;
				pp.insert(rs[rz1]);
				rz1 /= rs[rz1];
			}
			while (um1 > 1) {
				v1[rs[um1]]--;
				pp.insert(rs[um1]);
				um1 /= rs[um1];
			}
			for (auto x : pp) {
				if (v1[x] > 0) {
					mxr[x] = max(mxr[x], v1[x]);
				}
			}
			dfs(u[0], v);
			rz1 = u[1];
			um1 = u[2];
			while (rz1 > 1) {
				v1[rs[rz1]]--;
				rz1 /= rs[rz1];
			}
			while (um1 > 1) {
				v1[rs[um1]]++;
				um1 /= rs[um1];
			}
		}
	}
}
void dfs2(int v, int p, int c) {
	ans += c;
	ans %= md;
	for (auto u : g[v]) {
		if (u[0] != p) {
			int nc = c;
			nc *= u[2];
			nc %= md;
			nc *= binpow(u[1], md - 2);
			nc %= md;
			dfs2(u[0], v, nc);
		}
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int q;
	cin >> q;
	for (int j = 2; j <= 2e5; ++j) {
		if (!rs[j]) {
			rs[j] = j;
			for (int z = j * j; z <= 2e5; z += j) {
				rs[z] = j;
			}
		}
	}
	for (int t = 0; t < q; ++t) {
		int n;
		cin >> n;
		g.clear();
		g.resize(n);
		v1.clear();
		mxr.clear();
		ans = 0;
		for (int i = 0; i < n - 1; ++i) {
			int i1, j, x, y;
			cin >> i1 >> j >> x >> y;
			i1--;
			j--;
			g[i1].push_back({ j,x,y });
			g[j].push_back({ i1,y,x });
		}
		dfs(0, -1);
		int ch = 1;
		for (auto x : mxr) {
			for (int i = 0; i < x.second; ++i) {
				ch *= x.first;
				ch %= md;
			}
		}
		dfs2(0, -1, ch);
		cout << ans << "\n";
	}
	return 0;
}