#include <bits/stdc++.h>
#define x first
#define y second
#define sz(a) (int)a.size()
#define pb push_back
#define int long long

using namespace std;
const int mod = 998244353;
typedef long long ll;

void solve();

int bin_pow(int x, int k) {
    if (k == 0)
        return 1;
    if (k % 2 == 0) {
        int ans = bin_pow(x, k / 2);
        return (ans * ans) % mod;
    } else {
        return (bin_pow(x, k - 1) * x) % mod;
    }
}

struct chl {
    map <int, int> mp;
    void umn(chl b) {
        for (auto i : b.mp) {
            mp[i.x] += i.y;
        }
    }
    void delt(chl b) {
        for (auto i : b.mp) {
            mp[i.x] -= i.y;
        }
    }
    void gc(chl b) {
        map <int, int> mp2;
        for (auto i : mp) {
            if (min(i.y, b.mp[i.x]) != 0)
                mp2[i.x] = min(i.y, b.mp[i.x]);
        }
        mp = mp2;
    }
    int get() {
        int x = 1;
        for (auto i : mp) {
            x = (x * bin_pow(i.x, i.y)) % mod;
        }
        return x;
    }
};

chl dp[200010];

int ff[200010];
bool used[200010];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 0; i <= 200000; ++i) {
        ff[i] = i;
    }
    for (int i = 2; i <= 200000; ++i) {
        if (!used[i]) {
            for (int j = i; j <= 200000; j+=i) {
                used[j] = 1;
                while (ff[j] % i == 0) {
                    dp[j].mp[i]++;
                    ff[j] /= i;
                }
            }
        }
    }
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}


struct node {
    int u, x, y;
};

vector <node> g[200010];

chl pans[200010];

bitset <200010> bb;

void dfs(int v) {
    bb[v] = 1;
    for (auto u : g[v]) {
        if (!bb[u.u]) {
            pans[u.u] = pans[v];
            pans[u.u].umn(dp[u.x]);
            pans[u.u].delt(dp[u.y]);
            dfs(u.u);
        }
    }
}

void solve() {
    bb = 0;
    int n, x, y, ind1, ind2, gc;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    chl d;
    d.mp.clear();
    for (int i = 0; i < n - 1; ++i) {
        cin >> ind1 >> ind2 >> x >> y;
        gc = __gcd(x, y);
        x /= gc, y /= gc;
        d.umn(dp[x]);
        d.umn(dp[y]);
        ind1--, ind2--;
        g[ind1].pb({ind2, y, x});
        g[ind2].pb({ind1, x, y});
    }
    for (int i = 0; i < n; ++i) {
        if (!bb[i]) {
            pans[i] = d;
            dfs(i);
        }
    }
    d = pans[0];
    for (int i = 1; i < n; ++i) {
        d.gc(pans[i]);
    }
    for (int i = 0; i < n; ++i) {
        pans[i].delt(d);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = (ans + pans[i].get()) % mod;
    }
    cout << ans << '\n';
}
