//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>


using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int ll
#define ll long long
#define ld long double
#define pii pair<int, int>
#define int128 __int128
#define all(v) begin(v), end(v)
#define rall(v) rbegin(v), rend(v)
#define mp(x, y) make_pair(x, y)
#define mt make_tuple
#define popc(x) __builtin_popcount(x)
#define popcll(x) __builtin_popcountll(x)
#define trace(x) cout << #x << ": " << (x) << endl;

int rand(int l, int r) { return ((ll) rnd() % (r - l + 1)) + l; }

const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 998244353;
const ld eps = 1e-9;
const int N = (300000) + 1;

int lowd[N];

ll fastp(ll a, ll p) {
    ll ans = 1;
    while (p) {
        if (p & 1) ans = ans * a % mod;
        a = a * a % mod;
        p >>= 1;
    }
    return ans;
}

ll rev(ll a) {
    return fastp(a, mod - 2);
}

vector<array<int, 3>> g[N];
int sz[N], p[N], depth[N], ans[N];

map<int, int> mx1, mx2, mx;

int go[N];


void dfs(int v) {
    for (auto &to : g[v]) {
        if (to[0] != p[v]) {
            p[to[0]] = v;
            depth[to[0]] = depth[v] + 1;
            int z = to[2];
            vector<pair<int, int>> now1, now2;
            vector<pair<int, int>> prev1, prev2;
            while (z > 1) {
                int cnt = 0;
                int gg = lowd[z];
                while (lowd[z] == gg) {
                    ++cnt;
                    z = go[z];
                }
                now1.emplace_back(gg, cnt);
            }
            z = to[1];
            while (z > 1) {
                int cnt = 0;
                int gg = lowd[z];
                while (lowd[z] == gg) {
                    ++cnt;
                    z = go[z];
                }
                now2.emplace_back(gg, cnt);
            }
            for (auto[a, b] : now1) {
                mx1[a] += b;
            }

            for (auto[a, b] : now2) {
                mx2[a] += b;
                mx[a] = max(mx[a], max(0ll, mx2[a] - mx1[a]));
            }
            dfs(to[0]);
            for (auto[a, b] : now1) {
                mx1[a] -= b;
            }
            for (auto[a, b] : now2) {
                mx2[a] -= b;
            }
        }
    }
}

int get(int a, int x, int y) {
    if (a * x % y == 0) return a;
    else {
        return a * (y / gcd(a * x, y));
    }
}


void solve() {
    int n;
    cin >> n;
    mx1.clear(), mx2.clear();
    mx.clear();
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        p[i] = -1;
        depth[i] = 0;
        ans[i] = 1;
    }
    for (int i = 1; i < n; ++i) {
        int a, b, x, y;
        cin >> a >> b >> x >> y;
        --a, --b;
        int c = gcd(x, y);
        x /= c;
        y /= c;
        g[a].push_back({b, x, y});
        g[b].push_back({a, y, x});
    }
    dfs(0);
    vector<int> ord(n);
    iota(all(ord), 0);
    sort(all(ord), [](int i, int j) {
        return depth[i] < depth[j];
    });
    ll sum = 0;
    for (auto[a, b] : mx) ans[0] = ans[0] * fastp(a, b) % mod;
//    trace(ans[0])
    for (int v : ord) {
//        ans[v] %= mod;
//        assert(ans[v] < mod);
        sum += ans[v];
        if (sum >= mod) sum -= mod;
        for (auto &to : g[v]) {
            if (to[0] != p[v]) {
                ans[to[0]] = ans[v] * to[2] % mod * rev(to[1]) % mod;
//                trace(ans[to[0]])
            }
        }
    }
    cout << sum << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<int> primes;
    for (int i = 2; i < N; ++i) {
        if (lowd[i] == 0) {
            lowd[i] = i;
            primes.push_back(i);
        }
        go[i] = i / lowd[i];
        for (int x : primes) {
            if (x > i || x * i >= N) break;
            lowd[x * i] = x;
        }
    }
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
