#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int K = 320;
const int K2 = 320;

void solve() {
  int n;
  cin >> n;
  vector<int> arr(n);
  for (int &el : arr)
    cin >> el;
  int ans = 1;
  for (int step = -K; step <= K; ++step) {
    map<ll, int> mp;
    int mx = 0;
    for (int i = 0; i < n; ++i) {
      ll x = arr[i] - step * 1ll * i;
      mp[x]++;
      mx = max(mx, mp[x]);
    }
    if (mx > ans)
      ans = mx;
  }
  for (int i = 0; i < n; ++i) {
    vector<int> steps;
    int L = max(0, i - K2);
    int R = min(n, i + K2 + 1);
    map<ll, int> mp;
    int mx = 0;
    for (int j = L; j < R; ++j) {
      if (i == j)
        continue;
      int diff = arr[i] - arr[j];
      if (i < j)
        diff *= -1;
      int len = abs(i - j);
      if (diff % len != 0)
        continue;
      int step = diff / len;
      mp[step]++;
      mx = max(mx, mp[step]);
    }
    mx++;
    if (mx > ans)
      ans = mx;
  }
  cout << n - ans;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t = 1;
//  cin >> t;
  while (t--) {
    solve();
    cout << '\n';
  }
}