#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int K = 280;
const int K2 = 370;
const int INF = 1e9;

void solve() {
  int n;
  cin >> n;
  vector<int> arr(n);
  for (int &el : arr)
    cin >> el;
  int ans = 1;
  for (int step = -K; step <= K; ++step) {
    vector<ll> brr(n);
    for (int i = 0; i < n; ++i) {
      ll x = arr[i] - step * 1ll * i;
      brr[i] = x;
    }
    sort(brr.begin(), brr.end());
    int L = 0;
    for (int i = 1; i <= n; ++i) {
      if (i == n || brr[i] != brr[L]) {
        if (i - L > ans)
          ans = i - L;
        L = i;
      }
    }
  }
  for (int i = 0; i < n; ++i) {
    vector<int> steps;
    int LL = max(0, i - K2);
    int RR = min(n, i + K2 + 1);
    vector<int> brr(RR - LL, INF);
    for (int j = LL; j < RR; ++j) {
      if (i == j)
        continue;
      int diff = arr[i] - arr[j];
      if (i < j)
        diff *= -1;
      int len = abs(i - j);
      if (diff % len != 0)
        continue;
      int step = diff / len;
      brr[j - LL] = step;

    }
    sort(brr.begin(), brr.end());
    while (!brr.empty() && brr.back() == INF)
      brr.pop_back();
    int m = brr.size();
    int L = 0;
    for (int j = 0; j <= m; ++j) {
      if (j == m || brr[j] != brr[L]) {
        if (j - L + 1 > ans)
          ans = j - L + 1;
        L = j;
      }
    }
  }
  cout << n - ans;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t = 1;
//  cin >> t;
  while (t--) {
    solve();
    cout << '\n';
  }
}