#include <bits/stdc++.h>

void solve() {
    int n;
    std::cin >> n;
    std::vector<int64_t> a(n);
    int64_t sum = 0;
    for (auto &x : a) {
        std::cin >> x;
        sum += x;
    }
    std::multiset<int64_t> have;
    std::stack<int> q;
    for (auto &x : a)
        have.emplace(x);
    q.emplace(sum);
    while (!q.empty() && !have.empty()) {
        auto x = q.top();
        q.pop();
        if (x < *have.begin()) {
            std::cout << "NO\n";
            return;
        }
        if (have.find(x) != have.end()) {
            have.erase(have.find(x));
            continue;
        }
        int64_t fir = x / 2, sec = (x + 1) / 2;
        q.emplace(sec);
        q.emplace(fir);
    }
    if (q.empty() && have.empty())
        std::cout << "YES\n";
    else
        std::cout << "NO\n";

}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0), std::cout.tie(0);
    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
