#ifndef disastah
#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4,fma,popcnt")
#pragma GCC optimize("-Ofast,unroll-loops,fast-math")
#endif
#include "bits/stdc++.h"
#define ar array
std::mt19937 rnd(503);
using namespace std;
typedef long long ll;
const int N=2e5+5, mod=998244353;

int pr[N], rev[N], fp[N][101];

int n, deg[N], mn[N], val=0, ans=0;
vector<ar<int,3>> g[N];

int gcd(int a, int b) {
	while(a && b) a%=b, swap(a,b);
	return a?a:b;
}

int fpp(int x, int n) {
	int ans=1;
	while(n) {
		if (n&1) {
			ans=ll(ans)*x%mod;
		}
		n>>=1;
		x=ll(x)*x%mod;
	}
	return ans;
}

int divide(int x, int y) {
	return ll(rev[y])*x%mod;
}

void dfs(int v, int p=-1) {
	ans+=val;
	if (ans>=mod) ans-=mod;
	for (auto &[u,x,y] : g[v]) {
		if (u==p) continue;
		vector<ar<int,2>> hist;
		int old_val=val;
		int x0=x;
		while(x0>1) {
			int k=pr[x0], cnt=0, kp=1;
			while(k==pr[x0]) x0/=k, ++cnt, kp*=k;
			hist.push_back({k,deg[k]});
			deg[k]-=cnt;
			mn[k]=min(mn[k],deg[k]);
			val=divide(val,kp);
		}
		int y0=y;
		while(y0>1) {
			int k=pr[y0], cnt=0, kp=1;
			while(k==pr[y0]) y0/=k, ++cnt, kp*=k;
			hist.push_back({k,deg[k]});
			deg[k]+=cnt;
			val=ll(val)*kp%mod;
		}
		dfs(u,v);
		for (auto &[x,y] : hist) {
			deg[x]=y;
		}
		val=old_val;
	}
}

void solve() {
	cin >> n;
	for (int i=0; i<n-1; ++i) {
		int u, v, x, y;
		cin >> u >> v >> x >> y;
		--u, --v;
		int gc=gcd(x,y);
		x/=gc, y/=gc;
		g[u].push_back({v,x,y});
		g[v].push_back({u,y,x});
	}
	fill(deg,deg+n+1,100);
	fill(mn,mn+n+1,100);
	ans=0, val=1;
	for (int i=2; i<=n; ++i) {
		if (pr[i]==i) {
			val=ll(val)*fp[i][100]%mod;
		}
	}
	dfs(0);
	for (int i=2; i<=n; ++i) {
		if (pr[i]==i) {
			ans=ll(fpp(fp[i][mn[i]],mod-2))*ans%mod;
		}
	}
	cout << ans;
}

void clear() {
	for (int i=0; i<n; ++i) {
		g[i].clear();
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#ifdef disastah
	cout << "\nOutput\n\n";
#endif
	for (int i=2; i<N; ++i) {
		if (!pr[i]) {
			pr[i]=i;
			for (int j=i*2; j<N; j+=i) {
				if (!pr[j]) pr[j]=i;
			}
		}
	}
	for (int i=1; i<N; ++i) {
		rev[i]=fpp(i,mod-2);
		fp[i][0]=1;
		for (int j=1; j<=100; ++j) {
			fp[i][j]=ll(fp[i][j-1])*i%mod;
		}
	}
	int t=1;
	cin >> t;
	while(t--) {
		solve();
		clear();
		cout << "\n";
	}
}