#include <iostream>
#include <iomanip>
#include <functional>
#include <numeric>
#include <cmath>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <tuple>
#include <utility>
#include <random>
#include <chrono>
#include <algorithm>
#define all(o) (o).begin(), (o).end()
using namespace std;
using ll = long long;
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const T &e : v) o << e << " ";
    return o;
}
template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (T &e : v) o >> e;
    return o;
}
template<typename T1, typename T2>
ostream &operator<<(ostream &o, const pair<T1, T2> &v) {
    o << v.first << " " << v.second;
    return o;
}
template<typename T1, typename T2>
istream &operator>>(istream &o, pair<T1, T2> &v) {
    o >> v.first >> v.second;
    return o;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int best_i = 0, sec_best_i = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] > a[best_i]) {
            sec_best_i = best_i;
            best_i = i;
        } else if (a[i] > a[sec_best_i]) {
            sec_best_i = i;
        }
    }
    dbg(best_i);
    dbg(sec_best_i);
    cout << a[best_i] + a[sec_best_i] << "\n";
}

int main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        solve();
        cout << "#############################\n";
    }
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
    int q = 1;
    cin >> q;
    while (q--) solve();
#endif
    return 0;
}
