#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
typedef long long ll;

int n;
int a[100010];
int b[100010];
int ans;

const int S = 320;
const int A = S * 100010 * 4;
int cnt[A];
vector <pair <int, int>> x[100010];

inline void solve()
{
	for (int i = 0; i < A; ++i) cnt[i] = 0;
	for (int i = 1; i <= n; ++i) b[i] = a[i];
	for (int i = 0; i <= S; ++i)
	{
		for (int j = 1; j <= n; ++j)
		{
			ans = max(ans, ++cnt[b[j]]);
		}
		for (int j = 1; j <= n; ++j) cnt[b[j]]--;
		for (int j = 1; j <= n; ++j) b[j] += j;
	}

	ans = max(ans, 1);

	for (int i = 1; i <= n; ++i)
	{
		x[i].clear();
		for (int j = i - 1; j > max(0, i - S); --j)
		{
			int diff = a[i] - a[j];
			if (diff % (i - j)) continue;
			diff /= (i - j);
			int mx = 2;
			auto gt = (lower_bound(x[j].begin(), x[j].end(), make_pair(diff + 1, 0)));
			if (gt != x[j].begin() && prev(gt)->first == diff) mx = max(mx, prev(gt)->second + 1);

			x[i].push_back({ diff, mx });
			ans = max(ans, mx);
		}
		sort(x[i].begin(), x[i].end());
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
	}

	solve();
	reverse(a + 1, a + 1 + n);

	solve();

	cout << n - ans;


	return 0;
}