//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include<iostream>
#include<vector>
#include<cmath>
#include<random>
#include<set>
#include<map>
using namespace std;

#define debug(x) cout << (#x) << ": " << x;

struct ST {
	int sz;
	vector<int> data;
	ST() {
		;
	}

	ST(vector<int> inp) {
		for (sz = 1; sz < inp.size(); sz *= 2);
		data.assign(sz * 2, 0);
		for (int i = 0; i < inp.size(); i++) data[i + sz] = inp[i];
		for (int i = sz - 1; i > 0; i--) data[i] = data[i * 2] + data[i * 2 + 1];
	}

	long long get(int l, int r) {
		l += sz;
		r += sz;
		long long ans = 0;

		while (r > l) {
			if (l % 2) ans += data[l++];
			if (!(r % 2)) ans += data[r--];
			l /= 2; r /= 2;
		}

		if (r == l) ans += data[l];

		return ans;
	}

	void upd(int ind, int ch) {
		ind += sz;
		data[ind] = ch;
		ind /= 2;
		while (ind != 0) {
			data[ind] = data[ind * 2] + data[ind * 2 + 1];
			ind /= 2;
		}
	}
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;

	for (int i = 0; i < t; i++) {
		string s;
		cin >> s;

		vector<int> vec(26);
		for (int j = 0; j < s.size(); j++) {
			vec[s[j] - 'a'] += 1;
		}

		for (int j = 0; j < s.size(); j++) {
			if (vec[s[j] - 'a'] == 1) {
				for (int z = j; z < s.size(); z++) {
					cout << s[z];
				}

				cout << "\n";
				break;
			}

			vec[s[j] - 'a'] -= 1;
		}
	}

	return 0;
}