#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <cmath>
#include <map>
#include <random>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <iomanip>

using namespace std;
//#pragma GCC optimize(3)
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("inline")
//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#define double long double
//#define int long long
//const double eps = 1e-4;
const long long MX = 2e18;
const long long MX9 = 2e9;
const int MXN = 8e5;
const int MXDEL = 1e6;
const int K = 1000;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    if (n == 1 || n == 2) {
        cout << 0;
        return;
    }
    int x = (int) 200000 / K;
    int ans = 2;
    for (int p = -x - 10; p <= x + 10; ++p) {
        unordered_map<long long, int> mp;
        long long sum = 0;
        for (int i = 0; i < n; ++i) {
            mp[a[i] - sum]++;
            sum += p;
        }
        for (auto u: mp)
            ans = max(ans, u.second);
    }
    vector<int> mp(MXDEL * 6);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < min(n, i + K + 10); j++) {
            int delta = a[j] - a[i];
            if(delta % (j - i) != 0)
                continue;
            delta /= (j - i);
            if(abs(delta) <= x + 10)
                continue;
            mp[delta + MXDEL]++;
            ans = max(ans, mp[delta + MXDEL] + 1);
        }
        for (int j = i + 1; j < min(n, i + K + 10); j++) {
            int delta = a[j] - a[i];
            if(delta % (j - i) != 0)
                continue;
            delta /= (j - i);
            if(abs(delta) <= x + 10)
                continue;
            mp[delta + MXDEL]--;
        }
    }
    cout << n - ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
}