#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<map>
#include<set>
#include<array>
#include<random>
#include<stack>
#include<queue> 

using namespace std;
using ll = long long;
using ld = long double;

mt19937 gen(0);
const int IINF = 2e9;
const ll LINF = 4e18;
const ld EPS = 1e-12;

#define all(x) x.begin(), x.end()
#define print(x) cout << #x << ": " << x << endl;
#define print_arr(x) cout << #x << ": "; for(auto y: x) cout << y << ' '; cout << endl;

void solve(){
	string s;
	cin >> s;
	int n = s.size();
	vector<vector<int>> cnt(n + 1, vector<int>(26, 0));
	for (int i = n - 1; i >= 0; --i){
		for (int j = 0; j < 26; ++j){
			cnt[i][j] = cnt[i + 1][j];
		}
		cnt[i][s[i] - 'a']++;
	}
	int ans = 0;
	for (int i = 0; i < n; ++i){
		if (cnt[i + 1][s[i] - 'a'] < 1){
			ans = i;
			break;
		}
	}
	cout << s.substr(ans, n - ans) << '\n';
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int abba = 1;
	cin >> abba;
	while(abba--){
		solve();
	}
}