#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

void solve() {
    int n;
    cin >> n;
    multiset<ll> msa;
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        msa.insert(a);
        sum += a;
    }
    vector<ll> level = { sum };
    while (!msa.empty()) {
        if (level.size() > msa.size()) {
            cout << "NO" << "\n";
            return;
        }
        vector<ll> new_level;
        for (const auto& el : level) {
            if (msa.count(el)) {
                msa.erase(msa.lower_bound(el));
            }
            else {
                new_level.push_back(el / 2);
                new_level.push_back((el + 1) / 2);
            }
        }
        level.swap(new_level);
        new_level.clear();
    }
    cout << "YES" << "\n";
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
