#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

typedef long long ll;

const int INF = int(1e5) + 7;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    unordered_map<int, unordered_map<ll, int>> cnt;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (i == 0) {
            for (int j = -INF; j < INF; j++) {
                cnt[j][a[i]]++;
            }
        }
        else {
            for (int k = -INF / i * i; k < INF; k += i) {
                cnt[k / i][a[i] + k]++;
            }
        }
    }
    int max_cnt = 0;
    for (const auto& el : cnt) {
        for (const auto& el2 : el.second) {
            max_cnt = max(max_cnt, el2.second);
        }
    }
    cout << n - max_cnt << "\n";
}