#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ff first
#define ss second
//#define LONG

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf9 = 1000000009;
const ll inf18 = 1000000000000000018;

#ifdef LONG
#define int long long
#define inf inf18
#else
#define inf inf9
#endif

const int M = 998244353;

template <typename T1, typename T2> istream& operator>>(istream& is, pair <T1, T2>& a){is >> a.ff >> a.ss;return is;}
template <typename T1, typename T2> ostream& operator<<(ostream& os, pair <T1, T2> a){os << "(" << a.ff << ", " << a.ss << ")";return os;}
template <typename T> istream& operator>>(istream& is, vector <T>& a){for (auto &x : a){is >> x;}return is;}
template <typename T> ostream& operator<<(ostream& os, vector <T> a){for (auto x : a){os << x << " ";}os << endl;return os;}
template <typename T> void print(T a){for (auto x : a){cout << x << " ";}cout << endl;}

struct edge{
    int u, x, y;
};

const int N = 200010;
vector <edge> g[N];
int ans[N];
map <int, int> f[N];

int binpow(int x, int y){
    int c = 1;
    while (y){
        if (y & 1){
            c = (ll)c * x % M;
        }
        y >>= 1;
        x = (ll)x * x % M;
    }
    return c;
}

int gcd(int a, int b){
    while (a > 0 && b > 0){
        if (a < b){
            swap(a, b);
        }
        a %= b;
    }
    return a + b;
}

void dfs(int v, int r, map <int, int>& s){
    for (auto [u, x, y] : g[v]){
        if (u != r){
            for (auto const &[d, val] : f[x]){
                s[d] -= val;
                s[d] = max(s[d], 0);
            }
            for (auto const &[d, val] : f[y]){
                s[d] += val;
            }
            dfs(u, v, s);
            for (auto const &[d, val] : f[x]){
                s[d] += val;
            }
            for (auto const &[d, val] : f[y]){
                s[d] -= val;
            }
        }
    }
}

void walk(int v, int r, map <int, int>& s){
    for (auto const &[d, val] : s){
        ans[v] = (ll)ans[v] * binpow(d, val) % M;
    }
    for (auto [u, x, y] : g[v]){
        if (u != r){
            for (auto const &[d, val] : f[x]){
                s[d] -= val;
            }
            for (auto const &[d, val] : f[y]){
                s[d] += val;
            }
            walk(u, v, s);
            for (auto const &[d, val] : f[x]){
                s[d] += val;
            }
            for (auto const &[d, val] : f[y]){
                s[d] -= val;
            }
        }
    }
}

void solve(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        g[i].clear();
        ans[i] = 1;
    }
    for (int k = 0; k < n - 1; k++){
        int i, j, x, y;
        cin >> i >> j >> x >> y;
        i--; j--;
        int gd = gcd(x, y);
        x /= gd;
        y /= gd;
        g[i].pb({j, x, y});
        g[j].pb({i, y, x});
    }
    map <int, int> a;
    dfs(0, -1, a);
    walk(0, -1, a);
    int sum = 0;
    for (int i = 0; i < n; i++){
        sum = (sum + ans[i]) % M;
    }
    cout << sum << endl;
}

int32_t main(){
#ifndef LOCAL
ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#endif
    for (int i = 2; i < N; i++){
        int x = i;
        for (int j = 2; j * j <= x; j++){
            while (x % j == 0){
                x /= j;
                f[i][j]++;
            }
        }
        if (x > 1){
            f[i][x]++;
        }
    }
    int ttt = 1;
    cin >> ttt;
    while (ttt--){
        solve();
    }
}