#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <utility>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <string>
#include <sstream>
#include <random>
#include <cstdio>
#include <cstdlib>

using namespace std;

void solve() {

	long long n;
	cin >> n;
	vector<long long> a(n);
	vector<long long> olddel(n);
	long long w = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		w += a[i];
	}
	sort(a.begin(), a.end());
	reverse(a.begin(), a.end());
	long long del = 1;
	int ind = 0;
	while (w / del > 0) {
		long long cnt1 = w % del, cnt0 = del - cnt1;
		for (int i = 0; i < ind; ++i) {
			long long cntdop1 = a[i] % (del / olddel[i]), cntdop0 = (del / olddel[i]) - cntdop1;
			cnt0 -= cntdop0;
			cnt1 -= cntdop1;
		}
		while (ind < n && a[ind] == w / del + 1 && cnt1 > 0) {
			olddel[ind] = del;
			++ind;
			--cnt1;
		}
		while (ind < n && a[ind] == w / del && cnt0 > 0) {
			olddel[ind] = del;
			++ind;
			--cnt0;
		}
		del *= 2ll;
	}
	long long cnt = w;
	for (int i = 0; i < ind; ++i) {
		cnt -= a[i];
	}
	while (ind < n && a[ind] == 1 && cnt > 0) {
		--cnt;
		olddel[ind] = del;
		++ind;
	}
	if (ind == n && cnt == 0) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}