#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <array>
using namespace std;
typedef long long ll;
#define all(a) a.begin(), a.end()
#define rall(a) a.end(), a.begin()
ll gcd(ll a, ll b) {
    if (a == 0) {
        return b;
    }
    return gcd(b % a, a);
}
struct tr {
    vector<ll> t;
    void build(ll n) {
        t.resize(4 * n, 0);
    }
    /*void upd(int i, ll val, int x = 0, int l = 0, int r = n) {
        if (r - l == 1) {
            t[x] = val; ///
            return;
        }
        int mid = (r + l) / 2, xl = 2 * x + 1, xr = 2 * x + 2;
        if (i < mid) {
            upd(i, val, xl, l, mid);
        }
        else {
            upd(i, val, xr, mid, r);
        }
        t[x] = t[xl] + t[xr];
    }
    ll get(int l1, int r1, int x = 0, int l = 0, int r = n) {
        if (r1 <= l || r <= l1) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            return t[x];
        }
        int mid = (r + l) / 2, xl = 2 * x + 1, xr = 2 * x + 2;
        return get(l1, r1, xl, l, mid) + get(l1, r1, xr, mid, r);
    }*/
};
ll MOD = 998244353, x = 1;
vector<vector<array<ll, 3>>> g;
vector<ll> ans;
map<ll, ll> now, e;
vector<ll> d(2e5 + 100, -1);
vector<ll> prime;
ll bin_pow(ll a, ll pow) {
    if (pow == 0) {
        return 1;
    }
    ll www = bin_pow(a, pow / 2);
    www = www * www % MOD;
    if (pow % 2 == 1) {
        www = a * www % MOD;
    }
    return www;
}
void dfs(int u, int p = -1) {
    for (auto c : g[u]) {
        if (c[0] != p) {
            ll a = c[1], b = c[2];
            while (b > 1) {
                now[d[b]]--;
                b /= d[b];
            }
            while (a > 1) {
                now[d[a]]++;
                e[d[a]] = max(e[d[a]], now[d[a]]);
                a /= d[a];
            }
            dfs(c[0], u);
            a = c[1];
            b = c[2];
            while (a > 1) {
                now[d[a]]--;
                a /= d[a];
            }
            while (b > 1) {
                now[d[b]]++;
                b /= d[b];
            }
        }
    }
}
void ansfs(int u, int p, ll x_n) {
    ans[u] = x_n;
    for (auto c : g[u]) {
        if (c[0] != p) {
            ll a = c[1], z = 1;
            while (a > 1) {
                z = z * d[a] % MOD;
                a /= d[a];
            }
            z = bin_pow(z, MOD - 2);
            ansfs(c[0], u, x_n * c[2] % MOD * z % MOD);
        }
    }
}

signed main() {
    int q = 2e5 + 1;
    for (int i = 2; i < q; i++) {
        if (d[i] == -1) {
            prime.push_back(i);
            d[i] = i;
        }
        for (int j = 0; j < prime.size(); j++) {
            if (prime[j] * i > q || prime[j] > d[i]) {
                break;
            }
            d[prime[j] * i] = prime[j];
        }
    }
    ll t = 1;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;
        g.clear();
        g.resize(n);
        ans.clear();
        ans.resize(n, 1);
        x = 1;
        now.clear();
        e.clear();
        for (int i = 0; i < n - 1; i++) {
            ll a, b, x, y;
            cin >> a >> b >> x >> y;
            a--;
            b--;
            int h = gcd(x, y);
            x /= h;
            y /= h;
            g[a].push_back({ b, x, y });
            g[b].push_back({ a, y, x });
        }
        for (int i = 0; i < n; i++) {
            if (g[i].size() == 1) {
                dfs(i);
                for (auto& c : e) {
                    x = x * bin_pow(c.first, c.second) % MOD;
                }
                ansfs(i, -1, x);
                break;
            }
        }
        ll sum = 0;
        for (int i = 0; i < n; i++) {
            sum = (sum + ans[i]) % MOD;
        }
        cout << sum << "\n";
    }

}