#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using ld = long double;

const int K = 500;
const int MAXN = 200'000;
const int MID = MAXN * K;

int a[MAXN];
int cnt[MAXN * K * 2];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n = 0;
    cin >> n;

    int ans = n - 1;
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    for (int step = -K; step < K; ++step)
    {
        for (int i = 0; i < n; ++i)
        {
            a[i] -= step * i - MID;
            ++cnt[a[i]];
            ans = min(ans, n - cnt[a[i]]);
        }
        for (int i = 0; i < n; ++i)
        {
            --cnt[a[i]];
            a[i] += step * i - MID;    
        }
    }

    int len = MAXN / K + 2;
    vector<int> del;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 1; j < min(n - i, len); ++j)
        {
            int d = (a[i + j] - a[i]) / j;
            if (d * j == a[i + j] - a[i])
            {
                ans = min(ans, n - (++cnt[d + MID]) - 1);
                del.push_back(d);
            }
        }
        for (auto d : del)
            --cnt[d + MID];
    }

    cout << ans << "\n";

    return 0;
}