#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <queue>
#include <set>
#include <map>

using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
const int mod = 998244353, N = 1e5 + 2, root = 3e2 + 2;

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int n; cin >> n;
	vector <int> a(n);
	for (auto& x : a) cin >> x;
	int ans = min(n, 2ll);
	for (int i = -root; i <= root; ++i) {
		map <int, int> cnt;
		for (int j = 0; j < n; ++j) {
			cnt[a[j] + j * i]++;
			ans = max(ans, cnt[a[j] + j * i]);
		}
	}
	vector <map <int, int>> dp(n + 1);
	for (int i = 0; i < n; ++i) {
		for (int j = i - 1; j >= 0 and abs(j - i) <= root; --j) {
			if ((a[i] - a[j]) % (i - j) != 0) continue;
			int d = (a[i] - a[j]) / (i - j);
			if (dp[j].find(d) != dp[j].end())
				dp[i][d] = max(dp[i][d], dp[j][d] + 1);
			else
				dp[i][d] = 2;
			ans = max(ans, dp[i][d]);
		}
	}
	cout << n - ans << '\n';


}