#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <queue>
#include <set>
#include <map>
#include <numeric>

using namespace std;
#pragma GCC optimize("O3")
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
#define int long long
const int mod = 998244353, N = 1e5 + 2, root = 350;

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int n; cin >> n;
	int len = 1ll << n;
	string s; cin >> s;

	vector <int> all(len);
	iota(all.begin(), all.end(), 0);
	sort(all.begin(), all.end(), [&](int i, int j) {return s[i] < s[j]; });
	set <int> good = { all.begin(), all.end() };
	for (int i = 0; i < len; ++i) {
		int was = -1;
		set <int> ok;
		for (auto& x : all) {
			int w = x ^ i;
			if (good.find(w) == good.end()) continue;
			if (was != -1 and s[was] != s[x]) break;
			was = x;
			ok.insert(w);
		}
		good = ok;
	}
	int id = *good.begin();
	for (int i = 0; i < len; ++i) cout << s[i ^ id];
	cout << '\n';

}