#include <bits/stdc++.h>
#define fori for (int i = 0; i < n; ++i)
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#ifdef qscfthmko147
bool debug = false;//true;
#else
bool debug = false;
#endif // qscfthmko147

const ll MOD = 998244353;
const ll N = 2e5+228;

/*
1
8
5 4 2 3
6 4 5 4
1 3 5 2
6 8 2 1
3 5 3 4
3 2 2 5
6 7 4 3

*/

ll bp(ll n, ll k) {
    ll ans = 1;
    while (k > 0) {
        if (k&1) ans = ans * n % MOD;
        n = n * n % MOD;
        k >>= 1;
    }
    return ans;
}

struct edge {
    ll to, x, y;
    edge() = default;
    edge(ll to1, ll x1, ll y1) {
        to = to1;
        x = x1;
        y = y1;
    }
    void in() {
        cin >> to >> x >> y;
    }
};

vector <vector <edge>> g;
vector <vector <edge>> gr;

vector <ll> ts;

/*void top_sort(ll u, vector <bool> &used) {
    used[u] = true;
    for (edge e: g[u]) {
        ll v = e.to;
        if (used[v]) continue;
        top_sort(v, used);
    }
    ts.push_back(u);
}*/

/*void dfs1(ll u, ll &curnok, ll curx, ll cury, vector <bool> &used) {
    if(debug)cout << "IN DFS1 " << u << ' ' << curnok << ' ' << curx << ' ' << cury << endl;
    used[u] = true;
    for (auto vw: gr[u]) {
        ll v = vw.first;
        ll x = vw.second.first;
        ll y = vw.second.second;
    if(debug)cout << "CHECK NEIGH " << v << ' ' << x << ' ' << y << endl;
        if (used[v]) continue;
        curx *= x;
        cury *= y;
        ll gc = gcd(curx, cury);
        curx /= gc;
        cury /= gc;
        curnok = NOK(curnok, cury);
        dfs1(v, curnok, curx, cury, used);
    }
    for (auto vw: g[u]) {
        ll v = vw.first;
        ll x = vw.second.first;
        ll y = vw.second.second;
    if(debug)cout << "CHECK NEIGH2 " << v << ' ' << x << ' ' << y << endl;
        if (used[v]) continue;
        curx *= y;
        cury *= x;
        ll gc = gcd(curx, cury);
        curx /= gc;
        cury /= gc;
        curnok = NOK(curnok, cury);
        dfs1(v, curnok, curx, cury, used);
        curx *= gc;
        cury *= gc;
        curx /= x;
        cury /= y;
    }
    if(debug)cout << "OUT DFS1 " << u << ' ' << curnok << ' ' << curx << ' ' << cury << endl;
}*/

/*void dfs_ans(ll u, vector <bool> &used, vector <ll> &ans) {
    if(debug)cout << "IN DFS_ANS " << u << endl;
    used[u] = true;
    for (auto vw: gr[u]) {
        ll v = vw.first;
        ll x = vw.second.first;
        ll y = vw.second.second;
        if (used[v]) continue;
        if(debug)cout << "V, X, Y = " << v << ' ' << x << ' ' << y << endl;
        ans[v] = ans[u] * x / y;
        if(debug)cout << "NEW ANS = " << ans[v] << endl;
        dfs_ans(v, used, ans);
    }
    for (auto vw: g[u]) {
        ll v = vw.first;
        ll x = vw.second.first;
        ll y = vw.second.second;
        if (used[v]) continue;
        if(debug)cout << "V, X, Y = " << v << ' ' << x << ' ' << y << endl;
        ans[v] = ans[u] * y / x;
        if(debug)cout << "NEW ANS = " << ans[v] << endl;
        dfs_ans(v, used, ans);
    }
    if(debug)cout << "OUT DFS_ANS " << u << endl;
}*/

vector <ll> prime, lp, lp2, lpcnt;

void era(ll n) {
    lp.resize(n);
    lp2.resize(n);
    lpcnt.resize(n, 1);
    iota(lp.begin(), lp.end(), 0);
    iota(lp2.begin(), lp2.end(), 0);
    for (ll i = 2; i < n; ++i) {
        if (i == lp[i]) prime.push_back(i);
        for (int j = 0; j < prime.size() && prime[j] * i < n && prime[j] <= lp[i]; ++j) {
            if (prime[j] == lp[i]) {
                lp[prime[j] * i] = prime[j];
                lp2[prime[j] * i] = prime[j] * lp2[i];
                lpcnt[prime[j] * i] = lpcnt[i] + 1;
            } else {
                lp[prime[j] * i] = prime[j];
                lp2[prime[j] * i] = prime[j];
                lpcnt[prime[j] * i] = 1;
            }
        }
    }
}

vector <pair <ll, ll>> fact(ll n) {
    vector <pair <ll, ll>> ans;
    while (n > 1) {
        ans.push_back({lp[n], lpcnt[n]});
        n /= lp2[n];
    }
    return ans;
}

void dfs_cnt(ll u, vector <bool> &used, unordered_map <ll, ll> &nok, unordered_map <ll, ll> &upper, unordered_map <ll, ll> &lower) {
    if(debug)cout << "ENTER DFS_CNT " << u << endl;
    used[u] = true;
    for (edge e: gr[u]) {
        ll v = e.to;
        ll x = e.x;
        ll y = e.y;
        if(debug)cout << "CHECKING V = " << v << "; X, Y = " << x << ' ' << y << endl;
        if (used[v]) continue;
        unordered_map <ll, ll> chga, chgb;
        vector <pair <ll, ll>> a = fact(x), b = fact(y);
        if(debug){
            cout << "A IS :" << endl;
            for (auto [i, j]: a) cout << i << ' ' << j << endl;
            cout << "B IS :" << endl;
            for (auto [i, j]: b) cout << i << ' ' << j << endl;
        }
        for (int i = 0; i < a.size(); ++i) {
            upper[a[i].first] += a[i].second;
            if(debug)cout << "UPPER[" << a[i].first << "] = " << upper[a[i].first] << endl;
            chga[a[i].first] -= a[i].second;
        }
        for (int i = 0; i < b.size(); ++i) {
            lower[b[i].first] += b[i].second;
            if(debug)cout << "LOWER[" << b[i].first << "] = " << lower[b[i].first] << endl;
            chgb[b[i].first] -= b[i].second;
        }
        for (int i = 0; i < a.size(); ++i) {
            ll curmax = min(upper[a[i].first], lower[a[i].first]);
            lower[a[i].first] -= curmax;
            upper[a[i].first] -= curmax;
            if(debug)cout << "UPPER[" << a[i].first << "] = " << upper[a[i].first] << endl;
            if(debug)cout << "LOWER[" << a[i].first << "] = " << lower[a[i].first] << endl;
            chga[a[i].first] += curmax;
            chgb[a[i].first] += curmax;
        }
        for (int i = 0; i < b.size(); ++i) {
            ll curmax = min(upper[b[i].first], lower[b[i].first]);
            lower[b[i].first] -= curmax;
            upper[b[i].first] -= curmax;
            if(debug)cout << "UPPER[" << b[i].first << "] = " << upper[b[i].first] << endl;
            if(debug)cout << "LOWER[" << b[i].first << "] = " << lower[b[i].first] << endl;
            chga[b[i].first] += curmax;
            chgb[b[i].first] += curmax;
        }
        for (int i = 0; i < b.size(); ++i) {
            nok[b[i].first] = max(nok[b[i].first], lower[b[i].first]);
            if(debug)cout << "NEW NOK[" << b[i].first << "] = " << max(nok[b[i].first], lower[b[i].first]) << endl;
        }
        dfs_cnt(v, used, nok, upper, lower);
        for (auto [q, w]: chga) {
            upper[q] += w;
        }
        for (auto [q, w]: chgb) {
            lower[q] += w;
        }
    }
    for (edge e: g[u]) {
        ll v = e.to;
        ll x = e.y;
        ll y = e.x;
        if(debug)cout << "CHECKING V = " << v << "; X, Y = " << x << ' ' << y << endl;
        if (used[v]) continue;
        unordered_map <ll, ll> chga, chgb;
        vector <pair <ll, ll>> a = fact(x), b = fact(y);
        if(debug){
            cout << "A IS :" << endl;
            for (auto [i, j]: a) cout << i << ' ' << j << endl;
            cout << "B IS :" << endl;
            for (auto [i, j]: b) cout << i << ' ' << j << endl;
        }
        for (int i = 0; i < a.size(); ++i) {
            upper[a[i].first] += a[i].second;
            if(debug)cout << "UPPER[" << a[i].first << "] = " << upper[a[i].first] << endl;
            chga[a[i].first] -= a[i].second;
        }
        for (int i = 0; i < b.size(); ++i) {
            lower[b[i].first] += b[i].second;
            if(debug)cout << "LOWER[" << b[i].first << "] = " << lower[b[i].first] << endl;
            chgb[b[i].first] -= b[i].second;
        }
        for (int i = 0; i < a.size(); ++i) {
            ll curmax = min(upper[a[i].first], lower[a[i].first]);
            lower[a[i].first] -= curmax;
            upper[a[i].first] -= curmax;
            if(debug)cout << "UPPER[" << a[i].first << "] = " << upper[a[i].first] << endl;
            if(debug)cout << "LOWER[" << a[i].first << "] = " << lower[a[i].first] << endl;
            chga[a[i].first] += curmax;
            chgb[a[i].first] += curmax;
        }
        for (int i = 0; i < b.size(); ++i) {
            ll curmax = min(upper[b[i].first], lower[b[i].first]);
            lower[b[i].first] -= curmax;
            upper[b[i].first] -= curmax;
            if(debug)cout << "UPPER[" << b[i].first << "] = " << upper[b[i].first] << endl;
            if(debug)cout << "LOWER[" << b[i].first << "] = " << lower[b[i].first] << endl;
            chga[b[i].first] += curmax;
            chgb[b[i].first] += curmax;
        }
        for (int i = 0; i < b.size(); ++i) {
            nok[b[i].first] = max(nok[b[i].first], lower[b[i].first]);
            if(debug)cout << "NEW NOK[" << b[i].first << "] = " << max(nok[b[i].first], lower[b[i].first]) << endl;
        }
        dfs_cnt(v, used, nok, upper, lower);
        for (auto [q, w]: chga) {
            upper[q] += w;
        }
        for (auto [q, w]: chgb) {
            lower[q] += w;
        }
    }
    if(debug)cout << "EXIT DFS_CNT " << u << endl;
}

void dfs_ans(ll u, vector <bool> &used, vector <ll> &ans) {
    used[u] = true;
    for (edge e: gr[u]) {
        ll v = e.to;
        ll x = e.x;
        ll y = e.y;
        if (used[v]) continue;
        ans[v] = (ans[u] * x % MOD) * bp(y, MOD-2) % MOD;
        dfs_ans(v, used, ans);
    }
    for (edge e: g[u]) {
        ll v = e.to;
        ll x = e.x;
        ll y = e.y;
        if (used[v]) continue;
        ans[v] = (ans[u] * y % MOD) * bp(x, MOD-2) % MOD;
        dfs_ans(v, used, ans);
    }
}

ll nok_to_num(unordered_map <ll, ll> nok) {
    if(debug)cout << "IN NOK TO NUM" << endl;
    ll ans = 1;
    for (auto [n, x]: nok) {
        if(debug)cout << "IN NOK:" << n << ' ' << x << endl;
        ans = ans * bp(n, x) % MOD;
    }
    if(debug)cout << "RETURNED " << ans << endl;
    return ans;
}

inline void solve() {
    ll n;
    cin >> n;
    g.clear();
    gr.clear();
    ts.clear();
    g.resize(n, vector <edge> (0));
    gr.resize(n, vector <edge> (0));
    for (int i = 0; i < n-1; ++i) {
        ll a, b, x, y;
        cin >> a >> b >> x >> y;
        if (x < y) {
            swap(a, b);
            swap(x, y);
        }
        ll gc = gcd(x, y);
        g[a-1].push_back(edge(b-1, x/gc, y/gc));
        gr[b-1].push_back(edge(a-1, x/gc, y/gc));
    }
    //vector <bool> usedts(n);
    //fori {
    //    if (!usedts[i]) top_sort(i, usedts);
    //}
    //reverse(ts.begin(), ts.end());
    vector <ll> ans(n);
    unordered_map <ll, ll> nok, upper, lower;
    vector <bool> usedcnt(n);
    dfs_cnt(0, usedcnt, nok, upper, lower);
    ///asd HELLO ///
    ans[0] = nok_to_num(nok);
    if(debug)cout << "ANS[0] = " << ans[0] << endl;
    vector <bool> usedans(n);
    dfs_ans(0, usedans, ans);
    ll rans = 0;
    for (ll i: ans) rans = (rans + i) % MOD;
    cout << rans << endl;//'\n';
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    era(N);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}


/*
1
8
5 4 2 3
6 4 5 4
1 3 5 2
6 8 2 1
3 5 3 4
3 2 2 5
6 7 4 3

*/
