#include <iostream>
#include <set>
#include <queue>
#include <chrono>
#include <random>
using namespace std;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define int long long

void solve () {
    int n, m = 0, k, a[200100];
    multiset <int> s;

    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s.insert(a[i]);
        m += a[i];
    }
    if (n == 1) {
        cout << "YES\n";
        return;
    }

    queue <int> q;
    q.push(m);
    while (!q.empty()) {
        k = q.front();
        if (k == 1) {
            cout << "NO\n";
            return;
        }
        int k1 = k / 2, k2 = (k + 1) / 2;
        q.pop();

        if (s.find(k2) != s.end())
            s.erase(s.find(k2));
        else if (k2 == 1) {
            cout << "NO\n";
            return;
        }
        else
            q.push(k2);

        if (s.find(k1) != s.end())
            s.erase(s.find(k1));
        else if (k1 == 1) {
            cout << "NO\n";
            return;
        }
        else
            q.push(k1);

        if (q.size() > s.size()) {
            cout << "NO\n";
            return;
        }
    }
    if (!s.empty()) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;

    cin >> t;
    while (t--)
        solve();

    return 0;
}
