#include <bits/stdc++.h>
using namespace std;

#define int long long

int mod = 998244353, ans;
map <int, int> m;
vector <vector <pair <int, pair <int, int> > > > d(200100);
vector <int> mmax(200100), u(200100), rev(200100);
vector <vector <pair <int, int> > > pr(200100);

int poww (int a, int m) {
    int k = 1;
    while (m) {
        if (m % 2)
            k = 1ll * k * a % mod;
        a = 1ll * a * a % mod;
        m /= 2;
    }
    return k;
}

void dfs (int v, int x = -1, int y = -1) {
    u[v] = 1;
//    cout << v << '\n';
    if (x != -1) {
        for (auto i : pr[x])
            m[i.first] += i.second;
        for (auto i : pr[y]) {
            m[i.first] -= i.second;
        }
        for (auto i : pr[x])
            mmax[i.first] = max(mmax[i.first], m[i.first]);
        for (auto i : pr[y])
            mmax[i.first] = max(mmax[i.first], m[i.first]);
    }
    for (auto to : d[v]) {
        if (!u[to.first])
            dfs(to.first, to.second.first, to.second.second);
    }
    if (x != -1) {
        for (auto i : pr[x])
            m[i.first] -= i.second;
        for (auto i : pr[y])
            m[i.first] += i.second;
    }
}

void dfs1 (int v, int k, int x = -1, int y = -1) {
    u[v] = 2;
    int k1 = k;
    if (x != -1) {
        k1 = (1ll * k1 * rev[x]) % mod;
        k1 = (1ll * k1 * y) % mod;
    }
    ans = (ans + k1) % mod;
    for (auto to : d[v])
        if (u[to.first] != 2)
            dfs1 (to.first, k1, to.second.first, to.second.second);
}

void solve () {
    int n, k = 1;

    cin >> n;
    m.clear();
    ans = 0;
    for (int i = 0; i <= n; i++) {
        d[i].clear();
        mmax[i] = 0;
        u[i] = 0;
    }
    for (int f = 1; f < n; f++) {
        int i, j, x, y;

        cin >> i >> j >> x >> y;
        i--;
        j--;
        d[i].push_back({j, {x, y}});
        d[j].push_back({i, {y, x}});
    }
    dfs(0);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < mmax[i]; j++)
            k = (1ll * k * i) % mod;
    }
    dfs1(0, k);
    cout << ans << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t, a[200100] = {0}, m = 2e5 + 10;

    for (int i = 2; i <= m; i++) {
        if ((int)pr[i].size())
            continue;
        for (int j = i; j <= m; j += i) {
            int k = 0, n = j;
            while (!(n % i)) {
                k++;
                n /= i;
            }
            pr[j].push_back({i, k});
        }
    }
//    for (int i = 0; i <= 25; i++) {
//        cout << "i = " << i << ":   ";
//        for (auto j : pr[i])
//            cout << j.first << ' ' << j.second << "  ";
//        cout << '\n';
//    }
    for (int i = 1; i <= m; i++)
        rev[i] = poww(i, mod - 2);

    cin >> t;
    while (t--)
        solve();

    return 0;
}
