//
// Created by 79169 on 20.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <cassert>
#include <string>
#include <chrono>
#include <time.h>
#include <ctime>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e9;

mt19937 rnd(time(NULL));
#define endl '\n';

void no(){
    cout << "NO" << endl;
}

void yes(){
    cout << "YES" << endl;
}

int ask(int x){
    cout << x << endl;
    int y;
    cin >> y;
    return y;
}

inline int gcd(int a, int b){
    while (a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}

inline void solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    ll sum = 0;
    unordered_map<ll, int> st;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        st[a[i]] += 1;
        sum += a[i];
    }
    unordered_multiset<ll> st1;
    st1.insert(sum);
    for (int i = 0; i < n - 1; ) {
        ll x = *(st1.begin());
        if (st.find(x) == st.end() || st[x] == 0){
            ++i;
            if (x < 2){
                no();
                return;
            }
            ll y = x / 2;
            ll y_ = x - y;
            st1.erase(st1.begin());
            st1.insert(y);
            st1.insert(y_);
        }
        else{
            st1.erase(st1.begin());
            st[x]--;
        }
    }
    for (auto el : st1){
        st[el]--;
        if (st[el] < 0){
            no();
            return;
        }
    }
    yes();
//    cout << "NO" << endl;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    // t = 1;
    while (t--){
        solve();
    }
}