//
// Created by 79169 on 20.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <cassert>
#include <string>
#include <chrono>
#include <time.h>
#include <ctime>
#include <random>

using namespace std;
using ll = unsigned long long;
using ld = long double;

const int INF = 1e9;
const ll MOD = 998244353;
const int N = 2e5;
mt19937 rnd(time(NULL));
//#define endl '\n';

void no(){
    cout << "NO" << endl;
}

void yes(){
    cout << "YES" << endl;
}

int ask(int x){
    cout << x << endl;
    int y;
    cin >> y;
    return y;
}

inline ll gcd(ll a, ll b){
    while (a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}

vector<vector<pair<int, pair<ll, ll>>>> g;

map<ll, int> max_pow;
map<ll, int> cnt_pow;

int lp[N + 1];
vector<int> prime;

ll ppp = 1;
ll qqq = 1;

void prepare(){
    fill(lp, lp + N + 1, 0);
    for (int i = 2; i <= N; ++i){
        if (lp[i] == 0){
            lp[i] = i;
            prime.push_back(i);
        }
        for (int j = 0; j < prime.size() && prime[j] * i <= N && prime[j] <= lp[i]; ++j){
            lp[i * prime[j]] = prime[j];
        }
    }
}

void upd(ll p, ll q){
    while (p != 1){
        cnt_pow[lp[p]]--;
        p /= lp[p];
    }
    ll q1 = q;
    while (q != 1){
        cnt_pow[lp[q]]++;
        q /= lp[q];
    }
    while (q1 != 1){
        max_pow[lp[q1]] = max(max_pow[lp[q1]], cnt_pow[lp[q1]]);
        q1 /= lp[q1];
    }
}

ll sum = 0;

ll po2w(ll a, ll n){
    if (n == 0){
        return 1;
    }
    if (n == 1){
        return a;
    }
    if (n % 2 == 0){
        ll x = po2w(a, n / 2);
        return (x * x) % MOD;
    }
    if (n % 2 == 1){
        ll x = po2w(a, n - 1);
        return (x * a) % MOD;
    }
}

void dfs(int v, int p){
    sum += ppp * po2w(qqq, MOD - 2);
    sum %= MOD;
    for (auto &[u, c] : g[v]){
        if (u != p){
            upd(c.first, c.second);
            ll pppp = ppp, qqqq = qqq;
            ppp *= c.first;
            ppp %= MOD;
            qqq *= c.second;
            qqq %= MOD;
            dfs(u, v);
            ppp = pppp;
            qqq = qqqq;
            upd(c.second, c.first);
        }
    }
}


inline void solve() {
    int n;
    cin >> n;
    g.resize(0);
    g.resize(n);
    cnt_pow.clear();
    max_pow.clear();
    for (int i = 0; i < n - 1; ++i) {
        int a, b, x, y;
        cin >> a >> b >> x >> y;
        --a; --b;
        g[a].push_back({b, {y, x}});
        g[b].push_back({a, {x, y}});
    }

    sum = 0;
    dfs(0, 0);
//    cout << sum << endl;
    ll ans = 1;
    for (auto &[pr, poww] : max_pow){
//        cout << "ans *= " << pr << " ^ " << poww << endl;
        if (poww >= 0) {
            ans *= po2w(pr, poww);
            ans %= MOD;
        }
    }
//    cout << ans << endl;
    sum *= ans;
    sum %= MOD;
    cout << sum << endl;

}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    prepare();
    int t;
    cin >> t;
    // t = 1;
    while (t--){
//        int a, b;
//        cin >> a >> b;
//        cout << pow(a, b) << endl;
        solve();
    }
}