//
// Created by 79169 on 20.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <cassert>
#include <string>
#include <chrono>
#include <time.h>
#include <ctime>
#include <random>

using namespace std;
using ll = unsigned long long;
using ld = long double;

const int INF = 1e9;
const ll MOD = 998244353;
const int N = 1e5;
mt19937 rnd(time(NULL));
//#define endl '\n';

void no(){
    cout << "NO" << endl;
}

void yes(){
    cout << "YES" << endl;
}

int ask(int x){
    cout << x << endl;
    int y;
    cin >> y;
    return y;
}

inline ll gcd(ll a, ll b){
    while (a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}

ll po2w(ll a, ll n){
    if (n == 0){
        return 1;
    }
    if (n == 1){
        return a;
    }
    if (n % 2 == 0){
        ll x = po2w(a, n / 2);
        return (x * x) % MOD;
    }
    if (n % 2 == 1){
        ll x = po2w(a, n - 1);
        return (x * a) % MOD;
    }
}

inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ans = n;
    int ff = a[0];
    for (int val = -N; val <= 2 * N; ++val){
        a[0] = val;
        int mx = 0;
        unordered_map<int, int> cnt_for_d;
        for (int i = 1; i < n; ++i){
            if ((a[i] - a[0]) % i == 0){
                cnt_for_d[(a[i] - a[0]) / i]++;
                mx = max(mx, cnt_for_d[(a[i] - a[0]) / i]);
            }
        }
        if (val == ff){
            mx++;
        }
        ans = min(ans, n - mx);
    }
    cout << ans << endl;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    prepare();
    int t;
//    cin >> t;
     t = 1;
    while (t--){
//        int a, b;
//        cin >> a >> b;
//        cout << pow(a, b) << endl;
        solve();
    }
}