#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#define ll long long
using namespace std;
#define int long long
const int X = 1e6 + 2;
const int Mod = 998244353;
pair < pair <int, int>, pair <int, int> > edges[X];
ll ans[X];
int mnp[X];
int np[X];
int used[X];
vector <int> sw;
vector <int> g[X];


int st(int a, int b)
{
    ll ans = 1;
    while (b > 0)
    {
        if (b % 2 == 1)
        {
            ans *= a;
            ans %= Mod;
        }
        b /= 2;
        a *= a;
       
        a %= Mod;
        if (a == 0)
        {
            int l=0;
            l++;
        }
    }
    return ans;
}

ll del(ll a, ll b)
{
    ll h = st(b, Mod - 2);
    return (a * st(b, Mod - 2))%Mod;
}

void dfs(int v, int par)
{
    for (auto x : g[v])
    {
        auto y = edges[x];
        if (y.first.first != v)
        {
            swap(y.first.first, y.first.second);
            swap(y.second.first, y.second.second);
        }
        if (y.first.second != par)
        {

            int u = y.second.second;
            int u1 = y.second.first;
            for (int i = 2; i * i <= y.second.second; i++)
            {
            
                while (y.second.second % i == 0)
                {
                    y.second.second /= i;
                    np[i]++;
                    if (used[i] == 0)
                    {
                        used[i] = 1;
                        sw.push_back(i);
                    }
                    if (np[i] < mnp[i])
                    {
                        mnp[i] = np[i];
                    }
                }
            }
            if (y.second.second != 1)
            {
                np[y.second.second]++;
                if (used[y.second.second] == 0)
                {
                    used[y.second.second] = 1;
                    sw.push_back(y.second.second);
                }
            }
            for (int i = 2; i * i <= y.second.first; i++)
            {
                while (y.second.first % i == 0)
                {
                    y.second.first /= i;
                    np[i]--;
                    if (used[i] == 0)
                    {
                        used[i] = 1;
                        sw.push_back(i);
                    }
                    if (np[i] < mnp[i])
                    {
                        mnp[i] = np[i];
                    }
                }
            }
            if (y.second.first > 1)
            {
                np[y.second.first]--;
                if (np[y.second.first] < mnp[y.second.first])
                {
                    mnp[y.second.first] = np[y.second.first];
                }
                if (used[y.second.first] == 0)
                {
                    used[y.second.first] = 1;
                    sw.push_back(y.second.first);
                }
            }
            dfs(y.first.second, v);
            y.second.second = u;
            y.second.first = u1;
            for (int i = 2; i * i <= y.second.second; i++)
            {

                while (y.second.second % i == 0)
                {
                    y.second.second /= i;
                    np[i]--;
                }
            }
            if (y.second.second != 1)
            {
                np[y.second.second]--;
                
            }
            for (int i = 2; i * i <= y.second.first; i++)
            {
                while (y.second.first % i == 0)
                {
                    y.second.first /= i;
                    np[i]++;
                }
            }
            if (y.second.first > 1)
            {
                np[y.second.first]++;
            }
        }
    }
}

void dfs_ans(int v, int par, ll now)
{
    for (auto x : g[v])
    {
        auto y = edges[x];
        if (y.first.first != v)
        {
            swap(y.first.first, y.first.second);
            swap(y.second.first, y.second.second);
        }
        if (y.first.second != par)
        {
            ll k = 1;

            k = now * y.second.second;
            k %= Mod;
            k = del(k, y.second.first);
            ans[y.first.second] = k;
            dfs_ans(y.first.second, v, k);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
     while (t--)
     {
         int a;
         cin >> a;
         for (int i = 0; i < a - 1; i++)
         {
             cin >> edges[i].first.first >> edges[i].first.second >> edges[i].second.first >> edges[i].second.second;
             g[edges[i].first.first].push_back(i);
             g[edges[i].first.second].push_back(i);
         }
         dfs(1,0);
         int x = 1;
         for (auto z : sw)
         {
             x *= st(z, abs(mnp[z]));
             mnp[z] = 0;
             np[z] = 0;
             x %= Mod;
         }
         ans[1] = x;
         dfs_ans(1,0, x);
         ll sum = 0;
         for (int i = 1; i <= a; i++)
         {
             sum += ans[i];
             sum %= Mod;
         }
         cout << sum << endl;
         for (int i = 1; i <= a; i++)
         {
             ans[i] = 0;
             g[i].clear();
         }
     }
}

