#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const bool LOCAL = false;
const bool multitest = true;

const int mod = 1000000000 + 7;
const int inf = 1000000000 + 1;
const ll infll = 1000000000000000000 + 1;
mt19937_64 rnd(20123832);

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b){
	if (a > b){
		a = b;
		return true;
	}
	return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b){
	if (a < b){
		a = b;
		return true;
	}
	return false;
}

struct mint{
	int v;
	mint(int x){
		while (x < 0){
			x += mod;
		}
		while (x >= mod){
			x -= mod;
		}
		v = x;
	}
	mint() : v(0) {}
	friend mint operator + (mint a, mint b){
		return (a.v + b.v >= mod) ? a.v + b.v - mod : a.v + b.v;
	}
	mint operator += (mint other){
		return *this = *this + other;
	}
	friend mint operator - (mint a, mint b){
		return (a.v - b.v < 0) ? a.v - b.v + mod : a.v - b.v;
	}
	mint operator -= (mint other){
		return *this = *this - other;
	}
	friend mint operator -(mint a){
		return mint(-a.v);
	}
	friend mint operator * (mint a, mint b){
		return (1ll * a.v * b.v) % mod;
	}
	mint operator *= (mint other){
		return *this = *this * other;
	}
	void normalize(){
		while (v < 0){
			v += mod;
		}
		while (v >= mod){
			v -= mod;
		}
	}
	friend mint pow(mint a, int b){
		mint res = 1;
		while (b){
			if (b & 1) res *= a;
			a *= a;
			b >>= 1;
		}
		return res;
	}
	friend mint inv(mint a){
		return pow(a, mod - 2);
	}
	friend mint operator / (mint a, mint b){
		return a * inv(b);
	}
	mint operator /= (mint other){
		return *this = *this / other;
	}
	friend ostream& operator << (ostream& out, mint a){
		out << a.v;
		return out;
	}
	friend istream& operator >> (istream& in, mint &a){
		in >> a.v;
		a.normalize();
		return in;
	}
};

void solve(){
	int n;
	cin >> n;
	int a[n];
	for (int i = 0; i < n; i++){
		cin >> a[i];
	}
	int suf[n];
	suf[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; i--){
		suf[i] = max(suf[i + 1], a[i]);
	}
	int ans = 0;
	for (int i = 0; i + 1 < n; i++){
		chmax(ans, a[i] + suf[i + 1]);
	}
	cout << ans << '\n';
}
int main(){
	clock_t START = clock();
	if (LOCAL){
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	}
	int t = 1;
	if (multitest) cin >> t;
	while (t--){
		solve();
	}
	cerr << "Finished in " << 1000 * double(clock() - START) / CLOCKS_PER_SEC << " ms\n";
}