//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("-ffast-math")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define vec vector
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sqr(x) (x) * (x)
#define cube(x) (x) * (x) * (x)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

mt19937 rng(time(0));

typedef long long ll;
typedef long double ld;

#define int ll
#define double ld

typedef pair<int, int> pii;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = 998244353;

int binpow(int b, int e, int m = MOD) {
    int ans = 1;
    while(e) {
        if(e & 1) ans = 1LL * ans * b % m;
        b = 1LL * b * b % m;
        e >>= 1;
    }
    return ans;
}

template<typename T> void umin(T &x, T y) { if(x > y) x = y; }
template<typename T> void umax(T &x, T y) { if(x < y) x = y; }

const int SIZE = 1e6 + 5;

int n, a[SIZE];

void solve() {
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int sum = 0;
    map<int, int> cnt;
    for(int i = 0; i < n; i++) {
        cnt[a[i]]++;
        sum += a[i];
    }

    multiset<int> cur;
    cur.insert(sum);

    while(!cur.empty() && cur.size() <= n) {
        int x = *cur.begin();
        cur.erase(cur.begin());

        if(cnt[x] > 0) {
            cnt[x]--;
            continue;
        }

        if(x == 1) {
            cout << "NO";
            return;
        }

        cur.insert(x / 2);
        cur.insert((x + 1) / 2);
    }

    bool ok = cur.empty();
    for(auto i : cnt) {
        if(i.second > 0) {
            ok = 0;
            break;
        }
    }

    cout << (ok ? "YES" : "NO");


}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int t = 1;
    cin >> t;

    while(t--) {
        solve();
        cout << "\n";
    }

    return 0;
}
