#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define f first
#define s second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef tree<
null_type,
ll,
greater<ll>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;

const ll N = 2e5 + 100;
const ll oo = 998244353;

vector <ll> pr;
vector <ll> mlt[N];
vector <pair<ll, pair<ll, ll> > > a[N];

vector <ll> cur;
vector <ll> last;

ll val_0;
ll ans;

ll sum(ll x, ll y)
{
    return (x + y) % oo;
}

ll mult(ll x, ll y)
{
    return (x * y) % oo;
}

ll binpow(ll x, ll y)
{
    if (y == 0) return 1;
    if (y & 1) return mult(x, binpow(x, y - 1));
    else
    {
        ll c = binpow(x, y / 2);
        return mult(c, c);
    }
}

void add(ll x)
{
    cur[x]++;
}

void del(ll x)
{
    if (cur[x] > 0) cur[x]--;
    else val_0 = mult(val_0, x);
}

void Rec(ll x, ll y)
{
    for (auto i : a[x])
        if (i.f != y)
    {
        for (auto j : mlt[i.s.s]) add(j);
        for (auto j : mlt[i.s.f]) del(j);
        Rec(i.f, x);
        for (auto j : mlt[i.s.f]) add(j);
        for (auto j : mlt[i.s.s]) del(j);
    }
}

void Calc(ll x, ll y)
{
    ans = sum(ans, val_0);
    cout << x << " " << val_0 << endl;
    for (auto i : a[x])
        if (i.f != y)
    {
        val_0 = mult(val_0, i.s.s);
        val_0 = mult(val_0, binpow(i.s.f, oo - 2));
        Calc(i.f, x);
        val_0 = mult(val_0, i.s.f);
        val_0 = mult(val_0, binpow(i.s.s, oo - 2));
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    for (ll i = 2; i < N; i++)
    {
        ll j;
        for (j = 0; j < pr.size() && pr[j] * pr[j] <= i; j++)
            if (i % pr[j] == 0) break;
        if (j == pr.size() || pr[j] * pr[j] > i) pr.pb(i);
    }

    for (ll i = 2; i < N; i++)
    {
        ll x = i;
        for (ll j = 0; j < pr.size(); j++)
        {
            while (x % pr[j] == 0) mlt[i].pb(pr[j]), x /= pr[j];
            if (pr[j] * pr[j] > x)
            {
                if (x != 1) mlt[i].pb(x);
                break;
            }
        }
    }

    ll t;
    cin >> t;
    while (t--)
    {
        last.clear();
        cur.clear();
        last.resize(N, 0);
        cur.resize(N, 0);
        val_0 = 1;
        ans = 0;
        ll n;
        cin >> n;
        for (ll i = 0; i < n; i++) a[i].clear();
        for (ll i = 0; i < n - 1; i++)
        {
            ll x, y, x1, y1;
            cin >> x >> y >> x1 >> y1;
            a[--x].pb({--y, {x1, y1}});
            a[y].pb({x, {y1, x1}});
        }
        Rec(0, 0);
        Calc(0, 0);
        cout << ans << endl;
    }
}
