#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
// #include <priority_queue>
#include <unordered_set>
#include <bitset>
#include <algorithm>

// #define int long long
#define endl '\n'
#define all(x) x.begin(), x.end()

using namespace std;

typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


const int maxn = 2e5 + 228;
int abc[maxn];

int sum = 0;

vector<pair<int, pii>> g[maxn];

vi get(int a) {
    vi cnt;
    while (abc[a] != -1) {
        cnt.push_back(abc[a]);
        a /= abc[a];
    }
    return cnt;
}

void add(map<int, int>& a, vi b) {
    for (int i : b)
        a[i]++;
}

const int mod = 998244353;

int binpow(int n, int k) {
    if (!k)
        return 1;
    if (k & 1)
        return binpow(n, k - 1) * 1ll * n % mod;
    int b = binpow(n, k / 2);
    return b * 1ll * b % mod;
}

pair<int, map<int, int>> dfs(int v, int p = -1) {
    vector<pair<int, map<int, int>>> ans;
    map<int, int> cur;
    int sum = 0;
    map<int, int> nd2;
    for (auto i : g[v]) {
        if (i.first == p)
            continue;
        auto as = dfs(i.first, v);
        if (sum >= mod)
            sum -= mod;
        add(as.second, get(i.second.first));
        for (int i : get(i.second.second))
            as.second[i]--;
        for (pii i : as.second) {
            if (i.second <= 0)
                continue;
            cur[i.first] = max(cur[i.first], max(0, i.second));
        }
        ans.push_back(as);
    }
    int curr = 1;
    for (pii i : cur)
        curr = curr * 1ll * binpow(i.first, i.second) % mod;
    int cnt = -1;
    for (auto i : ans) {
        cnt++;
        if (g[v][cnt].first == p)
            cnt++;
        int nw = curr;
        for(pii j:i.second){
            if(j.second >= 0)
                nw = nw * 1ll * binpow(binpow(j.first, j.second), mod - 2) % mod;
            else
                nw = nw * 1ll * binpow(j.first, -j.second) % mod;
        }
        sum += i.first * 1ll * nw % mod;
        if (sum >= mod)
            sum -= mod;
    }
    sum += curr;
    if (sum >= mod)
        sum -= mod;
    return make_pair(sum, cur);
}

int gcd(int a, int b) {
    return (b ? gcd(b, a % b) : a);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        g[i].clear();
    for (int i = 0; i < n - 1; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--;
        int g = gcd(c, d);
        c /= g;
        d /= g;
        ::g[a].push_back(make_pair(b, make_pair(c, d)));
        ::g[b].push_back(make_pair(a, make_pair(d, c)));
    }
    cout << dfs(0).first << endl;
}

signed main(){
    for (int i = 0; i < maxn; i++)
        abc[i] = -1;
    for (int i = 2; i < maxn; i++) {
        if (abc[i] == -1) {
            abc[i] = i;
            for (int j = i * 2; j < maxn; j += i)
                if(abc[j] == -1)
                    abc[j] = i;
        }
    }
    int q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}
