#include <bits/stdc++.h>

using namespace std;

const int N = 110000;
const int C = 330;

int n;
int a[N];

int solve_small() {
	static int cnt[2 * N * C];
	int res = 1;
	for (int d = -C; d <= C; ++d) {
		for (int i = 0; i < n; ++i) {
			res = max(res, ++cnt[N * C + a[i] - i * d]);
		}
		for (int i = 0; i < n; ++i) {
			cnt[N * C + a[i] - i * d] = 0;
		}
	}
	return res;
}	

int solve_large() {
	static int cnt[2 * N];
	int res = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j <= min(n - 1, i + C); ++j) {
			int d = (a[j] - a[i]) / (j - i);
			if (d * (j - i) == a[j] - a[i]) {
				res = max(res, ++cnt[N + d] + 1);
			}
		}
		for (int j = i + 1; j <= min(n - 1, i + C); ++j) {
			int d = (a[j] - a[i]) / (j - i);
			if (d * (j - i) == a[j] - a[i]) {
				cnt[N + d] = 0;
			}
		}
	}
	return res;
}	

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	int mx = solve_small();

	mx = max(mx, solve_large());

	cout << n - mx << "\n";
	return 0;
}