#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(time(0));

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(a, b) cout << #a << " = " << a << ", " << #b << " = " << b << endl;
#define trace3(a, b, x) cout << #a << " = " << a << ", " << #b << " = " << b << ", " << #x << " = " << x << endl;
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

void fast_stream() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

template <typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void solve() {
    string s;
    cin >> s;

    vector<ll> pos(26, s.size());
    for (ll i = 0; i < s.size(); ++i) {
        pos[s[i] - 'a'] = i;
    }

    ll ind = s.size();

    for (auto i : pos) ind = min(ind, i);

    for (ll i = ind; i < s.size(); ++i) cout << s[i];
    cout << '\n';
}

signed main() {
    fast_stream();

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}