#include <bits/stdc++.h>

#define F first
#define S second
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;

template<class T> bool ckmin(T &a, T b) { return a > b ? a = b, true : false; }
template<class T> bool ckmax(T &a, T b) { return a < b ? a = b, true : false; }

int solve_small(int n, vector<int> &a, int q) {
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        b[i] = a[i] - (ll)q*i;
    }
    sort(all(b));
    int cnt = 1, res = n;
    for (int i = 1; i < n; ++i) {
        if (b[i] == b[i-1]) cnt++;
        else {
            ckmin(res, n-cnt);
            cnt = 1;
        }
    }
    ckmin(res, n-cnt);
    return res;
}

void solve() {
    int n; cin >> n;
    vector<int> a(n); for (auto &x : a) cin >> x;
    int ans = n, q = 0;
    for ( ; (ll)q*q <= 200000; ++q) {
        ckmin(ans, solve_small(n, a, q));
        ckmin(ans, solve_small(n, a, -q));
    }
    for (int i = 0; i < n; ++i) {
        vector<int> b;
        for (int j = 1; j <= q && i+j < n; ++j) {
            if (abs(a[i]-a[i+j])%j == 0) {
                b.push_back((a[i]-a[i+j])/j);
            }
        }
        sort(all(b));
        int cnt = 1, res = n;
        for (int i = 1; i < b.size(); ++i) {
            if (b[i] == b[i-1]) cnt++;
            else ckmin(res, n-cnt), cnt = 1;
        }
        ckmin(res, n-cnt);
        ckmin(ans, res-1);
    }
    cout << max(0, ans) << "\n";
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t = 1; solve();
    return 0;
}